Package: biostat3
Type: Package
Title: Utility Functions, Datasets and Extended Examples for Survival
        Analysis
Version: 0.1.9
Date: 2023-10-27
Authors@R: c(person("Annika","Tillander", role="ctb"),
	  person("Andreas","Karlsson", role="aut"),
	  person("Johan","Zetterqvist", role="ctb"),
	  person("Peter","Strom", role="ctb"),
	  person("Benedicte","Delcoigne", role="ctb"),
	  person("Mark","Clements", role=c("aut","cre"), email="mark.clements@ki.se")
	  )
Description: Utility functions, datasets and extended examples for survival analysis. This extends a range of other packages, some simple wrappers for time-to-event analyses, datasets, and extensive examples in HTML with R scripts. The package also supports the course Biostatistics III entitled "Survival analysis for epidemiologists in R".
Depends: survival, R (>= 3.5), MASS, methods
Imports: muhaz, graphics, stats
Suggests: car, bshazard, rstpm2, Epi, dplyr
License: GPL (>= 2)
LazyData: yes
LazyLoad: yes
NeedsCompilation: no
Packaged: 2023-10-27 09:21:58 UTC; marcle
Author: Annika Tillander [ctb],
  Andreas Karlsson [aut],
  Johan Zetterqvist [ctb],
  Peter Strom [ctb],
  Benedicte Delcoigne [ctb],
  Mark Clements [aut, cre]
Maintainer: Mark Clements <mark.clements@ki.se>
Repository: CRAN
Date/Publication: 2023-10-27 10:10:06 UTC
Built: R 4.2.0; ; 2023-10-27 12:06:46 UTC; unix

exportPattern("^[[:alpha:]]+") # export names that start with a letter 

import(survival)
import(methods)
import(MASS)
## importFrom(muhaz, muhaz, plot.muhaz, lines.muhaz)
## importFrom(car, linearHypothesis)
importFrom(graphics, lines, plot, matlines, matplot, plot.default,
           points)
importFrom(stats, model.extract, terms, qnorm, approx,
           profile, fitted, qt, spline, coef, confint,
           predict, qgamma)
importFrom("utils", "modifyList")

## importFrom(KMsurv,lifetab)
## importFrom(MASS, confint, profile)

S3method(as.data.frame,bshazard)
S3method(as.data.frame,muhaz)
S3method(as.data.frame,muhazList)
## S3method(confint,glm)
## S3method(confint, profile.glm)
S3method(eform,default)
S3method(lines,coxphHazList)
S3method(lines,muhaz2)
S3method(lines,muhazList)
S3method(plot,coxphHaz)
S3method(plot,coxphHazList)
S3method(as.data.frame,coxphHaz)
S3method(as.data.frame,coxphHazList)
S3method(plot,muhaz2)
S3method(plot,muhazList)
S3method(plot,smoothHaz)
S3method(print,coxphHaz)
S3method(summary,muhazList)
S3method(plot,lifetab2)
S3method(lines,lifetab2)
S3method(points,lifetab2)

## S3method(ggplot,muhazList)

###############################################################################
## Exercise 28 (Modelling cause-specific mortality)
## Flexible parametric models (fpm) implemented in Stata (stpm2) and R (rstpm2)
## One difference: Restricted cubic splines
##                 using truncated power basis (stpm2, Stata)
##                 using B-spline basis (rstpm2, R)
## R codes suggested by Xing-Rong Liu and Mark Clements (2016-03-06)
## For more detail interpretation, please see solutions_biostat3_2016.pdf file
###############################################################################

## @knitr loadDependencies
library(biostat3)  
library(rstpm2)  # for the flexible parametric model
library(dplyr)   # for data manipulation
library(ggplot2)

## @knitr loadPreprocess
data(melanoma)

## Extract subset and create 0/1 outcome variables
melanoma0 <- biostat3::melanoma %>% filter(stage=="Localised") %>%
             mutate(event = ifelse(status=="Dead: cancer" & surv_mm<120, 1, 0),
                    time = pmin(120, surv_mm)/12,
                    agegrp1 = (agegrp=="0-44")+0,  # used by time-dependent effect
                    agegrp2 = (agegrp=="45-59")+0, # used by time-dependent effect
                    agegrp3 = (agegrp=="60-74")+0, # used by time-dependent effect
                    agegrp4 = (agegrp=="75+")+0)   # used by time-dependent effect

## @knitr a_flex
## (a) Flexible parametric model with df=4
fpma <- stpm2(Surv(time,event) ~ year8594, data=melanoma0, df=4)
summary(fpma)
eform(fpma)["year8594Diagnosed 85-94",]

## @knitr a_cox
cox <- coxph(Surv(time, event) ~ year8594,
             data=melanoma0) # year8594 is a categorical variable
summary(cox)

## @knitr b_surv
## (b) Prediction and plots of survival and hazard by calendar period
years <- levels(melanoma0$year8594)

s <- predict(fpma,newdata=data.frame(year8594=years),grid=TRUE,full=TRUE,se.fit=TRUE,
             type="surv")
head(s)
ggplot(s, aes(x=time,y=Estimate,fill=year8594,ymin=lower,ymax=upper)) +
    xlab("Time since diagnosis (years)") +
    ylab("Survival") +
    geom_ribbon(alpha=0.6) +
    geom_line()

## @knitr b_haz
plot(fpma,newdata=data.frame(year8594=years[1]), type="haz",
     xlab="Time since diagnosis (years)", ylab="Hazard")
lines(fpma,newdata=data.frame(year8594=years[2]), type="haz", col=2)
legend("topright", legend=years, col=1:2, lty=1, bty="n")


## @knitr c_haz_log
## (c) hazards on log scale, adding log="y"
plot(fpma,newdata=data.frame(year8594=years[1]), type="haz",
     xlab="Time since diagnosis (years)",
     ci=FALSE,
     ylab="Hazard (log scale)",main=years[1], log="y", ylim=c(0.01,0.07))
lines(fpma,newdata=data.frame(year8594=years[2]), type="haz", col=2)
legend("topright", legend=years, col=1:2, lty=1, bty="n")

## @knitr d_AIC_BIC
## utility function to row bind from a list
Rbind <- function(object) do.call(rbind,object)
out <- lapply(1:6, function(i) {
    fitaic <- stpm2(Surv(time, event) ~ year8594, data=melanoma0, df=i)
    data.frame(
        i,
        AIC=AIC(fitaic),
        BIC=BIC(fitaic),
        beta=as.numeric(coef(fitaic)[2]),
        se=coef(summary(fitaic))[2,2])
})
out %>% Rbind

## @knitr e_base_surv
## Baseline survival
fitaic0 <- stpm2(Surv(time, event) ~ year8594, data=melanoma0, df=6)
plot(fitaic0,newdata=data.frame(year8594=years[1]), lty=6, ci=FALSE,
     xlab="Time since diagnosis (years)")
for (i in 1:5 ) {
  fitaic <- stpm2(Surv(time, event) ~ year8594, data=melanoma0, df=i)
  lines(fitaic,newdata=data.frame(year8594=years[1]), lty=i)
}
legend("topright", legend=paste0("df=",1:6), lty=1:6)

## @knitr e_base_haz
## Baseline hazard
fitaic1 <- stpm2(Surv(time, event) ~ year8594, data=melanoma0, df=6)
plot(fitaic1,newdata=data.frame(year8594=years[1]), lty=6, type="haz",
     ci=FALSE, xlab="Time since diagnosis (years)", ylab="Hazard")
for (i in 1:5 ) {
  fitaic <- stpm2(Surv(time, event) ~ year8594, data=melanoma0, df=i)
  lines(fitaic,type="haz",newdata=data.frame(year8594=years[1]), lty=i)
}
legend("topright", legend=paste0("df=",1:6), lty=1:6)

## @knitr f_sex_age
fpmf <- stpm2(Surv(time, event) ~ sex + year8594 + agegrp,
              data=melanoma0, df=4)
summary(fpmf)
eform(fpmf)[2:6,]

## To test the overall effect of age with LR test
fpmf2 <- stpm2(Surv(time,event) ~ sex + year8594, data=melanoma0, df=4)
anova(fpmf, fpmf2)


## @knitr g_sex_age
summary(fit <- coxph(Surv(time, event) ~ sex + year8594 + agegrp,
                     data=melanoma0))
anova(fit)

## @knitr h_time_varying
## (h) Change to time-varying effect of agegrp2:4
## NB: including main effect of agegrp
fpmh <- stpm2(Surv(time,event) ~ sex + year8594 + agegrp2 + agegrp3 + agegrp4,
              data=melanoma0, tvc=list(agegrp2 = 2, agegrp3 = 2, agegrp4 = 2),
              df=4)
summary(fpmh)

## LR test comparing fpmh (non-PH for agegrp2:4) with fpmf(PH for agegrp2:4)
anova(fpmh, fpmf)

## @knitr h_time_varying_penalised
## I investigated the non-proportional effect of age with penalized models
## here, sp is the optimal smoothing parameters estimated from models without sp argument
pfit0 <- pstpm2(Surv(time,event) ~ sex + year8594 + agegrp,
                data=melanoma0, sp=0.1359685)

## The time-dependent effects including linear forms of age groups
pfit1 <- pstpm2(Surv(time,event) ~ sex + year8594 + agegrp2 + agegrp3 + agegrp4,
                tvc=list(agegrp2=7,agegrp3=7,agegrp4=7),
                data=melanoma0, sp=c( 0.1429949, 1.6133966, 1.3183117, 1.9958815))
anova(pfit1, pfit0)## the results also suggest there is strong evidence

## @knitr i_plot_base_haz
## Plot of baseline hazard with fpmh
sexes <- levels(melanoma$sex)
years <- levels(melanoma$year8594)
agegrps <- levels(melanoma$agegrp)
newdata1 <- data.frame(sex=sexes[1],year8594=years[1],agegrp2=0, agegrp3=0, agegrp4=0)
plot(fpmh, newdata=newdata1, xlab="Time since diagnosis (years)", 
     type="haz")

## @knitr j_age_HR
plot(fpmh, newdata=newdata1, xlab="Time since diagnosis (years)",
     type="hr",var="agegrp2", ci=FALSE, ylim=c(0,6))
lines(fpmh, newdata=newdata1, type="hr", var="agegrp3", lty=2)
lines(fpmh, newdata=newdata1, type="hr", var="agegrp4", lty=3)
legend("topright", legend=paste0(agegrps[-1]," vs 0-44"), lty=1:3)

## @knitr j_oldest
plot(fpmh, newdata=newdata1,
     type="hr", log="y",
     exposed=function(data) transform(data,agegrp4=agegrp4+1), # same as var="agegrp4"
     xlab="Time since diagnosis (years)")

## @knitr j_age_HR_ggplot
pred <- lapply(2:4, function(i)
    predict(fpmh, newdata=newdata1, type="hr",var=paste0("agegrp",i),
            grid=TRUE, se.fit=TRUE, full=TRUE) %>%
    mutate(ageGroup=paste0(agegrps[i]," vs 0-44")))
pred <- Rbind(pred)
ggplot(pred, aes(x=time,y=Estimate,fill=ageGroup,ymin=lower,ymax=upper)) +
    geom_ribbon(alpha=0.3) +
    geom_line() +
    ylim(0,8) +
    xlab("Time since diagnosis (years)") +
    ylab("Hazard ratio") +
    labs(fill="Age group")

## @knitr k_haz_diff
plot(fpmh,newdata=newdata1,
     type="hdiff", var="agegrp4",
     xlab="Time since diagnosis (years)")

## @knitr l_surv_diff
plot(fpmh,newdata=newdata1,
     type="sdiff", var="agegrp4",
     xlab="Time since diagnosis (years)")

## @knitr m_time_dep_eff
out <- lapply(1:3, function(i) {
    fitdf <- stpm2(Surv(time,event) ~ sex + year8594 + agegrp2 + agegrp3 + agegrp4,
                   data=melanoma0, tvc=list(agegrp2 = i, agegrp3 = i, agegrp4 = i),
                   df=4)
    data.frame(i,
               aic=AIC(fitdf),
               bic=BIC(fitdf))
}) 
out %>% Rbind

## Plots with different df
fitdf1 <- stpm2(Surv(time,event) ~ sex + year8594 + agegrp2 + agegrp3 + agegrp4, data=melanoma0,
                tvc = list(agegrp2 = 1, agegrp3 = 1, agegrp4 = 1), df=4)

plot(fitdf1, newdata = newdata1,
     type="hr", ci=FALSE, log="y", var="agegrp4",
     xlab="Time since diagnosis (years)")
for (i in 2:3 ) {
    fitdf <- stpm2(Surv(time,event) ~ sex + year8594 + agegrp2 + agegrp3 + agegrp4,
                   data=melanoma0, tvc=list(agegrp2 = i, agegrp3 = i, agegrp4 = i),
                   df=4)
    lines(fitdf, newdata=newdata1,
          type="hr", lty=i,
          var="agegrp4")
}
legend("topright", legend=c("1 df", "2 df", "3 df"), lty=1:3)

## Purpose: To do the solution for Biostat III exercises in R
## Author: Andreas Karlsson, 2015-03-02
## Revised: Mark Clements, 2017-11-03
###############################################################################

## Install needed packages only need to be done once
## install.packages("survival")


###############################################################################
## Exercise 12
###############################################################################
## @knitr loadDependencies
library(biostat3) 


## @knitr loadPreprocess
melanoma.l <- transform(biostat3::melanoma,
                      death_cancer = ifelse( status == "Dead: cancer", 1, 0))


## @knitr 12.a

# Cox regression with time-since-entry as the timescale
# Note that R uses the Efron method for approximating the likelihood in the presence of ties,
# whereas Stata (and some other software) uses the Breslow method
cox1 <- coxph(Surv(surv_mm, death_cancer) ~ sex, data=melanoma.l)
summary(cox1)


## @knitr 12.b
cox2 <- coxph(Surv(surv_mm, death_cancer) ~ sex + agegrp + stage + subsite + year8594, data=melanoma.l)
summary(cox2)


## @knitr 12.c
cox3 <- coxph(Surv(surv_mm, death_cancer) ~ agegrp + agegrp * sex, data=melanoma.l)
summary(cox3)


## @knitr 12.d.i
cox4 <- coxph(Surv(surv_mm, death_cancer) ~ sex + year8594 + agegrp + subsite + stage, data=melanoma.l)
summary(cox4)

## Test proportional hazards assumption
cox.zph(cox4, transform="log") 
cox.zph(cox4, transform="identity") # Stata default

## @knitr 12.d.ii
## Stratified Cox model; separate baseline hazard functions are fit for each strata.
cox5 <- coxph(Surv(surv_mm, death_cancer) ~ sex + year8594 + agegrp + subsite + strata(stage), data=melanoma.l)
summary(cox5)

## Test proportional hazards assumption
cox.zph(cox5, transform="log") 
cox.zph(cox5, transform="identity") 

## @knitr 12.d.iii
cox5 <- coxph(Surv(surv_mm, death_cancer) ~ sex * agegrp + year8594 + agegrp + subsite + strata(stage), data=melanoma.l)
summary(cox5)
anova(cox5)

## Purpose: To do the solution for Biostat III exercises in R
## Author: Andreas Karlsson, 2015-03-02
## Revised: Mark Clements, 2017-11-03
###############################################################################

## Install needed packages only need to be done once
## install.packages("foreign")
## install.packages("survival")
## install.packages("dplyr")


###############################################################################
## Exercise 22
###############################################################################
## @knitr loadDependencies
library(biostat3) # for Surv and survfit
library(dplyr)    # for data manipulation
library(rstpm2)

## @knitr loadPreprocess


## @knitr 22.a
head(brv)

##Look at the five first couples
brv %>% select(couple, id, sex, doe, dosp, dox, fail) %>% filter(couple<=5) %>% arrange(couple, id)


## @knitr 22.b
brv <- mutate(brv, age_entry = as.numeric(doe - dob) / 365.24, # Calc age at entry
           att_age = as.numeric(dox - dob) / 365.24,   # Calc attained age
           t_at_risk = att_age - age_entry)            # Calc time at risk

## crude rates
survRate(Surv(age_entry, att_age, fail) ~ sex, data=brv)

poisson22b <- glm( fail ~ sex + offset( log( t_at_risk) ), family=poisson, data=brv)
summary( poisson22b )
eform(poisson22b)

select(brv, sex, age_entry) %>%
    group_by(sex) %>%
    summarise(meanAgeAtEntry = mean(age_entry))

## @knitr 22.c

## Creating times relativ to spouse death (year=0)
brv2 <- mutate(brv,
               id=NULL,
               y_before_sp_dth =  as.numeric(doe -dosp) / 365.24,
               y_after_sp_dth = as.numeric(dox - dosp) / 365.24)

## Splitting at spouse death (year=0)
brvSplit <- survSplit(brv2, cut = 0, end="y_after_sp_dth", start="y_before_sp_dth", id="id",event="fail")

## Calculating risk times
brvSplit <- mutate(brvSplit,
                   t_sp_at_risk =   y_after_sp_dth - y_before_sp_dth,
                   brv = ifelse(y_after_sp_dth > 0, 1, 0))

## Look at the five first couples
brvSplit %>% select(couple, id, sex, doe, dosp, dox, fail, y_before_sp_dth, y_after_sp_dth, t_sp_at_risk) %>% filter(couple<=5) %>% arrange(couple, id)

## @knitr 22.d
poisson22d <- glm( fail ~ brv + offset( log(t_sp_at_risk) ), family=poisson, data=brvSplit)
summary(poisson22d)
eform(poisson22d)

## @knitr 22.e
## Poisson regression for sex==1
poisson22e1 <- glm( fail ~ brv + offset( log(t_sp_at_risk) ), family=poisson, data=filter(brvSplit, sex==1))
summary(poisson22e1)
eform(poisson22e1)

## Poisson regression for sex==2
poisson22e2 <- glm( fail ~ brv + offset( log(t_sp_at_risk) ), family=poisson, data=filter(brvSplit, sex==2))
summary(poisson22e2)
eform(poisson22e2)

## Poisson regression, interaction with sex
brvSplit2 <- mutate(brvSplit,
                    sex = as.factor(sex),
                    brv = as.factor(brv))
poisson22e3 <- glm( fail ~ sex + brv:sex + offset( log(t_sp_at_risk) ), family=poisson, data=brvSplit2)
summary(poisson22e3)
eform(poisson22e3)

## @knitr 22.f
## Translate time scale from years from spouse death to ages
brvSplit3 <- brvSplit2 %>%
    mutate(age_sp_dth =  as.numeric(dosp - dob) / 365.24, # Age at spouse death
           age_start = age_sp_dth + y_before_sp_dth,      # Age at start of timeband
           age_end = age_sp_dth + y_after_sp_dth)         # Age at end of timeband

age_cat <- seq(70,100,5) # Split at these ages
brvSplit4 <- survSplit(brvSplit3, cut=age_cat, start="age_start", end="age_end", event="fail", zero = 0)

brvSplit4 <- mutate(brvSplit4,
                    t_at_risk = age_end- age_start, # Creating new time at risk
                    age = cut(age_end, age_cat))   # Creating age band category

## Calculate crude rates
survRate(Surv(t_at_risk, fail) ~ age, data=brvSplit4)

poisson22f1 <- glm( fail ~ brv + age + offset( log(t_at_risk) ), family=poisson, data=brvSplit4)
summary(poisson22f1)
eform(poisson22f1)

poisson22f2 <- glm( fail ~ brv +age + sex + offset( log(t_at_risk) ), family=poisson, data=brvSplit4)
summary(poisson22f2)
eform(poisson22f2)

## @knitr 22.g
poisson22g <- glm( fail ~ age + sex + brv:sex + offset( log(t_at_risk) ), family=poisson, data=brvSplit4)
summary(poisson22g)
eform(poisson22g)

## @knitr 22.i
summary(coxph(Surv(age_start, age_end, fail) ~ brv,
              data = brvSplit4))


summary(coxph(Surv(age_start, age_end, fail) ~ brv + sex,
              data = brvSplit4))

## @knitr 22.j
summary(coxph(Surv(age_start, age_end, fail) ~ sex + sex:brv,
              data = brvSplit4))

## Purpose: Solution for Biostat III exercises in R
## Author: Mark Clements, 2017-11-03
###############################################################################

## Install needed packages only need to be done once
## install.packages("foreign")
## install.packages("survival")
## install.packages("dplyr")


###############################################################################
## Exercise 23
###############################################################################
## @knitr loadDependencies
library(biostat3) # for Surv and survfit
library(dplyr)    # for data manipulation


## @knitr loadPreprocess

## @knitr 23.a1
data(melanoma) 
mel <- filter(melanoma, stage == "Localised") %>% 
        mutate( dead = (status %in% c("Dead: cancer","Dead: other") & surv_mm <= 120)+0, 
                surv_mm = pmin(120, surv_mm)
              ) 
head(mel) 

## @knitr 23.a2
## Define the age at start and end of follow-up 
mel <- mutate( mel, adx = age+0.5,   # age at diagnosis  (mid-point approximation) 
               astart = adx, 
               astop  = adx+surv_mm/12 
              )
## Split by age 
mel.split <- survSplit(mel, cut = 1:105, event = "dead", 
                       start = "astart", end = "astop")
## Quick check: the first two ids 
subset(mel.split, id<=2, select = c(id, astart, astop, dead)) 

## @knitr 23.b1
# For each age time band from (a), we calculate the start and stop in calendar time 
# We calculate the time since diagnosis as difference between age at start/stop and 
# age at diagnosis, and add that interval to year at diagnosis
mel.split2 <- mutate(mel.split, 
                    ystart = ydx + astart - adx, 
                    ystop  = ydx + astop - adx
                  )
subset(mel.split2, id<=2, select = c(id, adx, astart,astop,dead, ydx, ystart, ystop))

## @knitr 23.b2
## Now we can split along the calendar time 
## For each of the new age-calendar time bands, we now have to adjust the age at 
## start and end in the same way as above 
mel.split2 <- survSplit( mel.split2, cut = 1970:2000, event = "dead", 
                         start = "ystart", end = "ystop" ) %>%
              mutate( astart = adx + ystart - ydx, 
                      astop  = adx + ystop - ydx
                    )
## Quick check: this seems ok 
subset(mel.split2, id<=2, select = c(id, ystart, ystop, astart, astop, dead)) 

## @knitr 23.c1
## We calculate the total person time at risk for each time band
mel.split2 <- mutate( mel.split2, 
                      age  = floor(astart),  # Age at which person time was observed 
                      year = floor(ystart),  # Calendar year during which person time was observed 
                      pt  =  ystop - ystart  # ... or astop - astart, works the same
                    ) 
subset(mel.split2, id<=2, select = c(id, ystart, ystop, astart, astop, dead, age, year, pt))

## @knitr 23.c2
## Now tabulate: sum of person time across all combinations of age & year 
## (for some years, ages) 
xtabs(pt ~ age + year, data=mel.split2, subset = age>=50 & age<60 & year>=1980 & year<1990)

## @knitr 23.c3
## Same: sum up 0/1 alive/dead for total count of deaths 
xtabs(dead ~ age + year, data=mel.split2, subset = age>=50 & age<60 & year>=1980 & year<1990) 

## @knitr 23.d
mel.split2 <- mutate(mel.split2, 
                     age10  = cut(age, seq(0, 110 ,by=10), right=FALSE), 
                     year10 = cut(year, seq(1970, 2000, by=5), right=FALSE) 
                    ) 
sr <- survRate(Surv(pt, dead) ~ sex + age10 + year10, data=mel.split2) 
rownames(sr) <-1:nrow(sr) ## Simple rownames for display 
head(sr, n = 20) 

## @knitr 23.e1
pt <- mutate(mel.split2, sex = unclass(sex)) %>%    # make sex integer to be in line with popmort 
      group_by(sex, age, year)               %>%    # aggregate by sex, age, year 
      summarise(pt = sum(pt), observed = sum(dead)) # sum the person time, deaths 
pt <- ungroup(pt)  # For convenience
head(pt) 

## @knitr 23.e2
head(rstpm2::popmort)
summary(rstpm2::popmort) 

## @knitr 23.e3
joint <- left_join(pt, rstpm2::popmort)
head(joint) 

## @knitr 23.e4
joint <- mutate(joint, expected = pt * rate) 
head(joint) 


## @knitr 23.f1
SMR_all <- summarise(joint, SMR = sum(observed) / sum(expected) ) 
SMR_all 

## @knitr 23.f2
SMR_bySex <- group_by(joint, sex) %>% summarise( SMR = sum(observed) / sum(expected) ) 
SMR_bySex 

## @knitr 23.f3
SMR_byYear <- group_by(joint, year) %>% summarise( SMR = sum(observed) / sum(expected) ) 
SMR_byYear 
plot( SMR_byYear, type = "o")  # quick & dirty plot 

## @knitr 23.f4
joint <- mutate(joint, age_group = cut(age, seq(0, 110, by=10), right = FALSE))
SMR_byAge <- group_by(joint, age_group) %>% summarise( SMR = sum(observed) / sum(expected) ) 
SMR_byAge 
plot( SMR_byAge)           # quick & dirty plot 
abline( h = 1:2, lty = 2)  # two reference lines at 1 & 2

## @knitr 23.f5
by(joint, joint$sex, function(data) poisson.test(sum(data$observed), sum(data$expected)))


## @knitr 23.g1
joint2 <- transform(joint,
                    sex  = factor(sex, levels = 1:2, labels = c("m", "f")),
                    year =  factor(year) %>% relevel(ref = "1985"),  # mid-study
                    age_group = relevel(age_group, ref = "[70,80)")  # Close to one already
                   )
## Model & parameters
summary(fit <- glm(observed ~ sex + year + age_group + offset(log(expected)), data=joint2, family=poisson)) 
eform(fit)

## @knitr 23.g2
drop1(fit, test = "Chisq")

## https://stackoverflow.com/questions/10959521/how-to-write-to-clipboard-on-ubuntu-linux-in-r
clipboard <- function(x, sep="\t", row.names=FALSE, col.names=TRUE){
     con <- pipe("xclip -selection clipboard -i", open="w")
     write.table(x, con, sep=sep, row.names=row.names, col.names=col.names)
     close(con)
}
library(biostat3)
clipboard(colon_sample)

library(foreign)
getData <- function(name) {
    assign(name,read.dta(sprintf("http://biostat3.net/download/%s.dta",name)))
    ## save(list=name,file=sprintf("~/src/R/biostat3/data/%s.rda",name))
    ## prompt(name=name,file=sprintf("~/src/R/biostat3/man/%s.Rd",name))
}
getData("melanoma")
getData("colon")
getData("brv")
getData("colon_sample")
getData("diet")
getData("popmort")

year <- function(date) as.numeric(format(as.Date(date),"%Y"))
dmy <- function(day,month,year)
  as.Date(paste(year,month,day,sep="-"), "%Y-%m-%d")
Date2year <- function(date) {
    y <- year(date)
    len <- as.numeric(dmy(31,12,y)-dmy(1,1,y))+1
    y + as.numeric(date-dmy(1,1,y))/len
}
year2Date <- function(year) {
    y <- floor(year)
    len <- as.numeric(dmy(31,12,y)-dmy(1,1,y))+1
    dmy(1,1,y) + (year-y)*len
}
## Date2year(as.Date("2015-07-01"))
## year2Date(Date2year(as.Date("2011-12-31")))
## year2Date(Date2year(as.Date("2012-12-31"))) # leap-year

set.seed(12345)
colon <-
    transform(colon,
              id=1:nrow(colon),
              ydx=Date2year(dx),
              yexit=Date2year(exit),
              bdate=year2Date(Date2year(dx)-(age+runif(nrow(colon)))))
colon <- transform(colon, ybdate = Date2year(bdate))
melanoma <-
    transform(melanoma,
              id=1:nrow(melanoma),
              ydx=Date2year(date = dx),
              yexit=Date2year(exit),
              bdate=year2Date(Date2year(dx)-(age+runif(nrow(melanoma)))))
melanoma <- transform(melanoma, ybdate = Date2year(bdate))
diet <- transform(diet, yob=Date2year(dob), yoe=Date2year(doe), yox=Date2year(dox))

save(colon_sample, file="~/src/R/biostat3/data/colon_sample.rda", version=2, compress='xz')
save(popmort, file="~/src/R/biostat3/data/popmort.rda", version=2, compress='xz')
save(diet, file="~/src/R/biostat3/data/diet.rda", version=2, compress='xz')
save(melanoma, file="~/src/R/biostat3/data/melanoma.rda", version=2, compress='xz')
save(brv, file="~/src/R/biostat3/data/brv.rda", version=2, compress='xz')
save(colon, file="~/src/R/biostat3/data/colon.rda", version=2, compress='xz')

library(rmarkdown)
library(prettydoc)
setwd("~/src/R/biostat3/inst/doc")

files <- paste0("q", c(1:4,6:14,22,23,25,28),".Rmd")
## files <- paste0("q", c(14),".Rmd")

rmarkdown::render("index.Rmd", html_pretty())

setwd("labs")
for (file in files) {
    rmarkdown::render(file, html_pretty())
}
rmarkdown::render("installation.Rmd", html_pretty())
setwd("..")

setwd("solutions")
for (file in files) {
    rmarkdown::render(file, html_pretty())
}
setwd("..")



## setwd("~/src/R/biostat3/inst/doc/solutions")
## rmarkdown::render("q2.Rmd", "html_document")

## Purpose: To do the solution for the Biostat III exercise 13 in R
## Author: Johan Zetterqvist, 2015-03-04
## Revised: Mark Clements, 2017-11-03
###############################################################################

## ## Install needed packages only need to be done once
## Install needed packages only need to be done once
## install.packages("foreign")

###############################################################################
## Exercise 13
###############################################################################
## @knitr loadDependencies
library(biostat3) # for Surv and survfit

## @knitr loadPreprocess


## @knitr 13.a
## y is the observed time
## so it already measures time since entry
poisson13a <- glm(chd ~ hieng + offset(log(y)), family=poisson, data=diet)
summary(poisson13a)
eform(poisson13a)

cox13a <- coxph(Surv(y, chd) ~ hieng, data=diet)
summary(cox13a)

## @knitr 13.b

## counting process data with coxph
scale <- 365.24
cox13b <- coxph(Surv((doe-dob)/scale, (dox-dob)/scale, chd) ~ hieng, data=diet)
summary(cox13b)

## Purpose: To do the solution for Biostat III exercises in R
## Author: Benedicte Delcoigne, 2014-03-05
## Revised: Mark Clements, 2017-11-03
###############################################################################

###############################################################################
## Exercise 25
###############################################################################

## @knitr loadDependencies
library(biostat3) # cox and conditional logistic analyses
library(Epi)      # sample a nested case-control study from a cohort

## @knitr loadPreprocess
## Get the data for exercise 25 and have a look at it
mel <- subset(biostat3::melanoma, stage=="Localised") |>
    transform(dc = (status=="Dead: cancer" & surv_mm<120)+0,
              surv_10y = pmin(120, surv_mm))
with(mel,table(dc, status))

## @knitr ex_25_coxph
str(subset(mel, select=c(sex,year8594,agegrp))) # Check structure of risk factors/confounders
out_coh <- coxph(Surv(surv_10y,dc) ~ sex + year8594 + agegrp, data = mel)
summary(out_coh)


## @knitr n_ind
print(n_ind <- length(mel$id))

## @knitr n_event
table(mel$dc, useNA="always")
print(ncase <-  table (mel$dc, useNA="always")[2])

## @knitr gen_ncc
set.seed(12345)
nccdata <- ccwc(entry=0, exit=surv_10y , fail=dc, origin=0, controls=1,
                include=list(sex,year8594,agegrp,dc,id), data=mel)
tail(nccdata, 8) |> kable("html")


## @knitr clogit
out_ncc <- clogit(Fail ~ sex + year8594 + agegrp + strata(Set), data=nccdata)
summary(out_ncc)


## @knitr n_unique_ncc
print(n_uni <- length(unique(nccdata$id)))
n_uni

## @knitr compare_coh_ncc
library(broom)
cat("Full cohort:\n")
print(tidy_coh <- tidy(out_coh, conf.int=TRUE, exponentiate=TRUE))
cat("Nested case-control study:\n")
print(tidy_ncc <- tidy(out_ncc, conf.int=TRUE, exponentiate=TRUE))
tibble(term = tidy_coh$term, variance.ratio = (tidy_ncc$std.error/tidy_coh$std.error)^2)

tidy_coh <- tidy(out_coh)
tidy_ncc <- tidy(out_ncc)
f <- function(x,mu,sigma) {
    mu=as.numeric(mu)
    sigma=as.numeric(sigma)
    xp=exp(mu+x*sigma)
    cbind(x=xp,y=dlnorm(xp,mu,sigma))
}
x <- seq(-4,4,length=301)
par(mfrow=c(2,3))
for (i in 1:5) {
    f_coh = f(x,tidy_coh[i,"estimate"], tidy_coh[i,"std.error"])
    f_ncc = f(x,tidy_ncc[i,"estimate"], tidy_ncc[i,"std.error"])
    plot(rbind(f_coh,f_ncc), type="n", xlab="Hazard ratio", ylab="Density",
         main=as.character(tidy_coh$term[i]))
    polygon(f_coh,
            col=alpha("green",0.2), border=alpha("green",0.2))
    polygon(f_ncc,
            col=alpha("blue",0.2), border=alpha("blue",0.2))
}
legend("topright", c("Cohort","NCC"), col=c(alpha("green",0.2),alpha("blue",0.2)), lwd=5,
       bty="n")

## @knitr loop_ncc
set.seed(54321)
M <- 20
tidys_ncc <- lapply(1:M, function(i)
    ccwc(entry=0, exit=surv_10y , fail=dc, origin=0, controls=1,
         include=list(sex,year8594,agegrp), data=mel, silent=TRUE) |>
    clogit(formula = Fail ~ sex + year8594 + agegrp + strata(Set)) |> 
    suppressWarnings() |> tidy())
tidy_coh <- tidy(out_coh)
f <- function(x,mu,sigma) {
    mu=as.numeric(mu)
    sigma=as.numeric(sigma)
    xp=exp(mu+x*sigma)
    cbind(x=xp,y=dlnorm(xp,mu,sigma))
}
x <- seq(-4,4,length=301)
par(mfrow=c(2,3))
for (i in 1:5) {
    f_coh = f(x,tidy_coh[i,"estimate"], tidy_coh[i,"std.error"])
    f_ncc = lapply(tidys_ncc, function(object) 
        f(x,object[i,"estimate"], object[i,"std.error"]))
    plot(do.call(what=rbind,c(list(f_coh),f_ncc)), type="n", xlab="Hazard ratio", ylab="Density",
         main=as.character(tidy_coh$term[i]))
    for (j in 1:length(tidys_ncc))
        polygon(f_ncc[[j]],
                col=alpha("blue",0.02), border=alpha("blue",0.02))
    polygon(f_coh,
            col=alpha("green",0.2), border=alpha("green",0.2))
}
plot(0:1,0:1,type="n",axes=FALSE, xlab="",ylab="")
legend("center", c("Cohort","NCC"), col=c(alpha("green",0.2),alpha("blue",0.2)), lwd=5,
       bty="n")

## Purpose: Collapsibility
## Author: Mark Clements, 2019-10-23
###############################################################################

###############################################################################
## Exercise 14
###############################################################################
## @knitr loadDependencies
library(biostat3) 
library(rstpm2)
library(ggplot2)

## @knitr loadPreprocess

## @knitr 14.simulate
set.seed(12345)
d <- local({
    n <- 1e4
    x <- rbinom(n, 1, 0.5)
    u <- rnorm(n, 0, 3)
    t <- rexp(n, exp(-5+x+u))
    c <- runif(n, 0, 10)
    y <- pmin(t, c)
    delta <- (t < c)
    data.frame(y,x,u,delta)
})
head(d)


## @knitr 14.dag
if (requireNamespace("dagitty")) {
    library(dagitty)
    g1 <- dagitty( "dag {
    X -> T -> \"(Y,Delta)\"
    U -> T
    C -> \"(Y,Delta)\"
}")
    plot(graphLayout(g1))
}

## @knitr 14.a
summary(fit1 <- glm(delta~x+u+offset(log(y)),data=d,family=poisson))

summary(fit2 <- coxph(Surv(y,delta)~x+u,data=d))

summary(fit3 <- stpm2(Surv(y,delta)~x+u,data=d,df=4))

## summary table for the coefficients for X
rbind(Poisson=coef(summary(fit1))["x",c("Estimate","Std. Error")],
      Cox=coef(summary(fit2))["x",c("coef","se(coef)")],
      Stpm2=coef(summary(fit3))["x",c("Estimate","Std. Error")])

## @knitr 14.tvc.xu
fit <- stpm2(Surv(y,delta)~x+u,data=d,df=4, tvc=list(x=2)) # slow
plot(fit, type="hr", newdata=data.frame(x=0,u=0), var="x", ylim=c(1,4))
predict(fit, type="surv", newdata=data.frame(x=0:1,u=3), grid=TRUE, full=TRUE,
        se.fit=TRUE) |>
    ggplot(aes(x=y,y=Estimate,fill=factor(x),ymin=lower,ymax=upper)) +
    ylab("Survival") +
    geom_ribbon(alpha=0.6) +
    geom_line(aes(colour=factor(x)))
## standardisation: slow:(
plot(fit, type="meanhr", newdata=transform(d,x=0), var="x", seqLength=31, ylim=c(1,4))
plot(fit, type="meansurvdiff", newdata=transform(d,x=0), var="x", seqLength=31)
plot(fit, type="meansurv", newdata=transform(d,x=0), seqLength=101)


## @knitr 14.b
summary(fit1 <- glm(delta~x+offset(log(y)),data=d,family=poisson))

summary(fit2 <- coxph(Surv(y,delta)~x,data=d))

summary(fit3 <- stpm2(Surv(y,delta)~x,data=d,df=4))

## @knitr 14.b.2
## summary table for the coefficients for X
rbind(Poisson=coef(summary(fit1))["x",c("Estimate","Std. Error")],
      Cox=coef(summary(fit2))["x",c("coef","se(coef)")],
      Stpm2=coef(summary(fit3))["x",c("Estimate","Std. Error")])

## @knitr 14.tvc.x
fit <- stpm2(Surv(y,delta)~x,data=d,df=4, tvc=list(x=2))
plot(fit, type="hr", newdata=data.frame(x=0), var="x", ylim=c(1,4))

## @knitr 14.simulate.2
set.seed(12345)
d <- local({
    n <- 1e4*10 # CHANGED N
    x <- rbinom(n, 1, 0.5)
    u <- rnorm(n, 0, 3)
    t <- rexp(n, exp(-5+x+u))
    c <- runif(n, 0, 10/1000) # CHANGED FROM 10 TO 0.01
    y <- pmin(t, c)
    delta <- (t < c)
    data.frame(y,x,u,delta)
})

## @knitr 14.simulate.3
set.seed(12345)
d <- local( {
    n <- 1e4
    x <- rbinom(n, 1, 0.5)
    u <- rnorm(n, 0, 1) # CHANGED SD FROM 3 TO 1
    t <- rexp(n, exp(-5+x+u))
    c <- runif(n, 0, 10) 
    y <- pmin(t, c)
    delta <- (t < c)
    data.frame(y,x,u,delta)
})

## @knitr 14.aft
fit <- aft(Surv(y,delta)~x+u,data=d,df=4)
summary(fit)
fit <- aft(Surv(y,delta)~x,data=d,df=4)
summary(fit)

## Date: 2015-03-03
## Purpose: To do the solution for Biostat III exercise 9 in R
## Author: Annika Tillander,  Johan Zetterqvist
###############################################################################

## ## Install needed packages only need to be done once
## Install needed packages only need to be done once

###############################################################################
## Exercise 9
###############################################################################
## @knitr loadDependencies

library(biostat3)
library(dplyr)    # for data manipulation
library(splines)   # ns (recommended package)

## @knitr loadPreprocess
## Read melanoma data, select subcohorts and create a death indicator
melanoma.l <- biostat3::melanoma |>
    subset(stage=="Localised") |>
    transform(death_cancer = as.numeric(status=="Dead: cancer"))

melanoma.l2 <-
    transform(melanoma.l,
              ## Create a death indicator (only count deaths within 120 months)
              death_cancer = ifelse(surv_mm<=120, death_cancer, 0),
              ## Create a new time variable
              surv_mm = pmin(surv_mm, 120))

## @knitr 9.a

summary(coxph(Surv(surv_mm, death_cancer) ~ year8594,
              data = melanoma.l2))

## @knitr 9.b

survdiff(Surv(surv_mm, death_cancer) ~ year8594, data = melanoma.l)
summary(coxph(Surv(surv_mm, death_cancer) ~ year8594,
              data = melanoma.l))

## @knitr 9.c

summary(coxfit9c <- coxph(Surv(surv_mm, death_cancer) ~ year8594 + sex + agegrp,
                          data = melanoma.l2))

## Test if the effect of age is significant
## Use a Wald test with the car package
library(car)
linearHypothesis(coxfit9c,c("agegrp45-59 = 0","agegrp60-74 = 0","agegrp75+ = 0"))

## @knitr 9.d

## Test if the effect of age is significant
## Use an LR test with the anova function
## The model without agegrp
summary(coxfit9d <- coxph(Surv(surv_mm, death_cancer) ~ year8594 + sex,
                          data = melanoma.l2))
## LR test
anova(coxfit9c, coxfit9d)
anova(coxfit9c)
## @knitr 9.e

summary(coxfit9e <- coxph(Surv(surv_mm, death_cancer) ~ year8594 + sex + agegrp,
                          data = melanoma.l2))

## Split follow up by year
melanoma.spl <- survSplit(melanoma.l2, cut=12*(0:10), end="surv_mm", start="start",
                           event="death_cancer")

## Calculate persontime and
## recode start time as a factor
melanoma.spl <- transform(melanoma.spl,
                          pt = surv_mm - start,
                          fu = as.factor(start))

## Run Poisson regression
summary(poisson9e <- glm(death_cancer ~ fu + year8594 + sex + agegrp + offset(log(pt)),
                         family = poisson,
                         data = melanoma.spl))

eform(poisson9e)

## @knitr 9.f

sfit9f <- survfit(Surv(surv_mm, event=death_cancer) ~ 1,
                  data = melanoma.l2 )
## Have a look at the fitted object
str(sfit9f, 1)

head(sfit9f$time)

## Split follow up by event times
melanoma.spl2 <- survSplit(melanoma.l2, cut=sfit9f$time, end="surv_mm", start="start",
                           event="death_cancer")

## Calculate persontime and
## recode start time as a factor
melanoma.spl2 <- transform(melanoma.spl2,
                           pt = surv_mm - start,
                           fu = as.factor(start))

## Collapse
library(dplyr)
melanoma.spl3 <- melanoma.spl2 |>
    group_by(fu,year8594,sex,agegrp) |>
    summarise(pt=sum(pt), death_cancer=sum(death_cancer)) |>
    data.frame()

## Run Poisson regression
poisson9f <- glm(death_cancer ~ fu + year8594 + sex + agegrp + offset(log(pt)),
                 family = poisson,
                 data = melanoma.spl3 )

## IRR
coef9f <- eform(poisson9f)
## We are not interested in nuisance parameters fu1, fu2, etc
npar <- nrow(coef9f)
pars <- (npar-4):npar
coef9f[pars,]

summary(coxfit9e)


## @knitr 9.g
## split and collapse
library(dplyr)
cuts.splines <- seq(0,max(sfit9f$time),by=3)
mid.splines <- cuts.splines + 1.5
melanoma.spl4 <-
    survSplit(Surv(surv_mm,death_cancer)~., data=melanoma.l2, cut=cuts.splines,
              start="tstart", end="tstop") |>
    mutate(cut=cut(tstop,cuts.splines),
              mid=mid.splines[unclass(cut)]) |>
    group_by(mid,year8594,sex,agegrp) |>
    summarise(pt=sum(tstop-tstart), death_cancer=sum(death_cancer), .groups="keep")

poisson9g <- glm( death_cancer ~ ns(mid,df=3) + year8594 + sex + agegrp,
                 offset=log(pt), # for effects::Effect() - rather than in the formula
                 family = poisson,
                 data = melanoma.spl4 )
summary(poisson9g)
eform(poisson9g)

times <- seq(0,max(cuts.splines),length=1000)
delta <- times[2]-times[1]
newdata <- data.frame(mid=times, year8594="Diagnosed 85-94",
                      sex="Male", agegrp="45-59",
                      pt=1)
## plot predicted rates and 95% CI
library(tinyplot)
cbind(newdata,
      predict(poisson9g, newdata=newdata, se.fit=TRUE) |> as.data.frame()) |>
    transform(rate = exp(fit),
              lower = exp(fit-1.96*se.fit),
              upper = exp(fit+1.96*se.fit)) |>
	with(plt(rate~mid, type="ribbon",
             ymin=lower, ymax=upper,
             xlab="Time since diagnosis (months)",
             ylab="Rate", main="Males aged 45-59 years diagnosed 1985-94"))

## predict survival and 95% CI
library(rstpm2)
logcumhaz <-
    rstpm2::predictnl(poisson9g,
                      fun=function(fit,newdata)
                          log(cumsum(delta*predict(fit, newdata, type="response"))),
                      newdata=newdata) |>
    transform(surv = exp(-exp(Estimate)),
              lower.ci=exp(-exp(cbind(Estimate-1.96*SE))),
              upper.ci=exp(-exp(cbind(Estimate+1.96*SE)))) |>
    cbind(newdata)
with(logcumhaz, plt(surv~mid, ymin=lower.ci, ymax=upper.ci, type="ribbon",
                    xlab="Time since diagnosis (months)",
                    ylab="Survival", main="Males aged 45-59 years diagnosed 1985-94"))

# A first attempt at analysing the localised melanoma data
#
# Please help!
#
# Paul Dickman, November 2010
#
# setwd("c:/survival/")

library( survival )
library(foreign)
library(Epi)

# localised (stage==1) melanoma diagnosed in Finland
melanoma <- subset.data.frame(read.dta("http://biostat3.net/download/melanoma.dta",convert.factors=FALSE), stage==1)

# Lexis requires time variables to be numeric and have the same units
# we will use years
melanoma$dx<-1970+as.numeric(melanoma$dx)/365.24
melanoma$exit<-1970+as.numeric(melanoma$exit)/365.24
melanoma$bdate<-1970+as.numeric(melanoma$bdate)/365.24

head( melanoma)

# Patients who survived more than 10 years are censored at 10 years
melanoma$status <- ifelse(melanoma$surv_mm>120,0,melanoma$status)
melanoma$exit <- ifelse(melanoma$surv_mm>120,melanoma$dx + 10,melanoma$exit)
melanoma$surv_yy <- ifelse(melanoma$surv_mm>120,10,melanoma$surv_yy)
melanoma$surv_mm<- ifelse(melanoma$surv_mm>120,120,melanoma$surv_mm)

# Kaplan-Meir estimates of survival for each period
sf <- survfit( Surv( surv_mm, status==1 ) ~ 1 + year8594, data=melanoma )
plot(sf)

# Cox regression with time-since-entry as the timescale
# Note that R uses the Efron method for approximating the likelihood in the presence
# whereas Stata (and most other software) use the Breslow method
cox1 <- coxph( Surv( surv_mm, status==1 ) ~ 1 + year8594, method=c("breslow"), data=melanoma )
summary( cox1 )

# Cox regression again but using different variables to define time
cox2 <- coxph( Surv( exit-dx, status==1 ) ~ 1 + year8594, method=c("breslow"), data=melanoma )
summary( cox2 )

# Poisson regression assuming constant mortality over time
poisson1 <- glm( status==1 ~ 1 + year8594 + offset( log( surv_mm ) ), family=poisson, data=melanoma )
summary( poisson1 )

# Define a Lexis object
L <- Lexis( entry = list( per=dx, attage=dx-bdate, fu=0 ), exit = list( per=exit ),
 exit.status = factor( status, labels=c("alive","dead:cancer","dead:other","lost") ),
 data = melanoma )
str( L )
sample <- L[sample(5), ]

# Default plot of Lexis object
plot( sample )

# With a grid and deaths as endpoints
plot( sample, grid=0:10*10, col="black" )
points( sample, pch=c(NA,16)[sample$lex.Xst] )

# With a lot of bells and whistles:
plot( sample, grid=0:20*5, col="black", xaxs="i", yaxs="i",
      xlim=c(1975,2000), ylim=c(60,100), lwd=3, las=1 )
points( sample, pch=c(NA,16)[sample$lex.Xst], col="red", cex=1.5 )

# Split follow-up time into annual intervals
head( L, 3)
split <- splitLexis(L, breaks=seq(0,10,1), time.scale="fu")
head( split, 8 )

# Rerun the Poisson regression model assuming constant hazards on the original data
poisson1b <- glm( status==1 ~ 1 + year8594 + offset( log(exit-dx) ), family=poisson, data=melanoma )
summary( poisson1b )

# Now rerun the Poisson regression model assuming constant hazards on the split data (results should be the same)
poisson2 <- glm( as.numeric(split$lex.Xst)==2 ~ 1 + year8594 + offset( log(lex.dur) ), family=poisson, data=split )
summary( poisson2 )

# Now adjust for follow-up time
poisson3 <- glm( as.numeric(split$lex.Xst)==2 ~ 1 + as.factor(fu) + year8594 + offset( log(lex.dur) ), family=poisson, data=split )
summary( poisson3 )

## Date: 2015-03-03
## Purpose: To do the solution for Biostat III exercises in R
## Author: Johan Zetterqvist
## Modified: Mark Clements, 2017-08-07
###############################################################################

###############################################################################
## Exercise 7
###############################################################################

## Install needed packages only need to be done once
## install.packages("foreign")
## install.packages("muhaz")
## install.packages("car")

## @knitr loadDependencies
library(biostat3)
library(dplyr)    # for data manipulation
library(car)      # for car::linearHypothesis -> biostat3::lincom

## @knitr loadPreprocess
## Read melanoma data

## Create a new dataset with only localised cancer
melanoma.l <- filter(biostat3::melanoma, stage=="Localised")
head( melanoma.l )
summary(melanoma.l)

## @knitr 7.a.i

## Plot Kaplan-Meier curve using survfit
## Create a new event indicator
melanoma.l <- mutate(melanoma.l,
                   death_cancer = as.numeric(status=="Dead: cancer") )

## Create a fitted object for our subcohort
## using survfit
sfit7a1 <- survfit(Surv(surv_mm, event=death_cancer) ~ year8594,
                   data = melanoma.l )

## Have a look at the fitted object
str(sfit7a1, 1)

## Plot the survival curve (with some bells and whistles)
plot(sfit7a1,
     ## No automatic labelling of the curve (we do that ourselves)
     mark.time=F,
     ## Time is measured in months,  but we want to see it in years
     xscale=12,
     ## Make the plot prettier
     xlab="Years since diagnosis",
     ylab="S(t)",
     col=c("blue","red"),
     lty=c("solid","dashed"))
## Add legend too
legend("bottomleft",legend=levels(melanoma.l$year8594),col=c("blue","red"),lty=c("solid","dashed"), bty="n")

### TRY IF YOU WANT ###
if (FALSE) {
    library(survMisc)
    ## Note: `autoplot(sfit7a1)` was broken; I have submitted a pull request to fix this
    ## autoplot(sfit7a1)
    ## alternatively:
    autoplot(sfit7a1, timeTicks = "custom", times= seq(0, 20*12, 5*12))
}

## @knitr 7.a.ii

## To plot smoothed hazards, we use the muhaz package (using the muhaz2 wrapper)

plot(muhaz2(Surv(surv_mm/12, status == "Dead: cancer") ~ year8594, data=melanoma.l),
     xlab="Years since diagnosis", col=c("blue","red"), lty=1:2)


## @knitr 7.a.iii
## Compare with Kaplan-Meier plot
par(mfrow=1:2)
plot(sfit7a1,
     ## No automatic labelling of the curve (we do that ourselves)
     mark.time=FALSE,
     ## Time is measured in months,  but we want to see it in years
     xscale=12,
     ## Make the plot prettier
     xlab="Years since diagnosis",
     ylab="S(t)",
     col=c("blue","red"),
     lty=c("solid","dashed"))

plot(muhaz2(Surv(surv_mm/12, status == "Dead: cancer") ~ year8594, data=melanoma.l),
     xlab="Years since diagnosis", col=c("blue","red"),lty=c("solid","dashed"))

## @knitr 7.b

survRate(Surv(surv_mm, death_cancer) ~ year8594, data=melanoma.l)


## @knitr 7.c.i

## Calculate the incidence rate by time of diagnosis
## but with new variables
melanoma.l2 <- mutate(melanoma.l,
                      ## Update the death indicator (only count deaths within 120 months)
                      ## death_cancer = death_cancer * as.numeric(surv_mm<=120),
                      death_cancer = ifelse(surv_mm<=120 & status == "Dead: cancer",1,0),
                      ## Create a new time variable
                      ## surv_mm = pmin(surv_mm, 120)
                      surv_mm = ifelse(surv_mm<=120, surv_mm, 120)
                      )

## Calculate the rates on the truncated data
rates_by_diag_yr2 <- survRate(Surv(surv_mm, death_cancer) ~ year8594, data=melanoma.l2)
rates_by_diag_yr2

## @knitr 7.c.ii

## MRR full data
rates_by_diag_yr2[2, "rate"] / rates_by_diag_yr2[1, "rate"]
with(rates_by_diag_yr2[2:1,], poisson.test(event, tstop))

## @knitr 7.c.iii
## Use glm to estimate the rate ratios
## we scale the offset term to 1000 person-years
poisson7c <- glm( death_cancer ~ year8594 + offset( log( surv_mm/12/1000 ) ), family=poisson, data=melanoma.l2 )
summary( poisson7c )

## also for collapsed data
summary(glm( event ~ year8594 + offset( log( tstop/12/1000 ) ), family=poisson, data=rates_by_diag_yr2))


## IRR
eform(poisson7c)


## Note that the scaling of the offset term only has an impact on the intercept
summary( glm( death_cancer ~ year8594 + offset( log( surv_mm ) ),
             family=poisson, data=melanoma.l2 ) )

## @knitr 7.d

## Add a new variable for year
melanoma.l2 <- mutate( melanoma.l2, surv_yy1 = surv_mm/12)

## Split follow up by year
melanoma.spl <- survSplit(melanoma.l2, cut=0:9, end="surv_yy1", start="start",
                           event="death_cancer")

## Calculate persontime and
## recode start time as a factor
melanoma.spl <- transform(melanoma.spl,
                          pt = surv_yy1 - start,
                          fu = as.factor(start) )

## @knitr 7.e

## Calculate the incidence rate by observation year
yearly_rates <- survRate(Surv(pt/1000,death_cancer)~fu, data=melanoma.spl) |>
    transform(start=as.numeric(levels(fu))[fu]) |>
    transform(mid=start+0.5)

yearly_rates2 <- survRate(Surv(pt/1000,death_cancer)~fu+sex, data=melanoma.spl) |>
    transform(start=as.numeric(levels(fu))[fu]) |>
    transform(mid=start+0.5)

## Plot by year
with(yearly_rates,
     matplot(fu,
             cbind(rate, lower, upper),
             lty=c("solid","dashed","dashed"),
             col=c("black","gray","gray"),
             type="l",
             main="Cancer deaths by years since diagnosis",
             ylab="Incidence rate per 1000 person-years",
             xlab="Years since diagnosis") )

ci_polygon = function(x, lower, upper, ...)
    polygon(c(x,rev(x)), c(lower, rev(upper)), ...)
with(yearly_rates, {
    matplot(start, cbind(lower, upper), type="n",
            main="Cancer deaths by years since diagnosis",
            ylab="Incidence rate per 1000 person-years",
            xlab="Years since diagnosis")
    ci_polygon(start,lower,upper,
               col="lightgrey",
               border="transparent")
    lines(start,rate)
})

library(tinyplot)
with(yearly_rates, {
    plt(rate~start, ymin=lower, ymax=upper, type="ribbon",
        main="Cancer deaths by years since diagnosis",
        ylab="Incidence rate per 1000 person-years",
        xlab="Years since diagnosis")
})
with(yearly_rates2, {
    plt(rate~start|sex, ymin=lower, ymax=upper, type="ribbon",
        col = c(blue = "#0072B2", orange = "#E69F00"),
        main="Cancer deaths by years since diagnosis",
        ylab="Incidence rate per 1000 person-years",
        xlab="Years since diagnosis")
})


library(scales) # alpha() for transparency
ci_polygon = function(x, lower, upper, ...)
    polygon(c(x,rev(x)), c(lower, rev(upper)), ...)
with(yearly_rates2, {
    col = c(blue = "#0072B2", orange = "#E69F00")
    group = levels(sex)
    matplot(start, cbind(lower, upper), type="n",
            main="Cancer deaths by years since diagnosis",
            ylab="Incidence rate per 1000 person-years",
            xlab="Years since diagnosis")
    for (i in 1:length(group)) {
        index = sex == group[i]
        ci_polygon(start[index],lower[index],upper[index],
                   col=alpha(col[i],0.4),
                   border="transparent")
        lines(start[index],rate[index],col=col[i])
    }
    legend("topright", legend=group, lty=1, col=col, bty="n")
})

library(Hmisc)
xYplot(Cbind (rate, lower, upper) ~ start,
       groups=sex, 
       method="filled bands",
       data=yearly_rates2,
       type="l",
       keys='lines',
       col.fill=alpha(trellis.par.get("superpose.line")$col,0.4),
       main="Cancer deaths by years since diagnosis",
       ylab="Incidence rate per 1000 person-years",
       xlab="Years since diagnosis")

library(tactile)
with(yearly_rates2,
     xyplot(rate~start,
            lower=lower,
            upper=upper,
            type="l",
            groups=sex,
            auto.key=TRUE,
            panel=function(...) {tactile::panel.ci(...); panel.xyplot(...)},
            main="Cancer deaths by years since diagnosis",
            ylab="Incidence rate per 1000 person-years",
            xlab="Years since diagnosis"))

#' @description Superpose plots for grouped data
#' @param x vector for the x axis
#' @param y vector for the estimated values
#' @param INDEX vector for the index
#' @param panel a function with signature function(x, y, i, subscripts, value), where x and y are subsets of the full x and y, where i is a counter for the index set, subscripts is an indicator vector for the subset and value is the ith INDEX value
#' @param ... other parameters passed to `plot`

make_panel = function(FUN,col=1:7,lty=1:7,pch=1:7,...)
    function(x,y,i,subscripts,value)
        FUN(x,y,col=col[i],lty=lty[i],pch=pch[i],...)
plot.superpose = function(x, y, INDEX, panel=make_panel(points), index=NULL,
                          legend=unique(INDEX), legend.args=list(), add=FALSE, ...) {
    if (!add) plot(x,y,...,type="n")
    uids = unique(INDEX)
    for(i in 1:length(uids)) {
        subscripts = INDEX == uids[i]
        panel(x[subscripts], y[subscripts], i=i,
              subscripts=subscripts, value=uids[i])
    }
    if (!add)
        do.call("legend", modifyList(list(x="topright",legend=legend), legend.args))
}
ci_polygon = function(x, lower, upper, border="transparent", ...)
    polygon(c(x,rev(x)), c(lower, rev(upper)), border=border, ...)
with(yearly_rates2, {
    col = trellis.par.get("superpose.line")$col
    plot.superpose(start,rate,sex,
                   legend.args=list(col=col,lty=1,bty="n"),
                   ylim=c(0,80),
                   panel=function(x,y,i,subscripts,...) {
                       ci_polygon(x, lower[subscripts],upper[subscripts],
                                  col=alpha(col[i],0.4))
                       lines(x,y,col=col[i])
                   })
})

## matrix y
make_panel = function(FUN,col=1:7,lty=1:7,pch=1:7,...)
    function(x,y,i,value)
        FUN(x,y,col=col[i],lty=lty[i],pch=pch[i],...)
plot.superpose = function(x, y, INDEX, panel=make_panel(points), index=NULL,
                          legend=unique(INDEX), legend.args=list(), add=FALSE, ...) {
    if (!add) matplot(x,y,...,type="n")
    uids = unique(INDEX)
    for(i in 1:length(uids)) {
        subscripts = INDEX == uids[i]
        panel(x[subscripts], y[subscripts,], i=i, value=uids[i])
    }
    if (!add)
        do.call("legend", modifyList(list(x="topright",legend=legend), legend.args))
}
ci_polygon = function(x, lower, upper, border="transparent", ...)
    polygon(c(x,rev(x)), c(lower, rev(upper)), border=border, ...)
with(yearly_rates2, {
    col = trellis.par.get("superpose.line")$col
    plot.superpose(start, cbind(rate,lower,upper), sex,
                   legend.args=list(col=col,lty=1,bty="n"),
                   panel=function(x,y,i,...) {
                       ci_polygon(x, y[,2],y[,3],
                                  col=alpha(col[i],0.4))
                       lines(x,y[,1],col=col[i])
                   })
})

model.matrix(cbind(rate,lower,upper)~start+sex+1, data=yearly_rates2)[,-1]

## matrix y (simplified)
matplot2 = function(x, y, group=NULL, panel=matpoints,
                    xlab=NULL, ylab=NULL, ...) {
    stopifnot(length(x)==NROW(y),
              is.null(group) || length(x)==length(group),
              is.matrix(y) || is.vector(y))
    if (is.null(group)) group=1 # arbitrary value
    if (is.null(xlab)) xlab=deparse(substitute(x))
    if (is.null(ylab)) ylab=deparse(substitute(y))
    if (is.vector(y)) y=matrix(y)
    group_levels = if (is.factor(group)) levels(group) else unique(group)
    matplot(x, y, ..., type="n", xlab=xlab, ylab=ylab)
    for(i in 1:length(group_levels)) {
        subscripts = group == group_levels[i]
        panel(x[subscripts], y[subscripts,], i=i, group=group_levels[i])
    }
}
ci_polygon = function(x, lower, upper, border="transparent", ...)
    polygon(c(x,rev(x)), c(lower, rev(upper)), border=border, ...)
with(yearly_rates, {
    matplot2(start, cbind(rate,lower,upper), 
             panel=function(x,y,...) {
                 ci_polygon(x, y[,2], y[,3],
                            col="lightgrey")
                 lines(x,y[,1],col=1)
             },
             main="Cancer deaths by\nyears since diagnosis",
             ylab="Incidence rate per 1000 person-years",
             xlab="Years since diagnosis")
})
with(yearly_rates2, {
    col = trellis.par.get("superpose.line")$col
    matplot2(start, cbind(rate,lower,upper), sex,
             panel=function(x,y,i,...) {
                 ci_polygon(x, y[,2], y[,3],
                            col=alpha(col[i],0.4))
                 lines(x,y[,1],col=col[i])
             },
             main="Cancer deaths by\nyears since diagnosis",
             ylab="Incidence rate per 1000 person-years",
             xlab="Years since diagnosis")
    legend("topright", legend=levels(sex), lty=1, col=col, bty="n")
})

with(yearly_rates2, {
    matplot2(start, cbind(rate,lower,upper), sex,
             panel=function(x,y,i,...) matlines(x,y,col=i,lty=c(1,2,2)))
    legend("topright", legend=levels(sex), lty=1, col=1:2, bty="n")
})

with(yearly_rates, {
    par(mfrow=1:2)
    matplot(start, cbind(rate,lower,upper), type="l", main="matplot",
            lty=c(1,2,2), col=1)
    matplot2(start, cbind(rate,lower,upper),
             panel=function(x,y,...) matlines(x,y,lty=c(1,2,2),col=1),
             main="matplot2")
})


## Example using coplot()
panel.ci = function(x, y, lower, upper, subscripts, col, pch,
                    border="transparent", fill.col="grey",
                    line.col="black", ...) {
    polygon(c(x,rev(x)),
            c(lower[subscripts], rev(upper[subscripts])),
            border=border, col=fill.col)
    lines(x,y,col=line.col)
}


## @knitr 7.f
# Plot smoothed hazards

par(mfrow=1:2)
with(yearly_rates, matplot(as.numeric(as.character(fu))+0.5,
                           cbind(rate, lower,
                                 upper),
                           ylim=c(0,max(upper)),
                           lty=c("solid","dashed","dashed"),
                           col=c("black","gray","gray"),
                           type="l",
                           main="Cancer deaths by time since diagnosis",
                           ylab="Mortality rate per 1000 person-years",
                           xlab="Years since diagnosis") )

library(bshazard)
hazfit7f <- bshazard(Surv(surv_mm/12, status == "Dead: cancer") ~ 1, data = melanoma.l)
## scale hazard by 1000
plot(hazfit7f, xlab="Years since diagnosis",col="blue",lty="solid")


## @knitr 7.g
## Run Poisson regression
summary(poisson7g <- glm( death_cancer ~ fu + offset( log(pt) ),
                         family = poisson,
                         data = melanoma.spl ))
## IRR
eform(poisson7g)

## @knitr 7.h
summary(poisson7h <- glm( death_cancer ~ fu + year8594 + offset( log(pt) ),
                         family = poisson,
                         data = melanoma.spl ))
## IRR
eform(poisson7h)

# Add interaction term
summary(poisson7h2 <- glm( death_cancer ~ fu*year8594 + offset( log(pt) ), family=poisson, data=melanoma.spl ))
## IRR
eform(poisson7h2)

## @knitr 7.i

summary(poisson7i <- glm( death_cancer ~ fu + year8594 + sex + agegrp + offset( log(pt) ), family=poisson, data=melanoma.spl ))

## IRR
eform(poisson7i)

## Test if the effect of age is significant using a likelihood ratio test
drop1(poisson7i, ~agegrp, test="Chisq")
## For this we can also use the car package and a Wald test
linearHypothesis(poisson7i,c("agegrp45-59 = 0","agegrp60-74 = 0","agegrp75+ = 0"))
## ADVANCED:
## Alternative approach for the likelihood ratio test
# poisson7i_2 <- update(poisson7i,. ~ . - agegrp)
# anova(poisson7i_2,poisson7i,test="Chisq")

## @knitr 7.j

summary(poisson7j <- glm( death_cancer ~ fu + agegrp + year8594*sex + offset( log(pt) ), family=poisson, data=melanoma.spl ))

## IRR
eform(poisson7j)

## @knitr 7.k.i
# hand calculations
hz7k <- exp(coef(poisson7j))
hz7k["sexFemale"]
hz7k["sexFemale"]*hz7k["year8594Diagnosed 85-94:sexFemale"]

## @knitr 7.k.ii
## You will need the "car" package to use lincom. If it is not already installed:
## install.packages("car")
lincom(poisson7j,c("sexFemale + year8594Diagnosed 85-94:sexFemale"),eform=TRUE)


## @knitr 7.k.iii
## Create dummies and Poisson regression
melanoma.spl <- melanoma.spl %>%
    ## Add confidence intervals for the rates
    mutate(femaleEarly = sex=="Female" & year8594=="Diagnosed 75-84",
           femaleLate = sex=="Female" & year8594=="Diagnosed 85-94")

summary(poisson7k <- glm( death_cancer ~ fu + agegrp + year8594 + femaleEarly +
                         femaleLate + offset( log(pt) ), family=poisson,
                         data=melanoma.spl ))

## IRR
eform(poisson7k)

## @knitr 7.k.iv
## Add interaction term
summary(poisson7k2 <- glm( death_cancer ~ fu + agegrp + year8594 + year8594:sex +
                         offset( log(pt) ), family=poisson,
                         data=melanoma.spl ))
eform(poisson7k2)


## @knitr 7.l

summary( poisson7l.early <- glm( death_cancer ~ fu + agegrp + sex + offset( log(pt) ),
                       family = poisson, data = melanoma.spl,
                       subset = year8594 == "Diagnosed 75-84" ) )
eform(poisson7l.early)

summary( poisson7l.late <- glm( death_cancer ~ fu + agegrp + sex + offset( log(pt) ),
                       family = poisson, data = melanoma.spl,
                       subset = year8594 == "Diagnosed 85-94" ) )
eform(poisson7l.late)

# compare with results in i
eform(poisson7i)

# compare with results in j
eform(poisson7j)


# Poisson-regression with effects specific for diagnose period
summary(poisson7l2 <- glm( death_cancer ~ fu + fu:year8594 + agegrp + agegrp:year8594
                          + sex*year8594 + offset( log(pt) ),
                          family=poisson, data=melanoma.spl ))
eform(poisson7l2)

## @knitr 7.m
## Split follow up by month
library(splines)
time.cut <- seq(0,10,by=1/12)
nrow(biostat3::melanoma)
melanoma.spl <- survSplit(Surv(surv_mm/12,status=="Dead: cancer")~., data=biostat3::melanoma,
                          cut=time.cut,
                          subset=stage=="Localised")
nrow(melanoma.spl)
melanoma.spl <- transform(melanoma.spl, mid=(tstop+tstart)/2, risk_time=tstop-tstart)
poisson7m <- glm(event ~ ns(mid,df=6) + agegrp + year8594 +
                     offset(log(risk_time)),
                 family=poisson,
                 data=melanoma.spl)
df <- data.frame(agegrp="0-44", year8594="Diagnosed 75-84",
                 mid=time.cut[-1], risk_time=1)
## plot the rate at the baseline values
plot(df$mid, predict(poisson7m, newdata=df, type="response"),
     type="l", ylab="Rate", xlab="Time since diagnosis (years)",
     ylim=c(0,0.05))

add_ci = function(df, level=0.95, exponentiate=FALSE,
                  itrans=c("I","log"), ...) {
    stopifnot(is.list(df),
              (".fitted" %in% names(df) && ".se.fit" %in% names(df)) ||
              ("fit" %in% names(df) && "se.fit" %in% names(df)),
              is.numeric(level),
              length(level) %in% c(1,nrow(df)),
              level>0,
              level<1,
              is.logical(exponentiate))
    itrans <- match.arg(itrans)
    if (inherits(df,"list")) df = as.data.frame(df)
    a <- (1 - level)/2
    a <- cbind(a, 1 - a)
    fac <- qnorm(a)
    if (".fitted" %in% names(df) && ".se.fit" %in% names(df))
        within(df, {
            if (itrans=="log") {
                .se.fit <- .se.fit/.fitted
                .fitted <- log(.fitted)
            }
            .upper <- .fitted+fac[,2]*.se.fit
            .lower <- .fitted+fac[,1]*.se.fit
            transf <- function() {
                .upper <<- exp(.upper)
                .lower <<- exp(.lower)
                .fitted <<- exp(.fitted)
                .se.fit <<- .se.fit*.fitted
            }
            if (itrans=="log") transf()
            if (exponentiate) transf()
            transf <- NULL
        })
    else
        within(df, {
            if (itrans=="log") {
                se.fit <- se.fit/fit
                fit <- log(fit)
            }
            conf.high <- fit+fac[,2]*se.fit
            conf.low <- fit+fac[,1]*se.fit
            transf <- function() {
                conf.high <<- exp(conf.high)
                conf.low <<- exp(conf.low)
                fit <<- exp(fit)
                se.fit <<- se.fit*fit
            }
            if (itrans=="log") transf()
            if (exponentiate) transf()
            transf <- NULL
        })
}
predict(poisson7m, newdata=df,se.fit=TRUE) |> add_ci() |> head()
predict(poisson7m, newdata=df,se.fit=TRUE) |> add_ci(exp=TRUE) |> head()
predict(poisson7m, newdata=df,se.fit=TRUE) |> add_ci(exp=TRUE) |> add_ci(itrans="log") |> head()
augment(poisson7m, newdata=df, se_fit=TRUE) |> add_ci()
augment(poisson7m, newdata=df, se_fit=TRUE) |> add_ci(exp=TRUE)
augment(poisson7m, newdata=df, se_fit=TRUE) |> add_ci(exp=TRUE) |> add_ci(itrans="log")


as.data.frame.by <- function(x, row.names=NULL, option=FALSE, ...) {
    out <- array2DF(x, simplify=FALSE) |>
        subset(!sapply(Value,is.null))
    cbind(out[-length(out)], do.call(rbind,out$Value))
}
melanoma.spl4 <-
    by(melanoma.spl2,
       with(melanoma.spl2, data.frame(sex, agegrp, stage, year8594, timeband)),
       function(data)
           with(data,
                data.frame(risk_times=sum(risk_time),
                           events=sum(event),
                           mid=sum(risk_time*mid)/sum(risk_time)))) |>
    as.data.frame()
head(melanoma.spl4)

## @knitr 7.n
## using melanoma.spl and df from previous chunk
poisson7n <- glm(event ~ ns(mid,df=4) + agegrp + year8594 +
                     ifelse(year8594=="Diagnosed 85-94",1,0):ns(mid,df=3) +
                     offset(log(risk_time)),
                 family=poisson,
                 data=melanoma.spl)
library(rstpm2)
library(ggplot2)
## get log(RR) confidence interval using predictnl (delta method)
pred <- predictnl(poisson7n, function(object)
    log(predict(object, newdata=transform(df, year8594="Diagnosed 85-94"),
                type="response") /
        predict(object, newdata=df, type="response")))
pred2 <- transform(pred, time = df$mid, rr = exp(fit), ci = exp(confint(pred)))
ggplot(pred2, aes(x=time, y=rr, ymin=ci.2.5.., ymax=ci.97.5..)) +
    ggplot2::geom_line() + ggplot2::geom_ribbon(alpha=0.6) +
    xlab("Time since diagnosis (years)") +
    ylab("Rate ratio")
    
## Calculate the rate difference
band <- function(x,yy,col="grey")
    polygon(c(x,rev(x)), c(yy[,1], rev(yy[,2])), col=col, border=col)
pred <- predictnl(poisson7n, function(object)
    predict(object, newdata=transform(df, year8594="Diagnosed 85-94"),
                type="response") -
    predict(object, newdata=df, type="response"))
rd <- pred$fit
ci <- confint(pred)
matplot(df$mid,
        ci,
        type="n", # blank plot area
        xlab="Time since diagnosis (years)",
        ylab="Rate difference") 
band(df$mid,ci) # add confidence band
lines(df$mid, rd) # add rate difference

## @knitr 7.o
## Calculate survival from a smooth Poisson regression model 
if (requireNamespace("deSolve")) {
    twoState <- function(object, ...) {
        out <- as.data.frame(markov_msm(list(object),matrix(c(NA,1,NA,NA),2,byrow=TRUE), ...))
        transform(subset(out, state==1),
                  S=P,
                  S.lower=P.lower,
                  S.upper=P.upper)
    }
    df2 <- expand.grid(agegrp=levels(biostat3::melanoma$agegrp),
                       year8594=levels(biostat3::melanoma$year8594))
    df2 <- transform(df2,risk_time=1)
    pred <- twoState(poisson7n, t=c(0,df$mid), newdata = df2, tmvar = "mid")
    ggplot(pred, aes(x=time,y=S,ymin=S.lower,ymax=S.upper,fill=year8594)) +
        ggplot2::geom_line() + ggplot2::geom_ribbon(alpha=0.6) +
        facet_grid(~agegrp) +
        xlab("Time since diagnosis (years)") +
        ylab("Survival")
} else cat("To run this example, please install the deSolve package\n")
    


## Additional random code

## q2.R
hazards <- by(melanoma, melanoma$stage,
              function(data) with(bshazard(Surv(surv_mm/12, death_cancer)~1,
                                           data=data, verbose=FALSE),
                                  data.frame(time,hazard,lower.ci,upper.ci))) |>
    array2DF()
with(hazards, plt(hazard~time|`melanoma$stage`, 
                  ymin=lower.ci, ymax=upper.ci, type="ribbon",
                  ylim=c(0,1), # bug -- not used
                  xlab="Time since diagnosis (years)", ylab="Hazard"))

## Purpose: To do the solution for Biostat III exercises in R
## Author: Annika Tillander, 2014-01-30
## Edited: Andreas Karlsson, 2015-02-28, 2016-03-08
## Edited: Mark Clements, 2017-08-07
###############################################################################

###############################################################################
## Exercise 3
###############################################################################
## @knitr loadDependencies
library(biostat3)
library(survival)
library(dplyr)    # for data manipulation
library(survminer) # for ggsurvplot
library(bshazard) # smooth hazards

## @knitr loadPreprocess
melanoma <- biostat3::melanoma |>
    subset(stage=="Localised") |>
    transform(death_cancer = ifelse(status == "Dead: cancer", 1, 0),
              death_all = ifelse(status == "Dead: cancer" |
                                 status == "Dead: other", 1, 0))

## @knitr a_survDiaDate
survfit(Surv(surv_mm/12, death_cancer==1) ~ year8594, data = melanoma) |>
    plot(col = 1:2,
         xlab = "Time since diagnosis (years)",
         ylab = "Survival",
         main = "Kaplan-Meier survival estimates")
legend("bottomleft", levels(melanoma$year8594), col=1:2, lty = 1)

## @knitr b_hazDiaDate
par(mfrow=1:2)
for(level in levels(melanoma$year8594))
    plot(bshazard(Surv(surv_mm/12,death_cancer)~1, subset(melanoma,year8594==level),
                  verbose=FALSE), main=level, xlim=c(0,20), ylim=c(0,0.1),
         xlab="Time since diagnosis\n(years)")

## @knitr b_hazDiaDate_ggplot
group_by(melanoma, year8594) |> 
    do(as.data.frame(bshazard(Surv(surv_mm/12, death_cancer)~1, data=., verbose=FALSE))) |>
    ungroup() |>
    ggplot(aes(x=time,y=hazard,group=year8594)) + geom_line(aes(col=year8594)) +
    geom_ribbon(aes(ymin=lower.ci, ymax=upper.ci, fill=year8594), alpha=0.3) +
    xlim(0,20) + ylim(0,0.1) + 
    xlab('Time since diagnosis (years)') + ylab('Hazard')

## @knitr c_testDiaDate
## Log-rank test for equality of survivor functions
survdiff(Surv(surv_mm, death_cancer) ~ year8594, data=melanoma)
## Equivalent to the Peto & Peto modfication of the Gehan-Wilcoxon test
survdiff(Surv(surv_mm, death_cancer) ~ year8594, data=melanoma, rho=1)

## @knitr d_crudeRates1000_agegrp
survRate(Surv(surv_mm/1000,death_cancer)~agegrp, data=melanoma)
## melanoma |>
##     select(death_cancer, surv_mm, year8594) |>
##     group_by(year8594) |>
##     summarise(D = sum(death_cancer), Y = sum(surv_mm)/1000, Rate = D/Y,
##               lower.ci = stats::poisson.test(D,Y)$conf.int[1],
##               upper.ci = stats::poisson.test(D,Y)$conf.int[2]) 

survfit(Surv(surv_mm, death_cancer) ~ agegrp, data = melanoma) |>
    plot(col = 1:4,
         xlab = "Months since diagnosis",
         ylab = "Survival",
         main = "Kaplan-Meier survival estimates")
legend("bottomleft", levels(melanoma$agegrp), col=1:4, lty = 1)

## @knitr e_crudeRates1000_agegrp
survfit(Surv(surv_mm/12, death_cancer) ~ agegrp, data = melanoma) |>
    plot(col = 1:4,
         xlab = "Years since diagnosis",
         ylab = "Survival",
         main = "Kaplan-Meier survival estimates")
legend("bottomleft", levels(melanoma$agegrp), col=1:4, lty = 1)


survRate(Surv(surv_mm/12/1000,death_cancer)~year8594, data=melanoma)

## @knitr f_sexDiff
aplot = function() {
    survfit(Surv(surv_mm/12, death_cancer) ~ sex, data = melanoma) |>
    plot(col = 1:2,
         xlab = "Time since diagnosis (years)",
         ylab = "Survival",
         main = "Kaplan-Meier survival estimates")
}
if (requireNamespace("muhaz", quietly=TRUE)) {
    par(mfrow=c(1, 2))
    aplot()
    plot(muhaz2(Surv(surv_mm/12,death_cancer)~sex, data=melanoma), lty=1,
         xlab="Time since diagnosis (years)")
} else {
    par(mfrow=c(1, 1))
    aplot()
    legend("bottomleft", legend=levels(melanoma$sex), lty=1, col=1:2)
}

## Log-rank test for equality of survivor functions
survdiff(Surv(surv_mm, death_cancer==1) ~ sex, data=melanoma)

## Purpose: To do the solution for Biostat III exercises in R
## Author: Annika Tillander, 2014-01-30
## Edited: Andreas Karlsson, 2015-02-28
## Edited: Mark Clements, 2017-08-07
###############################################################################

###############################################################################
## Exercise 4
###############################################################################
## @knitr loadDependencies
library(biostat3) 
library(knitr) # kable

## @knitr loadPreprocess
localised <- subset(biostat3::melanoma, stage=="Localised") |>
    transform(death_cancer = ifelse(status == "Dead: cancer", 1, 0))

## @knitr actuarialYears
lifetab2(Surv(floor(surv_yy),death_cancer)~1, data = localised)[,1:7] |>
    kable("html")

## @knitr actuarialMonths
lifetab2(Surv(floor(surv_mm),death_cancer)~1, data = localised)[110:130,1:7] |>
    kable("html")

## @knitr kmYears
mfit_years <- survfit(Surv(surv_yy, death_cancer) ~ 1, data = localised)
summary(mfit_years)

## @knitr kmMonths
mfit_months <- survfit(Surv(surv_mm/12, death_cancer) ~ 1, data = localised)
summary(mfit_months,times=(110:130)/12)

## @knitr comparisonPlot
plot(mfit_months, conf.int=FALSE,
     ylim=c(0.7,1), cex=5,
     xlab="Time from cancer diagnosis (years)",
     ylab="Survival")
survfit(Surv(surv_yy, death_cancer) ~ 1, data = localised) |>
    lines(col="red", conf.int=FALSE)
lifetab2(Surv(surv_mm/12,death_cancer)~1, data = localised) |>
    lines(col="orange")
lifetab2(Surv(floor(surv_yy),death_cancer)~1, data = localised) |>
    lines(col="green")
legend("topright",
       legend=c("KM (months)", "KM (years)", "Actuarial (months)", "Actuarial (years)"),
       lty=1,
       col=c("black", "red", "orange", "green"),
       bty="n")

## Date: 2015-03-04
## Purpose: To do the solution for Biostat III exercise 11 in R
## Author: Johan Zetterqvist
## Revised: Mark Clements 2017-11-03
###############################################################################

## Install needed packages only need to be done once
## install.packages("survival")
## install.packages("dplyr")
## install.packages("foreign")

###############################################################################
## Exercise 11
###############################################################################
## @knitr loadDependencies

library(biostat3) # 
library(dplyr)    # for data manipulation

## @knitr loadPreprocess

## Read melanoma data
## and select subcohorts
melanoma.l <- biostat3::melanoma |>
    subset(stage=="Localised") |>
    transform(
        ## Create a death indicator
        death_cancer = as.numeric(status=="Dead: cancer"),
        death_any = as.numeric(status=="Dead: cancer" | status=="Dead: other") )

## Truncate follow-up time

melanoma.l2 <-
  transform(melanoma.l,
            ## Create new death indicators (only count deaths within 120 months)
            death_cancer = death_cancer * as.numeric( surv_mm <= 120),
            death_any = death_any * as.numeric( surv_mm <= 120),
            ## Create a new time variable
            surv_mm = pmin(surv_mm, 120))

## @knitr 11.a

summary(coxfit11a <- coxph(Surv(surv_mm, death_any) ~ sex + year8594 + agegrp,
                           data = melanoma.l2))

## @knitr 11.b

summary( coxfit11b <- coxph(Surv(surv_mm, death_cancer) ~ sex + year8594 + agegrp,
                           data = melanoma.l2) )

## Purpose: To do the solution for Biostat III exercises in R
## Author: Andreas Karlsson, 2015-03-02
## Revised: Mark Clements, 2017-11-03
###############################################################################

###############################################################################
## Exercise 10
###############################################################################
## @knitr loadDependencies
library(biostat3)
library(bshazard)
library(car)      # car::linearHypothesis -> biostat3::lincom
library(tinyplot) # plt()

## @knitr loadPreprocess
localised <-
    subset(biostat3::melanoma, stage == "Localised") |>
    transform(death_cancer = ifelse( status == "Dead: cancer" & surv_mm <= 120, 1, 0), #censoring for > 120 months
           trunc_yy = pmin(surv_mm/12,10))  #scale to years and truncate to 10 years

## @knitr 10.a
# Using bshazard to smooth the Kaplan-Meier hazards by strata
hazDiaDate <- lapply(levels(localised$year8594),
                     function(level) bshazard(Surv(trunc_yy,death_cancer)~1, v=F,
                                              data=subset(localised, year8594==level)) |>
                                     with(data.frame(time,hazard,lower.ci,upper.ci,
                                                     year8594=level))) |>
    do.call(what=rbind)

## Comparing hazards
with(hazDiaDate, plt(hazard~time|year8594, ymin=lower.ci, ymax=upper.ci,
                     group=year8594,
                     type="ribbon",
                     xlab="Time since diagnosis (years)", 
                     ylab="Hazard"))
# or using ggplot2
library(ggplot2)
ggplot(hazDiaDate, aes(x=time, y=hazard, fill=year8594,
                       ymin=lower.ci, ymax=upper.ci)) +
    geom_line(aes(color=year8594)) +
    geom_ribbon(alpha=0.3) +
    xlab("Time since diagnosis (years)") +
    ylab("Hazard")


## @knitr 10.b
## Comparing hazards on a log scales
with(hazDiaDate, plt(hazard~time|year8594, ymin=lower.ci, ymax=upper.ci,
                     group=year8594,
                     log="y",
                     type="ribbon",
                     xlab="Time since diagnosis (years)", 
                     ylab="Hazard"))

## @knitr 10.c
survfit1 <- survfit(Surv(trunc_yy,death_cancer)~year8594, data=localised)
plot(survfit1, col=1:2, fun=function(S) -log(-log(S)), log="x",
     xlab="log(time)", ylab="-log(H)")
legend("topright",legend=levels(localised$year8594),col=1:2,lty=1)

## or we can use
biostat3::survPHplot(Surv(trunc_yy,death_cancer)~year8594, data=localised)

## @knitr 10.d
# Cox regression with time-since-entry as the timescale
# Note that R uses the Efron method for approximating the likelihood in the presence of ties
# whereas Stata (and some other software) use the Breslow method
cox1 <- coxph(Surv(trunc_yy, death_cancer==1) ~ year8594, data=localised)
summary(cox1)


## @knitr 10.e

cox2 <- coxph(Surv(trunc_yy, death_cancer==1) ~ sex + year8594 + agegrp, data=localised)
summary(cox2)

## Plot of the scaled Schoenfeld residuals for calendar period 1985–94.
## The smooth line shows the estimated log hazard ratio as a function of time.
cox2.phtest <- cox.zph(cox2, terms=FALSE) # for separate plots
print(cox2.phtest)
plot(cox2.phtest,var=2,resid=TRUE, se=TRUE, main="Schoenfeld residuals", ylim=c(-4,4))

## @knitr 10.f
par(mfrow=c(2,2))
for (var in 3:5)
    plot(cox2.phtest,var=var,resid=TRUE, se=TRUE, main="Schoenfeld residuals", ylim=c(-4,4))

## @knitr 10.g
## The results from the previous proportional hazards assumption test
print(cox.zph(cox2))

## @knitr 10.h
melanoma2p8Split <- survSplit(localised, cut=c(2), end="trunc_yy", start="start",
                              event="death_cancer", episode="fu") |>
    transform(fu = as.factor(fu))

##Tabulate ageband including risk_time
melanoma2p8Split |> subset(id<=3, select=c(id, start, trunc_yy))

head(melanoma2p8Split)

cox2p8Split1 <- coxph(Surv(start, trunc_yy, death_cancer) ~ sex + year8594 + agegrp*fu,
                      data=melanoma2p8Split)
summary(cox2p8Split1)

cox2p8Split1b <- coxph(Surv(start, trunc_yy, death_cancer) ~ sex + year8594 + agegrp +
                           I(agegrp=="45-59" & fu=="2") + I(agegrp=="60-74" & fu=="2") +
                           I(agegrp=="75+" & fu=="2"), data=melanoma2p8Split)
summary(cox2p8Split1b)


## @knitr 10.i
cox2p8Split2 <- coxph(Surv(start, trunc_yy, death_cancer) ~ sex + year8594 + fu +
                          fu:agegrp, data=melanoma2p8Split)
summary(cox2p8Split2)

## @knitr 10.ib

## Alternative approach using tt():
## http://cran.r-project.org/web/packages/survival/vignettes/timedep.pdf
cox2p8tvc2 <- coxph(Surv(trunc_yy, death_cancer) ~ sex + year8594 + agegrp +
                        tt(agegrp=="45-59") + tt(agegrp=="60-74") + tt(agegrp=="75+"),
                    data=localised,
                    tt = function(x, t, ...) x*(t>=2))
summary(cox2p8tvc2)
## The tt labels do not play nicely with lincom:(

cox2p8tvct <- coxph(Surv(trunc_yy, death_cancer) ~ sex + year8594 + agegrp + tt(agegrp),
                    data=localised,
                    tt = function(x, t, ...) cbind(`45-59`=(x=="45-59")*t,
                                                   `60-74`=(x=="60-74")*t,
                                                   `75+`=(x=="75+")*t))
summary(cox2p8tvct)
lincom(cox2p8tvct, "agegrp75+",eform=TRUE)                   # t=0
lincom(cox2p8tvct, "agegrp75+ + tt(agegrp)75+",eform=TRUE)   # t=1
lincom(cox2p8tvct, "agegrp75+ + 2*tt(agegrp)75+",eform=TRUE) # t=2

cox2p8tvclogt <- coxph(Surv(trunc_yy, death_cancer) ~ sex + year8594 + agegrp + 
                           tt(agegrp),
                       data=localised,
                    tt = function(x, t, ...) cbind(`45-59`=(x=="45-59")*log(t),
                                                   `60-74`=(x=="60-74")*log(t),
                                                   `75+`=(x=="75+")*log(t)))
summary(cox2p8tvclogt)
lincom(cox2p8tvclogt, "agegrp75+ - 0.6931472*tt(agegrp)75+",eform=TRUE) # t=0.5 => log(t)=-0.6931472
lincom(cox2p8tvclogt, "agegrp75+", eform=TRUE) # t=1 => log(t)=0
lincom(cox2p8tvclogt, "agegrp75+ + 0.6931472*tt(agegrp)75+",eform=TRUE) # t=2 => log(t)=0.6931472



## @knitr 10.j
library(splines) # ns
library(dplyr)   # mutate, group_by, summarise
library(rstpm2)  # predictnl
time.cuts <- seq(0,10,length=100)
delta <- diff(time.cuts)[1]
## split and collapse
melanoma2p8Split2 <- survSplit(Surv(trunc_yy,death_cancer)~., data=localised,
                               cut=time.cuts, end="tstop", start="tstart",
                               event="death_cancer") |>
    mutate(fu=cut(tstop,time.cuts),
           mid=time.cuts[unclass(fu)]+delta/2) |>
    group_by(mid,sex,year8594,agegrp) |>
    summarise(pt=sum(tstop-tstart), death_cancer=sum(death_cancer),
              .groups="keep") |>
    mutate(age75 = (agegrp=="75+")+0)
poisson2p8tvc <- glm(death_cancer ~ sex + year8594 + agegrp + ns(mid,df=3) +
                         age75:ns(mid,df=3) + offset(log(pt)),
                     data=melanoma2p8Split2, family=poisson)
newdata <- data.frame(mid=seq(0,max(time.cuts),length=100), year8594="Diagnosed 85-94",
                      sex="Male", agegrp="75+", age75=1, pt=1)
predictnl(poisson2p8tvc,
          fun=function(fit,newdata)
              predict(fit, newdata) -
              predict(fit, transform(newdata, agegrp='0-44', age75=0)),
          newdata=newdata) |>
    cbind(newdata) |>
    transform(RateRatio=exp(fit),
              lower.ci=exp(fit-1.96*se.fit),
              upper.ci=exp(fit+1.96*se.fit)) |>
    with(plt(mid, RateRatio, type="ribbon", xlab="Time since diagnosis (months)",
             ymin=lower.ci, ymax=upper.ci,
             ylab="Rate ratio", main="Ages 75+ compared with ages 0-44 years"))

summary(poisson2p8tvc)
newdata <- expand.grid(mid=c(0.5,2), year8594="Diagnosed 85-94",
                       sex="Male", agegrp=levels(localised$agegrp), pt=1) |>
    transform(age75=(agegrp=="75+")+0)
predictnl(poisson2p8tvc,
          fun=function(fit,newdata)
              predict(fit, newdata) -
              predict(fit, transform(newdata, agegrp='0-44', age75=0)),
          newdata=newdata) |>
    cbind(newdata) |>
    transform(RateRatio=exp(fit),
              lower.ci=exp(fit-1.96*se.fit),
              upper.ci=exp(fit+1.96*se.fit)) |>
    subset(select=c(agegrp, mid, RateRatio, lower.ci, upper.ci))

## Date: 2015-03-03
## Purpose: To do the solution for Biostat III exercises in R
## Author: Johan Zetterqvist
## Modified: Mark Clements, 2017-08-07, 2024-10-27
###############################################################################

###############################################################################
## Exercise 7
###############################################################################

## Install needed packages only need to be done once
## install.packages("foreign")
## install.packages("muhaz")
## install.packages("car")

## @knitr loadDependencies
library(biostat3)
library(dplyr)    # for data manipulation
library(car)      # for car::linearHypothesis -> biostat3::lincom
library(knitr)
library(broom)
options(pillar.sigfig = 5) # increase the number of digits printed in tibbles

## @knitr loadPreprocess
## Read melanoma data

## Create a new dataset with only localised cancer
melanoma.l <- subset(biostat3::melanoma, stage=="Localised")
head(melanoma.l)
summary(melanoma.l)

## @knitr 7.a.i

## Plot Kaplan-Meier curve using survfit
## Create a new event indicator
melanoma.l <- transform(melanoma.l,
                        death_cancer = as.numeric(status=="Dead: cancer") )

## Create a fitted object for our subcohort
## using survfit
sfit7a1 <- survfit(Surv(surv_mm, event=death_cancer) ~ year8594,
                   data = melanoma.l )

## Have a look at the fitted object
str(sfit7a1, 1)

## Plot the survival curve (with some bells and whistles)
plot(sfit7a1,
     ## No automatic labelling of the curve (we do that ourselves)
     mark.time=FALSE,
     ## Time is measured in months,  but we want to see it in years
     xscale=12,
     ## Make the plot prettier
     xlab="Years since diagnosis",
     ylab="S(t)",
     col=c("blue","red"),
     lty=c("solid","dashed"))
## Add legend too
legend("bottomleft",legend=levels(melanoma.l$year8594),col=c("blue","red"),
       lty=c("solid","dashed"), bty="n")

### TRY IF YOU WANT ###
if (FALSE) {
    library(survMisc)
    ## Note: `autoplot(sfit7a1)` was broken; I have submitted a pull request to fix this
    ## autoplot(sfit7a1)
    ## alternatively:
    autoplot(sfit7a1, timeTicks = "custom", times= seq(0, 20*12, 5*12))
}

## @knitr 7.a.ii

## To plot smoothed hazards, we use the bshazard package
library(bshazard)
par(mfrow=1:2)
for(level in levels(melanoma.l$year8594))
    plot(bshazard(Surv(surv_mm/12, status == "Dead: cancer") ~ 1,
                  data=subset(melanoma.l, year8594==level)),
         xlab="Years since diagnosis", main=level, xlim=c(0,20), ylim=c(0,0.08))

## @knitr 7.a.iii
## Compare with Kaplan-Meier plot
layout(matrix(c(1,1,2,3), 2, 2, byrow = TRUE))
plot(sfit7a1,
     ## No automatic labelling of the curve (we do that ourselves)
     mark.time=FALSE,
     ## Time is measured in months,  but we want to see it in years
     xscale=12,
     ylim=c(0.6,1),
     ## Make the plot prettier
     xlab="Years since diagnosis",
     ylab="S(t)",
     col=c("blue","red"),
     lty=c("solid","dashed"))
legend("bottomleft",legend=levels(melanoma.l$year8594),
       col=c("blue","red"),lty=c("solid","dashed"), bty="n")
cols = c("Diagnosed 75-84"="blue", "Diagnosed 85-94"="red")
ltys = c("Diagnosed 75-84"="solid", "Diagnosed 85-94"="dashed")
for(level in levels(melanoma.l$year8594))
    plot(bshazard(Surv(surv_mm/12, status == "Dead: cancer") ~ 1,
                  data=subset(melanoma.l, year8594==level),
                  verbose=FALSE),
         xlab="Years since diagnosis", main=level,
         xlim=c(0,22), ylim=c(0,0.08), col=cols[level],
         lty=ltys[level])

## @knitr 7.b
survRate(Surv(surv_mm/12, death_cancer) ~ year8594, data=melanoma.l) |>
    kable("html")


## @knitr 7.c.i

## Calculate the incidence rate by time of diagnosis
## but with new variables
melanoma.l2 <-
    transform(melanoma.l,
              ## Update the death indicator (only count deaths within 120 months)
              ## death_cancer = death_cancer * as.numeric(surv_mm<=120),
              death_cancer = ifelse(surv_mm<=120 & status == "Dead: cancer",1,0),
              ## Create a new time variable
              surv_mm = pmin(surv_mm,120))

## Calculate the rates on the truncated data
rates_by_diag_yr2 <- survRate(Surv(surv_mm, death_cancer) ~ year8594, data=melanoma.l2)
rates_by_diag_yr2 |> kable("html")

## @knitr 7.c.ii

## MRR full data
rates_by_diag_yr2[2, "rate"] / rates_by_diag_yr2[1, "rate"]
with(rates_by_diag_yr2[2:1,], poisson.test(event, tstop)) # reverse the row order:)

## @knitr 7.c.iii
## Use glm to estimate the rate ratios
## we scale the offset term to 1000 person-years
poisson7c <- glm(death_cancer ~ year8594 + offset(log(surv_mm/12/1000)),
                 family=poisson, data=melanoma.l2)
summary(poisson7c)

## also for collapsed data
summary(glm(event ~ year8594 + offset(log(tstop/12/1000)), family=poisson,
            data=rates_by_diag_yr2))

## IRR - using broom::tidy
tidy(poisson7c, conf.int=TRUE, exponentiate=TRUE)
## or (less generally)
biostat3::eform(poisson7c)

## Note that the scaling of the offset term only has an impact on the intercept
summary(glm(death_cancer ~ year8594 + offset(log(surv_mm)),
            family=poisson, data=melanoma.l2))

## @knitr 7.d

## Add a new variable for year
melanoma.l2 <- transform(melanoma.l2, surv_yy1 = surv_mm/12)

## Split follow up by year
melanoma.spl <- survSplit(melanoma.l2, cut=0:9, end="surv_yy1", start="start",
                           event="death_cancer")

## Calculate persontime and
## recode start time as a factor
melanoma.spl <- transform(melanoma.spl,
                          pt = surv_yy1 - start,
                          fu = as.factor(start) )

## @knitr 7.e

## Calculate the incidence rate by observation year
yearly_rates <- survRate(Surv(pt/1000,death_cancer)~fu, data=melanoma.spl) |>
    transform(start=as.numeric(levels(fu))[fu]) |>
    transform(mid=start+0.5)

library(tinyplot) # lightweight base graphics extension
with(yearly_rates, {
    plt(rate~start, ymin=lower, ymax=upper, type="ribbon",
        main="Cancer deaths by years since diagnosis",
        ylab="Incidence rate per 1000 person-years",
        xlab="Years since diagnosis")
})


## @knitr 7.f
# Plot smoothed hazards

library(bshazard)
library(tinyplot)
par(mfrow=1:2)
survRate(Surv(pt,death_cancer)~fu, data=melanoma.spl) |>
    transform(start=as.numeric(levels(fu))[fu]) |>
    transform(mid=start+0.5) |>
    with({
        plt(rate~mid, ymin=lower, ymax=upper,
            type="ribbon",
            main="Rates",
            ylab="Mortality rate per person-year",
            xlab="Years since diagnosis",
            xlim=c(0,10))
    })
bshazard(Surv(surv_mm/12, status == "Dead: cancer") ~ 1, data = melanoma.l) |>
    plot(xlab="Years since diagnosis", xlim=c(0,10),
         main="Smoothed hazard")
box() # redo the box around the plot

## @knitr 7.g
## Run Poisson regression
summary(poisson7g <- glm(death_cancer ~ fu + offset(log(pt)),
                         family = poisson,
                         data = melanoma.spl))
## IRR
## tidy(poisson7g, conf.int=TRUE, exponentiate=TRUE)
eform(poisson7g) # faster:)

## @knitr 7.h
summary(poisson7h <- glm( death_cancer ~ fu + year8594 + offset( log(pt) ),
                         family = poisson,
                         data = melanoma.spl ))
## IRR
## tidy(poisson7h, conf.int=TRUE, exponentiate=TRUE)
eform(poisson7h)

# Add interaction term
summary(poisson7h2 <- glm(death_cancer ~ fu*year8594 + offset(log(pt)),
                          family=poisson, data=melanoma.spl))
## IRR
## tidy(poisson7h2, conf.int=TRUE, exponentiate=TRUE)
eform(poisson7h2)

## @knitr 7.i

summary(poisson7i <- glm(death_cancer ~ fu + year8594 + sex + agegrp + offset(log(pt)),
                         family=poisson, data=melanoma.spl))

## IRR
## tidy(poisson7i, conf.int=TRUE, exponentiate=TRUE)
eform(poisson7i)

## Test if the effect of age is significant using a likelihood ratio test
drop1(poisson7i, ~agegrp, test="Chisq")
## For this we can also use the car package and a Wald test
linearHypothesis(poisson7i,c("agegrp45-59 = 0","agegrp60-74 = 0","agegrp75+ = 0"))
## ADVANCED:
## Alternative approach for the likelihood ratio test
# poisson7i_2 <- update(poisson7i,. ~ . - agegrp)
# anova(poisson7i_2,poisson7i,test="Chisq")

## @knitr 7.j

summary(poisson7j <- glm(death_cancer ~ fu + agegrp + year8594*sex + offset(log(pt)),
                         family=poisson, data=melanoma.spl))

## IRR
## tidy(poisson7j, conf.int=TRUE, exponentiate=TRUE)
eform(poisson7j)

## @knitr 7.k.i
# hand calculations
hz7k <- exp(coef(poisson7j))
hz7k["sexFemale"]
hz7k["sexFemale"]*hz7k["year8594Diagnosed 85-94:sexFemale"]

## @knitr 7.k.ii
## You will need the "car" package to use lincom. If it is not already installed:
## install.packages("car")
lincom(poisson7j,c("sexFemale + year8594Diagnosed 85-94:sexFemale"),eform=TRUE)


## @knitr 7.k.iii
## Create dummies and Poisson regression
melanoma.spl <- melanoma.spl |>
    ## Add confidence intervals for the rates
    transform(femaleEarly = sex=="Female" & year8594=="Diagnosed 75-84",
              femaleLate = sex=="Female" & year8594=="Diagnosed 85-94")

summary(poisson7k <- glm( death_cancer ~ fu + agegrp + year8594 + femaleEarly +
                         femaleLate + offset( log(pt) ), family=poisson,
                         data=melanoma.spl ))

## IRR
## tidy(poisson7k, conf.int=TRUE, exponentiate=TRUE)
eform(poisson7k)

## @knitr 7.k.iv
## Add interaction term
summary(poisson7k2 <- glm( death_cancer ~ fu + agegrp + year8594 + year8594:sex +
                         offset( log(pt) ), family=poisson,
                         data=melanoma.spl ))
## tidy(poisson7k2, conf.int=TRUE, exponentiate=TRUE)
eform(poisson7k2)

## @knitr 7.l

summary( poisson7l.early <- glm( death_cancer ~ fu + agegrp + sex + offset( log(pt) ),
                       family = poisson, data = melanoma.spl,
                       subset = year8594 == "Diagnosed 75-84" ) )
## tidy(poisson7l.early, conf.int=TRUE, exponentiate=TRUE)
eform(poisson7l.early)

summary( poisson7l.late <- glm( death_cancer ~ fu + agegrp + sex + offset( log(pt) ),
                       family = poisson, data = melanoma.spl,
                       subset = year8594 == "Diagnosed 85-94" ) )
## tidy(poisson7l.late, conf.int=TRUE, exponentiate=TRUE)
eform(poisson7l.late)

# compare with results in i
## tidy(poisson7i, conf.int=TRUE, exponentiate=TRUE)
eform(poisson7i)

# compare with results in j
## tidy(poisson7j, conf.int=TRUE, exponentiate=TRUE)
eform(poisson7j)


# Poisson-regression with effects specific for diagnose period
summary(poisson7l2 <- glm( death_cancer ~ fu + fu:year8594 + agegrp + agegrp:year8594
                          + sex*year8594 + offset( log(pt) ),
                          family=poisson, data=melanoma.spl ))
## tidy(poisson7l2, conf.int=TRUE, exponentiate=TRUE)
eform(poisson7l2)

## @knitr 7.m
## Split follow up by month
library(splines)
library(tinyplot)
time.cut <- seq(0,10,by=1/12)
nrow(biostat3::melanoma)
melanoma.spl2 <- survSplit(Surv(surv_mm/12,status=="Dead: cancer")~.,
                           data=biostat3::melanoma,
                           cut=time.cut,
                           subset=stage=="Localised") |>
    transform(mid=(tstop+tstart)/2, risk_time=tstop-tstart)
nrow(melanoma.spl2)
poisson7m <- glm(event ~ ns(mid,df=6) + agegrp + year8594 +
                     offset(log(risk_time)),
                 family=poisson,
                 data=melanoma.spl2)
df <- data.frame(agegrp="0-44", year8594="Diagnosed 75-84",
                 mid=time.cut[-1], risk_time=1)
pred <- predict(poisson7m, newdata=df, se.fit=TRUE)
qq <- qnorm(0.975)
df <- with(pred, transform(df,
                           fit=exp(fit), # parallel (not sequential:)
                           conf.low=exp(fit-qq*se.fit),
                           conf.high=exp(fit+qq*se.fit)))
## plot the rate at the baseline values
with(df, plt(fit~mid, ymin=conf.low, ymax=conf.high, type="ribbon",
     ylab="Rate", xlab="Time since diagnosis (years)",
     ylim=c(0,0.05)))

## @knitr 7.n
## using melanoma.spl2 and df from previous chunk
poisson7n <- glm(event ~ ns(mid,df=4) + agegrp + year8594 +
                     ifelse(year8594=="Diagnosed 85-94",1,0):ns(mid,df=3) +
                     offset(log(risk_time)),
                 family=poisson,
                 data=melanoma.spl2)
library(rstpm2)
library(tinyplot)
## get log(RR) confidence interval using predictnl (delta method)
df <- data.frame(agegrp="0-44", year8594="Diagnosed 75-84",
                 mid=time.cut[-1], risk_time=1)
predictnl(poisson7n, function(object)
    predict(object, newdata=transform(df, year8594="Diagnosed 85-94"), type="link") -
    predict(object, newdata=df, type="link")) |>
    cbind(df) |>
    as.data.frame() |>
    transform(fit = exp(fit),
              conf.low=exp(fit-1.96*se.fit),
              conf.high=exp(fit+1.96*se.fit)) |>
    with(plt(fit~mid, ymin=conf.low, ymax=conf.high, type="ribbon",
             xlab="Time since diagnosis (years)",
             ylab="Rate ratio"))

predictnl(poisson7n,
          function(object)
              predict(object, newdata=transform(df, year8594="Diagnosed 85-94"),
                      type="response") -
              predict(object, newdata=df, type="response")) |>
    cbind(df) |>
    transform(conf.low=fit-1.96*se.fit,
              conf.high=fit+1.96*se.fit) |>
    with(plt(fit~mid, ymin=conf.low, ymax=conf.high, type="ribbon",
             xlab="Time since diagnosis (years)",
             ylab="Rate difference"))

## @knitr 7.o
## Calculate survival from a smooth Poisson regression model 
if (requireNamespace("deSolve")) {
    twoState <- function(object, ...) {
        markov_msm(list(object),matrix(c(NA,1,NA,NA),2,byrow=TRUE), ...) |>
            as.data.frame() |>
            subset(state==1)
    }
    df3 <- expand.grid(agegrp=levels(biostat3::melanoma$agegrp),
                       year8594=levels(biostat3::melanoma$year8594)) |>
        transform(risk_time=1)
    library(tinyplot)
    twoState(poisson7n, t=c(0,time.cut), newdata = df3, tmvar = "mid") |>
        with(plt(P~time|year8594, ymin=P.lower,ymax=P.upper,
                 type="ribbon",facet=agegrp,
                 xlab="Time since diagnosis (years)",
                 ylab="Survival"))
} else cat("To run this example, please install the deSolve package\n")

## @knitr 7.o.b
if (requireNamespace("pracma")) {
library(tinyplot)
library(rstpm2)
library(pracma)
df3 <- with(biostat3::melanoma,
            expand.grid(agegrp=levels(agegrp),
                        year8594=levels(year8594))) |>
    transform(risk_time=1)
oneState <- function(object,newdata=df3) {
    f <- function(t,y)
        -y*predict(object, newdata=transform(newdata,mid=t), type="response")
    pracma::ode45(f, t0=0, y0=rep(1,nrow(newdata)), tfinal=10, hmax=0.1)
}
out0 = oneState(poisson7n, newdata=df3)
out = predictnl(poisson7n,
                function(object, newdata)
                    log(-log(as.vector(oneState(object, newdata)$y))),
                newdata=df3, conf.int=TRUE) |> # slow
    transform(fit=exp(-exp(fit)),
              conf.low=exp(-exp(fit-1.96*se.fit)),
              conf.high=exp(-exp(fit+1.96*se.fit))) |>
    cbind(with(biostat3::melanoma,
               expand.grid(mid=out0$t,
                           agegrp=levels(agegrp),
                           year8594=levels(year8594))))
with(out,plt(fit~mid|year8594,type="ribbon",facet=agegrp,
             ymin=conf.low, ymax=conf.high,
             xlab="Time since diagnosis (years)",
             ylab="Survival"))
} else cat("To run this example, please install the pracma package\n")

## Purpose: To do the solution for Biostat III exercises in R
## Author: Johan Zetterqvist, 2014-01-30
## Edited: Andreas Karlsson, 2015-03-01, 2016-03-08
## Edited: Mark Clements, 2017-08-07
###############################################################################

###############################################################################
## Exercise 6
###############################################################################
## @knitr loadDependencies
library(biostat3) # diet dataset
library(dplyr)    # for data manipulation
library(knitr)    # kable()
library(broom)    # tidy()

## @knitr loadPreprocess
head(diet) |> kable("html")
summary(diet) |> kable("html")

## @knitr 6a_ir
diet <- biostat3::diet

diet.ir6a <- survRate(Surv(y/1000,chd) ~ hieng, data=diet)
kable(diet.ir6a, "html")
## or
diet |>
    group_by(hieng) |>
    summarise(Event = sum(chd), Time = sum(y/1000), Rate = Event/Time,      # group sums
              lower.ci = poisson.test(Event,Time)$conf.int[1],
              upper.ci = poisson.test(Event,Time)$conf.int[2]) |> kable("html")

## @knitr 6a_ir_b
## IRR
with(diet.ir6a, poisson.test(event,tstop)) 
with(diet.ir6a, poisson.test(rev(event),rev(tstop)))

## @knitr 6b_ir
poisson6b <- glm(chd ~ hieng + offset( log(y/1000)), family=poisson, data=diet)
summary(poisson6b)
eform(poisson6b)
eform(poisson6b, method="Profile")
## using tidyverse...
tidy(poisson6b, conf.int=TRUE, exponentiate=TRUE)

## @knitr 6c_energyDist
hist(diet$energy, breaks=25, probability=TRUE, xlab="Energy (units)")
curve(dnorm(x, mean=mean(diet$energy), sd=sd(diet$energy)), col = "red", add=TRUE)
lines(density(diet$energy), col = "blue")
legend("topright", legend=c("Normal density","Smoothed density"),
       lty=1, col=c("red", "blue"), bty="n")
quantile(diet$energy, probs=c(0.01,0.05,0.1,0.25,0.5,0.75,0.90,0.95,0.99))
# For kurtosis and skewness, see package e1071

## @knitr 6d_engCat
diet <- transform(diet, eng3=cut(energy, breaks=c(1500,2500,3000,4500),
                                 labels=c("low","medium","high"), 
                                 right = FALSE))
cbind(Freq=table(diet$eng3),
      Prop=proportions(table(diet$eng3))) |> kable("html")


## @knitr 6e_irEng
## rates and IRRs
diet.ir6e <- survRate(Surv(y/1000,chd) ~ eng3, data=diet)
print(diet.ir6e)

# calculate IRR and confidence intervals
with(diet.ir6e, rate[eng3=="medium"] / rate[eng3=="low"])
with(diet.ir6e[c(2,1),], { # compare second row with first row
  poisson.test(event, tstop)
})
with(diet.ir6e, rate[eng3=="high"] / rate[eng3=="low"])
with(diet.ir6e[c(3,1),], { # compare third row with first row
  poisson.test(event, tstop)
})


## @knitr 6f_irEng
diet <- transform(diet, 
                  X1 = as.numeric(eng3 == "low"),
                  X2 = as.numeric(eng3 == "medium"),
                  X3 = as.numeric(eng3 == "high"))
## or (names eng3low, eng3medium and eng3high)
diet = cbind(diet, model.matrix(~eng3+0, diet))
colSums(diet[c("X1","X2","X3","eng3low","eng3medium","eng3high")])

## @knitr 6g_irEng
subset(diet, eng3=="low", select=c(energy,eng3,X1,X2,X3)) |> head() |> kable("html")
subset(diet, eng3=="medium", select=c(energy,eng3,X1,X2,X3)) |> head() |> kable("html")
subset(diet, eng3=="high", select=c(energy,eng3,X1,X2,X3)) |> head() |> kable("html")

## @knitr 6h
poisson6h <- glm(chd ~ X2 + X3 + offset(log(y/1000)), family=poisson, data=diet)
summary(poisson6h)
tidy(poisson6h, conf.int=TRUE, exponentiate=TRUE)

## @knitr 6i
poisson6i <- glm(chd ~ X1 + X3 + offset(log(y/1000)), family=poisson, data=diet)
# or 
poisson6i <- glm(chd ~ I(eng3=="low") + I(eng3=="high") + offset(log(y/1000)),
                 family=poisson, data=diet)
summary(poisson6i)
tidy(poisson6i, conf.int=TRUE, exponentiate=TRUE)

## @knitr 6j
poisson6j <- glm(chd ~ eng3 + offset(log(y/1000)), family=poisson, data=diet)
summary(poisson6j)
tidy(poisson6j, conf.int=TRUE, exponentiate=TRUE)

## @knitr 6k
summarise(diet, rate = sum(chd) / sum(y))
## or
survRate(Surv(y/1000,chd)~1, data=diet)

#! /usr/bin/Rscript
library(httpuv)
setwd("~/src/R/biostat3/inst/doc")
runServer(
  host = "127.0.0.1", port = 8080,
  app = list(
    staticPaths = list(
      "/" = staticPath(
        ".",
        headers = list(
          "Cross-Origin-Opener-Policy" = "same-origin",
          "Cross-Origin-Embedder-Policy" = "require-corp"
        )
      )
    )
  )
)

## Purpose: To do the solution for Biostat III exercises in R
## Author: Annika Tillander, 2014-01-30
## Edited: Andreas Karlsson, 2015-02-24, 2016-03-07
## Edited: Mark Clements, 2017-08-02
###############################################################################

###############################################################################
## Exercise 2
###############################################################################
## @knitr loadDependencies
library(biostat3) # loads the survival and muhaz packages
library(dplyr)    # for data manipulation
library(bshazard) # for smoothed hazards
library(knitr)    # for html tables
library(tinyplot) # plt() for nicer base graphics
## utility function
as.data.frame.bshazard <- function(x, ...)
    with(x, data.frame(time,hazard,lower.ci,upper.ci))

## @knitr loadPreprocess
## Create 0/1 outcome variables and then show first six rows of the dataset
melanoma <- 
    transform(biostat3::melanoma,
              death_cancer = ifelse(status == "Dead: cancer", 1, 0),
              death_all = ifelse(status %in% c("Dead: cancer", "Dead: other"), 1, 0))
head(melanoma) |> knitr::kable("html")

## @knitr a_tabulate
## Tabulate by stage
Freq <- xtabs(~stage, data=melanoma)
cbind(Freq, Prop=proportions(Freq)) |> kable("html")

## @knitr a_plotSurv
survfit(Surv(surv_mm/12, death_cancer) ~ stage, data = melanoma) |>
    plot(col=1:4,
         xlab = "Time since diagnosis (years)",
         ylab = "Survival")
legend("topright", levels(melanoma$stage), col=1:4, lty = 1)

## @knitr a_plotHazard
library(dplyr)
hazards <- group_by(melanoma, stage) |> 
    do(as.data.frame(bshazard(Surv(surv_mm/12, death_cancer)~1, data=., verbose=FALSE))) |>
    ungroup()
with(hazards, plt(hazard~time|stage, ymin=lower.ci, ymax=upper.ci,
                  type="ribbon",
                  xlab="Time since diagnosis (years)",
                  ylab="Hazard",
                  col=1:4, lty=1, xlim=c(0,20), ylim=0:1))
ggplot(hazards,aes(x=time,y=hazard,group=stage)) + geom_line(aes(col=stage)) +
    geom_ribbon(aes(ymin=lower.ci, ymax=upper.ci, fill=stage), alpha=0.3) +
    xlim(0,20) + ylim(0,1) + 
    xlab('Time since diagnosis (years)') + ylab('Hazard')

## @knitr b_crudeRates
survRate(Surv(surv_mm/12, death_cancer) ~ stage, data=melanoma) |> kable("html")

## @knitr b2_crudeRates
library(dplyr)
melanoma |>
    group_by(stage) |>
    summarise(D = sum(death_cancer), M = sum(surv_mm/12), Rate = D/M,
              CI_low = stats::poisson.test(D,M)$conf.int[1],
              CI_high = stats::poisson.test(D,M)$conf.int[2]) |>
    kable("html")

## @knitr c_crudeRates1000
survRate(Surv(surv_mm/12/1000, death_cancer) ~ stage, data=melanoma) |>
    kable("html")

## @knitr d_crudeRates1000_sex
survRate(Surv(surv_mm/12/1000, death_cancer) ~ sex, data=melanoma) |>
    kable("html")

## @knitr d_plotSurv_sex
survfit(Surv(surv_mm/12, death_cancer) ~ sex, data = melanoma) |>
    plot(col=1:2,
         xlab = "Time since diagnosis (years)",
         ylab = "Survival")
legend("topright", legend=levels(melanoma$sex), lty=1, col=1:2)

library(dplyr)
hazards <- group_by(melanoma, sex) |> 
    do(as.data.frame(bshazard(Surv(surv_mm/12, death_cancer)~1, data=., verbose=FALSE))) |>
    ungroup()
with(hazards, plt(hazard~time|sex, ymin=lower.ci, ymax=upper.ci,
                  type="ribbon",
                  xlab="Time since diagnosis (years)",
                  ylab="Hazard",
                  col=1:2, lty=1, xlim=c(0,20)))

## @knitr e_tabByAge
Freq <- xtabs(~status+agegrp, melanoma)
Freq
round(proportions(Freq,"agegrp")*100,1) # proportions for status by agegrp
chisq.test(Freq[-4,])

## @knitr f_survStage
par(mfrow=c(1, 1))
survfit(Surv(surv_mm/12, death_all) ~ stage, data = melanoma) |>
    plot(col=1:4,
         xlab = "Time since diagnosis (years)",
         ylab = "Survival",
         main = "Kaplan-Meier survival estimates\nAll-cause")
legend("topright", levels(melanoma$stage), col=1:4, lty = 1)

## @knitr g_allCa75p
par(mfrow=c(1, 2))
survfit(Surv(surv_mm/12, death_cancer) ~ stage, data = subset(melanoma,agegrp=="75+")) |>
    plot(col=1:4,
         xlab = "Time since diagnosis (years)",
         ylab = "Survival",
         main = "Kaplan-Meier survival estimates\nCancer | Age 75+")
survfit(Surv(surv_mm/12, death_all) ~ stage, data = subset(melanoma,agegrp=="75+")) |>
    plot(col=1:4,
         xlab = "Time since diagnosis (years)",
         ylab = "Survival",
         main = "Kaplan-Meier survival estimates\nAll-cause | Age 75+")
legend("topright", levels(melanoma$stage), col=1:4, lty = 1)

## @knitr h_allCaAgeGrp
par(mfrow=c(1, 2))
survfit(Surv(surv_mm/12, death_cancer) ~ agegrp, data = melanoma) |>
    plot(col=1:4,
         xlab = "Time since diagnosis (years)",
         ylab = "Survival",
         main = "Kaplan-Meier estimates of\ncancer survival by age group")
survfit(Surv(surv_mm/12, death_all) ~ agegrp, data = melanoma) |>
    plot(col=1:4,
         xlab = "Time since diagnois",
         ylab = "Survival",
         main = "Kaplan-Meier estimates of\nall-cause survival by age group")
legend("topright", levels(melanoma$agegrp), col=1:4, lty = 1)

## Purpose: To do the solution for Biostat III exercises in R
## Author: Johan Zetterqvist, 2014-01-30
## Edited: Andreas Karlsson, 2015-03-01
##         Benedicte Delcoigne, 2015-03-03
##         Mark Clements, 2017-11-05
###############################################################################


###############################################################################
## Exercise 8
###############################################################################
## @knitr loadDependencies
library(biostat3) 
library(bshazard)  # for bshazard
library(knitr)     # kable
library(broom)     # tidy

## @knitr loadPreprocess
diet <- transform(biostat3::diet, bmi = weight/((height/100)^2))
head(diet) |> kable("html")

## @knitr 8a1_Haz_att_age
scale <- 365.24
plot(bshazard(Surv((doe - dob)/scale, (dox - dob)/scale, chd) ~ 1,
              verbose=FALSE,
              data=subset(diet,hieng=="low")),
     ylim=c(0,0.03), conf.int=FALSE, xlab="Attained age (years)")
lines(bshazard(Surv((doe - dob)/scale, (dox - dob)/scale, chd) ~ 1,
               verbose=FALSE,
               data=subset(diet,hieng=="high")),
      col="red", conf.int=FALSE)
legend("topleft", legend=c('hieng=="low"','hieng=="high"'), col=1:2, lty=1, bty="n")

par(mfrow=1:2)
for (level in levels(diet$hieng))
    plot(bshazard(Surv((doe - dob)/scale, (dox - dob)/scale, chd) ~ 1,
                  verbose=FALSE,
                  data=subset(diet,hieng==level)),
         ylim=c(0,0.03), xlab="Attained age (years)",
         main=sprintf('hieng == "%s"', level))

## @knitr 8a2_Haz_time_entry
if (requireNamespace("muhaz")) {
    scale <- 365.24
    plot(muhaz2(Surv((dox - doe)/scale, chd) ~ hieng, data=diet), lty=2,
         xlab="Time since study entry (years)", ylim=c(0,0.025),
         legend=FALSE)
    lines(bshazard(Surv((dox - doe)/scale, chd) ~ 1, v=F, data=subset(diet,hieng=="low")),
          conf.int=FALSE)
    lines(bshazard(Surv((dox - doe)/scale, chd) ~ 1, v=F, data=subset(diet,hieng=="high")),
          col="red", conf.int=FALSE)
    legend("topleft", legend=c('hieng=="low" (bshazard)','hieng=="high" (bshazard)',
                               'hieng=="low" (muhaz)','hieng=="high" (muhaz)'),
           col=1:2, lty=c(1,1,2,2), bty="n")
} 

scale <- 365.24
par(mfrow=1:2)
for (level in levels(diet$hieng))
    plot(bshazard(Surv((dox - doe)/scale, chd) ~ 1,
                  verbose=FALSE,
                  data=subset(diet,hieng==level)),
         ylim=c(0,0.03), xlab="Time since study entry (years)",
         main=sprintf('hieng == "%s"', level))

## @knitr 8b_ir
poisson8b <- glm(chd ~ hieng + offset(log(y/1000)), family=poisson, data=diet)
summary(poisson8b)
broom::tidy(poisson8b, conf.int=TRUE, exponentiate=TRUE) # tidyverse (profile-based CIs)
biostat3::eform(poisson8b) # Wald-based CIs


## @knitr 8c_ir
## Create BMI variable
diet <- transform(diet, bmi=weight/((height/100)^2))

## Create orderly varable instead of categorical, start at zero
levels(diet$job)
diet <- transform(diet, jobNumber = unclass(job) - 1)

poisson8c <- glm(chd ~ hieng + jobNumber + bmi + offset(log(y/1000)),
                 family=poisson, data=diet)
summary(poisson8c)
eform(poisson8c)

##########################################################

## @knitr 8d_agebands

## Split time at 30,50,60 and 72 with time scale age at entry to attained age
scale <- 365.24
age.cuts <- c(30,50,60,72)
diet.spl.dob <- survSplit(Surv((doe - dob)/scale, (dox - dob)/scale, chd) ~ .,
                          data=diet, cut=age.cuts,start="tstart",end="tstop")


## Tabulate ageband
diet.spl.dob |> subset(id<=3, select=c(id, tstart, tstop, y))

## Create an agespan variable
diet.spl.dob <- transform(diet.spl.dob,
                          agespan = cut(tstop, age.cuts))

## Make the numeric variables factors since we want to model them with dummie variables and calculate time at risk
diet.spl.dob <- transform(diet.spl.dob,
                          jobNumber = as.factor(jobNumber),
                          risk_time = (tstop-tstart))

## Tabulate ageband including risk_time
diet.spl.dob |> subset(id<=3, select=c(id,  tstart, tstop, y,risk_time))


## Tabulate number of events per agespan
xtabs(~agespan+chd,diet.spl.dob)

## @knitr 8d_model1
poisson8d <- glm( chd ~ hieng + agespan + offset( log( risk_time) ),
                 family=poisson,
                 data=diet.spl.dob)

summary(poisson8d)
eform(poisson8d)

## @knitr 8d_model2
poisson8d <- glm( chd ~ hieng + agespan + jobNumber + bmi + offset( log( risk_time) ),
                 family=poisson,
                 data=diet.spl.dob)

summary(poisson8d)
eform(poisson8d)

## @knitr 8.e.i
time.cuts <- c(0, 5, 10, 15, 22)
diet.spl.t_entry <- survSplit(Surv((dox-doe)/365.24, chd) ~ ., data=diet,
                              cut=time.cuts, end="tstop", start="tstart", event="chd")

##Tabulate ageband
diet.spl.t_entry |> subset(id<=3, select=c(id, tstart, tstop, y))

diet.spl.t_entry <-
    transform(diet.spl.t_entry,
              fu = cut(tstop, time.cuts),
              risk_time = (tstop-tstart))

##Tabulate ageband including risk_time
diet.spl.t_entry |> subset(id<=3, select=c(id, fu, tstart, y, risk_time))

poisson8e1 <- glm(chd ~ fu + hieng + offset(log(risk_time)),
                 family=poisson,
                 data=diet.spl.t_entry)
summary(poisson8e1)
eform(poisson8e1)

## @knitr 8.e.ii
poisson8e2 <- glm(chd ~ fu + hieng + job + bmi + offset(log(risk_time)),
                 family=poisson,
                 data=diet.spl.t_entry)
summary(poisson8e2)
eform(poisson8e2)

## Purpose: To do the solution for Biostat III exercises in R
## Author: Annika Tillander, 2014-01-30
## Edited: Andreas Karlsson, 2015-02-17, 2016-03-01
## Edited: Mark Clements, 2017-08-02
###############################################################################

###############################################################################
## Exercise 1b
###############################################################################

## @knitr loadDependencies
library(biostat3)
library(survminer)
library(knitr)

## @knitr printData
kable(biostat3::colon_sample, "html")

## @knitr lifeTable
lifetab2(Surv(floor(surv_yy), status == "Dead: cancer")~1,
         colon_sample, breaks=0:10) |>
    kable("html", digits=2)

## @knitr KaplanMeier
mfit <- survfit(Surv(surv_mm/12, status == "Dead: cancer") ~ 1,
                data = colon_sample) # make Kaplan-Meier estimates
summary(mfit) # print Kaplan-Meier table
plot(mfit,    # plot Kaplan-Meier curve
     ylab="S(t)",
     xlab="Time since diagnosis (years)",
     main = "Kaplan−Meier estimates of cause−specific survival")

ggsurvplot(mfit, # plot Kaplan-Meier curve
     ylab="S(t)",
     xlab="Time since diagnosis (years)",
     main = "Kaplan−Meier estimates of cause−specific survival",
     risk.table = TRUE,
     conf.int = TRUE,
     ggtheme = theme_minimal())

---
title: "Biostatistics III in R"
author:
- Code by Mark Clements
output:
  prettydoc::html_pretty:
    mathjax: https://biostat3.net/js/mathjax/tex-chtml.js
    theme: cayman
    highlight: github
---

# Exercise 23. Calculating SMRs/SIRs #

-----------

```{r setup, cache=FALSE, message=FALSE, echo=FALSE}
library('knitr')
read_chunk('../q23.R')
opts_chunk$set(cache=FALSE)
```

```{r loadDependencies, message=FALSE}
```

```{r loadPreprocess, results='hide'}
```


## (a) ##

```{r 23.a1}
```

```{r 23.a2}
```

## (b) ##

```{r 23.b1}
```

```{r 23.b2}
```

## (c) ##


```{r 23.c1}
```

```{r 23.c2}
```

```{r 23.c3}
```

## (d) ##


```{r 23.d}
```

## (e) ##

		
```{r 23.e1}
```

```{r 23.e2}
```

```{r 23.e3}
```

```{r 23.e4}
```

## (f) ##


```{r 23.f1, results='asis'}
```

```{r 23.f2, results='asis'}
```

```{r 23.f3, results='asis'}
```

```{r 23.f4, results='asis'}
```

```{r 23.f5}
```

## (g) ##

```{r 23.g1}
```

```{r 23.g2}
```

---
title: "Biostatistics III in R"
author:
- Code by Bénédicte Delcoigne and Mark Clements
output:
  prettydoc::html_pretty:
    theme: cayman
    highlight: github
---

# Exercise 25. Localised melanoma : generating and analysing a nested case-control (NCC) study #

-----------

```{r setup, cache=FALSE, message=FALSE, echo=FALSE}
library('knitr')
read_chunk('../q25.R')
opts_chunk$set(cache=FALSE)
```

You may have to install the required packages the first time you use them. You can install a package by `install.packages("package_of_interest")` for each package you require.

```{r loadDependencies, message=FALSE}
```
Load the melanoma data. Restrict the data to the localised status of the melanoma and to the 10 firts years of follow-up. Use the time-on-study as the timescale. define the event as death from cancer.

```{r loadPreprocess, results='hide'}
```

The Cox proportional hazard analysis is done thanks to the "coxph" command in the "survival" package. It is often a good idea to check first the structure of the variables.

```{r ex_25_coxph,  message=FALSE, warning=FALSE, results='hide'}
```

## (a) ## 
How many individuals are in the study?

```{r  n_ind,  message=FALSE, warning=FALSE, results='hide'}
```

## (b) ## 
How many experience the event?

```{r  n_event,  message=FALSE, warning=FALSE, results='hide'}
```

## (c1) ## 
Generate  a nested case-control study with 1 control per case. Cases and controls are matched on time since entry. This is done by using the function "cwcc" in the Epi package. Note that in the codes provided here, the variables "dc" and "id" are not necessary. They permit however to understand how the data are handled as for eample: how many individuals are sampled several times or how many cases happened to be sampled as controls before their failure time.

```{r gen_ncc,  message=FALSE, warning=FALSE, results='hide'}
```

## (c2) ## 
Analyse the nested case-control data (with the survival package or the Epi package) and function "clogit". As the ncc data was generated with the Epi package, we use the syntax of this package.

```{r clogit,  message=FALSE, warning=FALSE, results='hide'}
```

## (d) ## 
How many unique individuals are in our study?

```{r n_unique_ncc,  message=FALSE, warning=FALSE, results='hide'}
```

## (e) ## 
Compare the estimated parameters and standard errors between the full cohort anal-
ysis and the nested case-control study. What is the relative efficiency (ratio of vari-
ances) of the nested case-control compared to the full cohort design?

```{r compare_coh_ncc,  message=FALSE, warning=FALSE, results='hide'}
```

## (f) ## 
Generate several nested case-control study and analyse them. A loop is generated with M sampling of NCC with 1 control per case. The codes provide the estimated HR for each loop i an data frame in which the first line contains the cohort's HR. The codes provide also a summary table with the cohort's HR and the mean and sd of the HR provided by the M loops. The histograms for each of the variables include a green vertical line at the cohort's HR value and a red line at the HR loops' mean.

```{r loop_ncc,  message=FALSE, warning=FALSE, results='hide'}
```

---
title: "Biostatistics III in R"
author:
- Code by Mark Clements
output:
  prettydoc::html_pretty:
    theme: cayman
    highlight: github
---


# Exercise 14. Non-collapsibility of proportional hazards models #

-----------

We simulate for time-to-event data assuming _constant hazards_ and then investigate whether we can estimate the underlying parameters. Note that the binary variable $X$ is essentially a coin toss and we have used a large variance for the normally distributed $U$. 

```{r setup, cache=FALSE, message=FALSE, echo=FALSE}
library('knitr')
read_chunk('../q14.R')
opts_chunk$set(cache=FALSE)
```

You may have to install the required packages the first time you use them. You can install a package by `install.packages("package_of_interest")` for each package you require.

```{r loadDependencies, message=FALSE}
```

<!-- We can use `dagitty` to graph the causal diagram:  -->
<!-- ```{r 14.dag} -->
<!-- ``` -->

The assumed causal diagram is reproduced below: 

```{r,engine='tikz',fig.ext='svg',fig.width=3,echo=FALSE}
    \usetikzlibrary{arrows,decorations.pathmorphing,backgrounds,positioning,fit,petri,matrix}
    \begin{tikzpicture}[->,bend angle=20,semithick,>=stealth']
      \matrix [matrix of nodes,row sep=10mm, column sep=15mm]
      {
        |(X)| $X$ & |(C)| $C$ \\
        & |(T)| $T$ & |(Y)| $(Y,\Delta)$ \\
        |(U)| $U$ \\
      };
      \begin{scope}[every node/.style={auto}]
        \draw (X) to node[anchor=south] {1} (T);
        \draw (U) to node[anchor=south] {1} (T);
        \draw (T) to node[anchor=north] {} (Y);
        \draw (C) to node[anchor=north] {} (Y);
      \end{scope}
    \end{tikzpicture}
```


```{r 14.simulate}
```

## (a) Fitting models with both $X$ and $U$ ## 

For constant hazards, we can fit (i) Poisson regression, (ii) Cox regression and (iii) flexible parametric survival models. With both covariates, these models are expected to estimate the parameters for $X$ and $U$, with values close to 1:

```{r 14.a}
```

If we fit a time-varying hazard ratio for $X$, we see that the hazard ratio looks reasonably constant.

```{r 14.tvc.xu}
```

## (b) Fitting models with only $X$ ## 

We now model by excluding the variable $U$. This variable could be excluded when it is not measured or perhaps when the variable is not considered to be a confounding variable -- from the causal diagram, the two variables $X$ and $U$ are not correlated and are only connected through the time variable $T$.

```{r 14.b}
```

```{r 14.b.2}
```

We clearly see that the estimate for $X$ is different in the models without $U$. If we now allow the the hazard ratio to vary by time:

```{r 14.tvc.x}
```

We see that the hazard ratio is clearly time-varying, starting at an initial value at time = 0 of close to exp(1), but then declining rapidly. As discussed in class, this is an example of _unmeasured heterogeneity_, which is a normal _random effect_ or, in this context, a log-normal _frailty_. Initially, there is no selection in the at-risk population, and the estimated marginal hazard ratio from the model without $U$ is similar to the conditional hazrd ratio from the model that adjusts for $U$. However, at later times, the at-risk population has been selected for those with a smaller frailty (because they were less likely to have had the event), and for a log-normal frailty the marginal hazard ratio is attenuated towards 1.

Let us stress that _$U$ is not a confounder_. The issue is that fitting proportional hazards models with unmodelled heterogeneity for variables that are not confounders can lead to time-varying hazard ratios -- and marginal estimates that do not have a causal interpretation. 

## (c) Rarer outcomes ## 

We now simulate for rarer outcomes by changing the censoring distribution. 

```{r 14.simulate.2}
```

```{r 14.b, results='hide'}
```

```{r 14.b.2}
```

For rarer outcomes, the marginal estimates that do not model for $U$ are closer to the conditional estimates that have modelled for $U$.


## (d) Less heterogeneity ## 

We now simulate for less heterogeneity by changing the reducing the standard deviation for the random effect $U$ from 3 to 1. 

```{r 14.simulate.3}
```

```{r 14.b, results='hide'}
```

```{r 14.b.2}
```

The marginal estimates are now much closer to the conditional estimates. For little or no heterogeneity, the marginal and conditional estimates would be very similar.

## (e) Accelerated failure time models ##

We re-run the baseline simulations:

```{r 14.simulate, results='hide'}
```

The accelerated failure time models have the form $S(t|x,u)=S_0(t/\exp( \beta_1 x + \beta_2 u))$, where the function $S_0(t)$ is expressed in terms of splines. For an exponential distribution, the hazard ratio is equal to the inverse of the ratio of the means --- so we expect values of $-1$ for $x$ and $u$. 

```{r 14.aft}
```

We see that the model with both $x$ and $u$ estimates values are very close to $-1$ --- which is as expected. Importantly, the model with only $x$ also estimates a value close to $-1$, which shows that the acclerated failure time models are robust to omitted covariates. The standard error for $x$ was smaller in the model with both $x$ and $u$ compared with that for the model with only $x$.

---
title: "Biostatistics III in R"
author:
- Code by Johan Zetterqvist and Mark Clements
output:
  prettydoc::html_pretty:
    theme: cayman
    highlight: github
---

# Exercise 11. Cox regression with all-cause mortality as the outcome #


Now fit a model to the localised melanoma data where the outcome is observed survival (i.e. all deaths are considered to be events).

```{r setup, cache=FALSE, message=FALSE, echo=FALSE}
library('knitr')
read_chunk('../q11.R')
opts_chunk$set(cache=FALSE)
```

You may have to install the required packages the first time you use them. You can install a package by `install.packages("package_of_interest")` for each package you require.

```{r loadDependencies, message=FALSE}
```
Load the melanoma data and explore it.

```{r loadPreprocess, results='hide', eval=FALSE}
```

## (a) ## 

Interpret the estimated hazard ratio for the parameter labelled `agegrp60-74`, including a comment on statistical significance.


```{r 11.a, warning=FALSE, results='hide', eval=FALSE}
```

Write out the regression equation. Using the regression equation, write out a formula for the hazard ratio for a male aged 60--74 years compared with a female aged 75 years or over.

## (b) ## 

On comparing the estimates between the observed and cause-specific survival models it appears that only the parameters for age have changed substantially. Can you explain why the estimates for the effect of age would be expected to change more than the estimates of the effect of sex and period?

```{r 11.b, warning=FALSE, results='hide', eval=FALSE}
```

---
title: "Biostatistics III in R"
author:
- Code by Mark Clements
format:
  html:
    minimal: true
filters:
  - webr
execute:
  echo: true
  message: false
  cache: false
  fig-width: 7
  fig-height: 6
---


# Exercise 14. Non-collapsibility of proportional hazards models #

-----------

We simulate for time-to-event data assuming _constant hazards_ and then investigate whether we can estimate the underlying parameters. Note that the binary variable $X$ is essentially a coin toss and we have used a large variance for the normally distributed $U$. 

You may have to install the required packages the first time you use them. You can install a package by `install.packages("package_of_interest")` for each package you require.

```{webr-r}
#| autorun: true
library(survival) # coxph
library(rstpm2) # stpm2
```

The assumed causal diagram is reproduced below: 

```{r,engine='tikz',fig.ext='svg',fig.width=3,echo=FALSE}
    \usetikzlibrary{arrows,decorations.pathmorphing,backgrounds,positioning,fit,petri,matrix}
    \begin{tikzpicture}[->,bend angle=20,semithick,>=stealth']
      \matrix [matrix of nodes,row sep=10mm, column sep=15mm]
      {
        |(X)| $X$ & |(C)| $C$ \\
        & |(T)| $T$ & |(Y)| $(Y,\Delta)$ \\
        |(U)| $U$ \\
      };
      \begin{scope}[every node/.style={auto}]
        \draw (X) to node[anchor=south] {1} (T);
        \draw (U) to node[anchor=south] {1} (T);
        \draw (T) to node[anchor=north] {} (Y);
        \draw (C) to node[anchor=north] {} (Y);
      \end{scope}
    \end{tikzpicture}
```

<!-- We can also use `dagitty` to graph the causal diagram (if this is available): -->
<!-- ```{webr-r} -->
<!-- if (requireNamespace("dagitty")) { -->
<!--     g1 <- dagitty::dagitty( "dag { -->
<!--     X -> T -> \"(Y,Delta)\" -->
<!--     U -> T -->
<!--     C -> \"(Y,Delta)\" -->
<!-- }") -->
<!--     plot(graphLayout(g1)) -->
<!-- } -->
<!-- ``` -->


```{webr-r}
#| autorun: true
set.seed(12345)
d <- local({
    n <- 1e4
    x <- rbinom(n, 1, 0.5)
    u <- rnorm(n, 0, 3)
    t <- rexp(n, exp(-5+x+u))
    c <- runif(n, 0, 10)
    y <- pmin(t, c)
    delta <- (t < c)
    data.frame(y,x,u,delta)
})
head(d)
```

## (a) Fitting models with both $X$ and $U$ ## 

For constant hazards, we can fit (i) Poisson regression, (ii) Cox regression and (iii) flexible parametric survival models. 

```{webr-r}
summary(fit1 <- glm(delta~x+u+offset(log(y)),data=d,family=poisson))
summary(fit2 <- coxph(Surv(y,delta)~x+u,data=d))
summary(fit3 <- stpm2(Surv(y,delta)~x+u,data=d,df=4))
rbind(glm=coef(summary(fit1))["x",c("Estimate","Std. Error")],
      coxph=coef(summary(fit2))["x",c("coef","se(coef)")],
      stpm2=coef(summary(fit3))["x",c("Estimate","Std. Error")])
```

It may be useful to investigate whether the hazard ratio for $X$ is time-varying hazard ratio and the form for survival.

```{webr-r}
library(ggplot2)
fit <- stpm2(Surv(y,delta)~x+u,data=d,df=4, tvc=list(x=2)) # slow
plot(fit, type="hr", newdata=data.frame(x=0,u=0), var="x", ylim=c(1,4))
predict(fit, type="surv", newdata=data.frame(x=0:1,u=3), grid=TRUE, full=TRUE,
        se.fit=TRUE) |>
    ggplot(aes(x=y,y=Estimate,fill=factor(x),ymin=lower,ymax=upper)) +
    ylab("Survival") +
    geom_ribbon(alpha=0.6) +
    geom_line(aes(colour=factor(x)))
## standardisation: slow:(
plot(fit, type="meanhr", newdata=transform(d,x=0), var="x", seqLength=31, ylim=c(1,4))
plot(fit, type="meansurvdiff", newdata=transform(d,x=0), var="x", seqLength=31)
plot(fit, type="meansurv", newdata=transform(d,x=0), seqLength=101)
```

## (b) Fitting models with only $X$ ## 

We now model by excluding the variable $U$. This variable could be excluded when it is not measured or perhaps when the variable is not considered to be a confounding variable -- from the causal diagram, the two variables $X$ and $U$ are not correlated and are only connected through the time variable $T$.

```{webr-r}
fit1 <- glm(delta~x+offset(log(y)),data=d,family=poisson)
fit2 <- coxph(Surv(y,delta)~x,data=d)
fit3 <- stpm2(Surv(y,delta)~x,data=d,df=4)
rbind(glm=coef(summary(fit1))["x",c("Estimate","Std. Error")],
      coxph=coef(summary(fit2))["x",c("coef","se(coef)")],
      stpm2=coef(summary(fit3))["x",c("Estimate","Std. Error")])
```

Again, we suggest investigating whether the hazard ratio for $X$ is time-varying.

```{webr-r}
stpm2(Surv(y,delta)~x,data=d,df=4, tvc=list(x=2)) |>
    plot(type="hr", newdata=data.frame(x=0), var="x", ylim=c(1,4))
```

What do you see from the time-varing hazard ratio? Is $U$ a potential confounder for $X$?



## (c) Rarer outcomes ## 

We now simulate for rarer outcomes by changing the censoring distribution:

```{webr-r}
set.seed(12345)
d <- local({
    n <- 1e4*10 # CHANGED N
    x <- rbinom(n, 1, 0.5)
    u <- rnorm(n, 0, 3)
    t <- rexp(n, exp(-5+x+u))
    c <- runif(n, 0, 10/1000) # CHANGED FROM 10 TO 0.01
    y <- pmin(t, c)
    delta <- (t < c)
    data.frame(y,x,u,delta)
})
fit1 <- glm(delta~x+offset(log(y)),data=d,family=poisson)
fit2 <- coxph(Surv(y,delta)~x,data=d)
fit3 <- stpm2(Surv(y,delta)~x,data=d,df=4)
rbind(glm=coef(summary(fit1))["x",c("Estimate","Std. Error")],
      coxph=coef(summary(fit2))["x",c("coef","se(coef)")],
      stpm2=coef(summary(fit3))["x",c("Estimate","Std. Error")])
```

What do you observe?


## (d) Less heterogeneity ## 

We now simulate for less heterogeneity by changing the reducing the standard deviation for the random effect $U$ from 3 to 1. 

```{webr-r}
set.seed(12345)
d <- local( {
    n <- 1e4
    x <- rbinom(n, 1, 0.5)
    u <- rnorm(n, 0, 1) # CHANGED SD FROM 3 TO 1
    t <- rexp(n, exp(-5+x+u))
    c <- runif(n, 0, 10) 
    y <- pmin(t, c)
    delta <- (t < c)
    data.frame(y,x,u,delta)
})
fit1 <- glm(delta~x+offset(log(y)),data=d,family=poisson)
fit2 <- coxph(Surv(y,delta)~x,data=d)
fit3 <- stpm2(Surv(y,delta)~x,data=d,df=4)
rbind(glm=coef(summary(fit1))["x",c("Estimate","Std. Error")],
      coxph=coef(summary(fit2))["x",c("coef","se(coef)")],
      stpm2=coef(summary(fit3))["x",c("Estimate","Std. Error")])
```

What do you observe?


## (e) Accelerated failure time models ##

As an alternative model class, we can fit _accelerated failure time models_ with a smooth baseline survival function. We can use the *rstpm2::aft* function, which uses splines to model baseline survival. Using the baseline simulation, fit and interpret smooth accelerated failure time models:

```{webr-r}
set.seed(12345)
d <- local({
    n <- 1e4
    x <- rbinom(n, 1, 0.5)
    u <- rnorm(n, 0, 3)
    t <- rexp(n, exp(-5+x+u))
    c <- runif(n, 0, 10)
    y <- pmin(t, c)
    delta <- (t < c)
    data.frame(y,x,u,delta)
})
aft(Surv(y,delta)~x+u,data=d,df=4) |> summary()
aft(Surv(y,delta)~x,data=d,df=4) |> summary()
```

---
title: "Biostatistics III in R"
author:
- Code by Annika Tillander, Andreas Karlsson and Mark Clements
output:
  prettydoc::html_pretty:
    theme: cayman
    highlight: github
---


# Exercise 10. Examining the proportional hazards hypothesis (localised melanoma) #

-----------

Load the diet data using time-on-study as the timescale with a maximum of 10 years follow-up.

```{r setup, cache=FALSE, message=FALSE, echo=FALSE}
library('knitr')
read_chunk('../q10.R')
opts_chunk$set(cache=FALSE, results='hide', fig.keep='none')
```

You may have to install the required packages the first time you use them. You can install a package by `install.packages("package_of_interest")` for each package you require.

```{r loadDependencies, message=FALSE}
```
Load melanoma data and explore it.

```{r loadPreprocess}
```

## (a) ## 
For the localised melanoma data with 10 years follow-up, plot the instantaneous cause-specific hazard for each calendar period.


```{r 10.a, message=FALSE}
```

## (b) ## 
Now plot the instantaneous cause-specific hazard for each calendar period using a log scale for the y axis (use the option yscale(log)). What would you expect to see if a proportional hazards assumption was appropriate? Do you see it?

```{r 10.b, message=FALSE}
```

## (c) ## 
Another graphical way of checking the proportional hazards assumption is to plot the log cumulative cause specific hazard function for each calendar period. These plots were not given extensive coverage in the lectures, so attempt this if you like or continue to part (d).

```{r 10.c, message=FALSE}
```

## (d) ## 
Compare your estimated hazard ratio from part (a) with the one from a fitted Cox model with calendar period as the only explanatory variable. Are they similar?

```{r 10.d}
```

## (e) ## 
Now fit a more complex model and use graphical methods to explore the assumption of proportional hazards by calendar period.

```{r 10.e}
```

What do you conclude?

## (f) ## 
Do part (a)–(e) but now for the variable agegrp. What are your conclusions regarding the assumption of proportional hazards? No written solutions for this part.

## (g) ## 
Now formally test the assumption of proportional hazards.

```{r 10.g}
```

Are your conclusions from the test coherent with your conclusions from the graphical assessments?

## (h) ## 
Estimate separate age effects for the first two years of follow-up (and separate estimates for the remainder of the follow-up) while controlling for sex and period. Do the estimates for the effect of age differ between the two periods of follow-up? Write out the regression equation.

```{r 10.h}
```

We see effects of age (i.e., the hazard ratios) for the period 0–2 years subsequent to diagnosis along with the interaction effects. An advantage of the default parameterisation is that one can easily test the statistical significance of the interaction effects. Before going further, test whether the age*follow-up interaction is statistically significant (using a Wald and/or LR test).

## (i) ## 
Often we wish to see the effects of exposure (age) for each level of the modifier (time since diagnosis). That is, we would like to complete the table below with relevant hazard ratios. To get the effects of age for the period 2+ years after diagnosis, using the default parametrization, we must multiply the hazard ratios for 0–2 years by the appropriate interaction effect. Now let’s reparameterise the model to directly estimate the effects of age for each level of time since diagnosis.

              0–2 years   2+ years
------------- ----------- ----------
  Agegrp0-44     1.00        1.00
  Agegrp45-59    --          --
  Agegrp60-74    --          -- 
  Agegrp75+      --          --


```{r 10.i}
```

We can also use the `tt` argument in `coxph` for modelling for time-varying effects:

```{r 10.ib}
```

Write out the regression equations for models `cox2p8Split2` and `cox2p8tvct`. Based on model `cox2p8tvct`, write out a formula for the hazard ratio for those aged 75 years and over compared with those aged less than 45 years as a function of time.



## (j) ## 

ADVANCED: Fit an analogous Poisson regression model. Are the parameter estimates similar? HINT: You will need to split the data by time since diagnosis. Calculate and plot the rates.

<!-- ```{r 10.j} -->
<!-- ``` -->

---
title: "Biostatistics III in R"
author:
- Code by Bénédicte Delcoigne and Mark Clements
output:
  prettydoc::html_pretty:
    theme: cayman
    highlight: github
---

# Exercise 25. Localised melanoma : generating and analysing a nested case-control (NCC) study #

-----------

```{r setup, cache=FALSE, message=FALSE, echo=FALSE}
library('knitr')
read_chunk('../q25.R')
opts_chunk$set(cache=FALSE)
```


```{r loadDependencies, message=FALSE}
```

```{r loadPreprocess, results='hide'}
```

```{r ex_25_coxph,  message=FALSE, warning=FALSE}
```

## (a) ## 

There are 5318 individuals in the study that we would need to
        collect data for if we were to use the complete cohort
        of patients.
		
```{r  n_ind,  message=FALSE, warning=FALSE}
```

## (b) ## 
960 cancer patients die from melanoma during the first 10 years
        of follow-up.

```{r  n_event,  message=FALSE, warning=FALSE}
```

## (c1) ## 

```{r gen_ncc,  message=FALSE, warning=FALSE}
```

## (c2) ## 

```{r clogit,  message=FALSE, warning=FALSE}
```

## (d) ## 

```{r n_unique_ncc,  message=FALSE, warning=FALSE}
```

## (e) ## 
Note that, since every nested case-control study is different,
        the parameter estimates you obtain will not be identical to
        those above. However, the hazard ratios from the two models
        should be very similar. The standard errors are slightly larger
        for the nested case-control study since the estimates are based
        on a sample from the full cohort. Loss of precision is the
        trade-off we have to make when designing a nested
        case-control study. The precision can be improved by adding more
        controls to each case.

```{r compare_coh_ncc,  message=FALSE, warning=FALSE}
```

## (f) ## 
We see that there is sampling variation in
        the parameter estimates from the five nested case-control
        studies but they are centered on the full cohort estimate. We
        see that the standard errors of the estimates from the nested
        case-control studies are larger than for the full cohort but
        there is some sampling variation.
		
```{r loop_ncc,  message=FALSE, warning=FALSE, results='hide'}
```

```{r output,  message=FALSE, warning=FALSE}
```

---
title: "Biostatistics III in R"
author:
- Code by Annika Tillander, Andreas Karlsson and Mark Clements
output:
  prettydoc::html_pretty:
    theme: cayman
    highlight: github
---


# Exercise 2. Comparing survival proportions and mortality rates by stage for cause-specific and all-cause survival #
	

```{r setup, cache=FALSE, message=FALSE, echo=FALSE}
library('knitr')
read_chunk('../q2.R')
opts_chunk$set(cache=FALSE, fig.width=10, fig.height=6, results='hide', fig.keep='none')
```

The purpose of this exercise is to study survival of the patients
using two alternative measures --- survival proportions and
mortality rates. A second purpose is to study the difference between
cause-specific and all-cause survival.

You may have to install the required packages the first time you use them. You can install a package by `install.packages("package_of_interest")` for each package you require.

Load dependencies

```{r loadDependencies, message=FALSE}
```

We start by listing the first few observations to get an idea about the data. We then define two 1/0 variables for the events that we are interested in.

```{r loadPreprocess, results='markup'}
```

## (a) Plot estimates of the survivor function and hazard function by stage ##

We now tabulate the distribution of the melanoma patients by cancer stage at diagnosis.

```{r a_tabulate}
```

We then plot the survival and hazards by stage. Does it appear that stage is associated with patient survival?

```{r a_plotSurv}
```

As an extension, this could be calculated using the `bshazard` package, with plotting using either `ggplot2` or `lattice` packages.

## (b) Estimate the mortality rates for each stage using, for example, the `survRate` command ##

```{r b_crudeRates}
```

What are the units of the estimated rates? The `survRate` function, as the name suggests, is used to
        estimates rates. Look at the help pages if you are not familiar
        with the function (e.g. `?survRate` or `help(survRate)`).


## (c) ##
If you haven’t already done so, estimate the mortality rates for each stage per person-year and per 1000 person-years of follow-up.

## (d) ##

Study whether survival is different for males and females (both
        by plotting the survivor function and by tabulating
        mortality rates).
Is there a difference in survival between males and females? If
        yes, is the difference present throughout the follow up?

## (e) ##

The plots you made above were based on cause-specific survival
(i.e., only deaths due to cancer are counted as events, deaths
due to other causes are censored). In the next part of this
question we will estimate all-cause survival (i.e., any death is
counted as an event). First, however, study the coding of vital
status and tabulate vital status by age group.

How many patients die of each cause? Does the distribution of
cause of death depend on age?


```{r e_tabByAge}
```

## (f) ##

To get all-cause survival, specify all deaths (both cancer
and other) as events.

Now plot the survivor proportion for all-cause survival
by stage. We name the graph to be able to separate them in the
graph window. Is the survivor proportion different compared to
the cause-specific survival you estimated above? Why?

## (g) ##

It is more common to die from a cause other than cancer in
older ages. How does this impact the survivor proportion for
different stages? Compare cause-specific and all-cause survival
by plotting the survivor proportion by stage for the oldest age
group (75+ years) for both cause-specific and
all-cause survival.

## (h) ##

Now estimate both cancer-specific and all-cause survival for
        each age group.

---
title: "Biostatistics III in R"
author:
- Code by Andreas Karlsson and Mark Clements
output:
  prettydoc::html_pretty:
    theme: cayman
    highlight: github
---

# Exercise 22. Estimating the effect of a time-varying exposure – the bereavement data #


These data were used to study a possible effect of marital bereavement (loss of husband or wife) on all–cause mortality in the elderly. The dataset was extracted from a larger follow-up study of an elderly population and concerns subjects whose husbands or wives were alive at entry to the study. Thus all subjects enter as not bereaved but may become bereaved at some point during follow–up. The variable dosp records the date of death of each subject’s spouse and takes the value 1/1/2000 where this has not yet happened.


-----------


```{r setup, cache=FALSE, message=FALSE, echo=FALSE}
library('knitr')
read_chunk('../q22.R')
opts_chunk$set(cache=FALSE,dpi=20)
```

You may have to install the required packages the first time you use them. You can install a package by `install.packages("package_of_interest")` for each package you require.

```{r loadDependencies, message=FALSE}
```

## (a) ## 


```{r loadPreprocess, results='hide'}
```

```{r 22.a, warning=FALSE, message=FALSE}
```

## (b) ## 

  i. The timescale is attained age, which would seem to be a
            reasonable choice.
  ii. Males have the higher mortality which is to be expected.
  iii. Age could potentially be a confounder. Males are slightly older at diagnosis (although we haven't studied pairwise differences).

```{r 22.b, warning=FALSE, message=FALSE}
```

## (c) Breaking records into pre and post bereavement. ## 

```{r 22.c, warning=FALSE, message=FALSE}
```

## (d) ## 
Now find the (crude) effect of bereavement.


```{r 22.d, warning=FALSE, message=FALSE}
```

## (e) ## 

```{r 22.e, warning=FALSE, message=FALSE}
```

## (f) Controlling for age.## 

```{r 22.f, warning=FALSE, message=FALSE}
```

## (g) ## 

```{r 22.g, warning=FALSE, message=FALSE}
```

## (h) ## 

We could split the post bereavement period into multiple
        categories (e.g., within one year and subsequent to one year
        following bereavement) and compare the risks between
        these categories.

## (i) Analysis using Cox regression.## 

Cox regression: effect of `brv` controlled for attained age:

```{r 22.i, warning=FALSE, message=FALSE}
```

## (j) ## 
Cox regression estimating the effect of `brv` for each sex, 
                    controlling for age:


```{r 22.j, warning=FALSE, message=FALSE}
```

---
title: "Biostatistics III in R"
author:
- Code by Johan Zetterqvist, Andreas Karlsson and Mark Clements
output:
  prettydoc::html_pretty:
    mathjax: https://biostat3.net/js/mathjax/tex-chtml.js
    theme: cayman
    highlight: github
---

# Exercise 6. Diet data: tabulating incidence rates and modelling with Poisson regression #

```{r setup, cache=FALSE, message=FALSE, echo=FALSE}
library('knitr')
read_chunk('../q6.R')
opts_chunk$set(cache=FALSE)
```

You may have to install the required packages the first time you use them. You can install a package by `install.packages("package_of_interest")` for each package you require.

```{r loadDependencies, message=FALSE}
```
Load the diet data using time-on-study as the timescale. We look at the first six rows of the data using `head` and look at a summary for the variables using `summary`:

```{r loadPreprocess, results='asis'}
```

## (a) ##

```{r 6a_ir,  message=FALSE, results='asis'}
```

```{r 6a_ir_b,  message=FALSE}
```

We see that individuals with a high energy intake have a lower
        CHD incidence rate. The estimated crude incidence rate ratio
        is 0.52 (95% CI: 0.27, 0.97).

## (b) ##

The code is:

```{r 6b_ir}
```

The point estimate for the IRR calculated by the Poisson regression is
the same as the IRR calculated in 6(a). The regression model can be defined by:

\begin{align*}
E(\text{chd}) &= \frac{y}{1000}\exp\left(\beta_0 + \beta_1I(\text{hieng}="high") \right) \\
&= \exp\left(\beta_0 + \beta_1I(\text{hieng}="high") + \log(y/1000) \right)
\end{align*}

where $E(\text{chd})$ is the expected count for CHD, $\beta_0$ is the
intercept parameter for the log rate and $\beta_1$ is the parameter
for the log rate ratio for high energy diets. We have also used
$I(\text{condition})$ as an indicator function, which will take a
value of 1 when the condition is true and 0 otherwise.

A theoretical observation: if we consider the data as being
cross-classified solely by `hieng` then the Poisson regression model
with one parameter is a _saturated model_ (that is, the number of
observations is equal to the number of parameters) so the IRR
estimated from the model will be identical to the ‘observed’ IRR. That
is, the model is a perfect fit.

## (c) ##

```{r 6c_energyDist,  message=FALSE}
```

The histogram and density curve gives us an idea of the distribution of energy intake. The normal curve suggests that a normal approximation may be
acceptable. We can also tabulate moments and percentiles of the
distribution.

## (d) ##

```{r 6d_engCat}
```

This could also be done using `dplyr::mutate`.

## (e) ##


```{r 6e_irEng}
```

We see that the CHD incidence rate decreases as the level of total
energy intake increases. These calculations are usually better done
using a regression model as they are less fiddly and can be adjusted
for other covariates.

## (f) ##


```{r 6f_irEng, results='asis'}
```

## (g) ##

```{r 6g_irEng}
```

## (h) ##

```{r 6h,  message=FALSE}
```

Level 1 of the categorized total energy is the reference category. The
estimated rate ratio comparing level 2 to level 1 is 0.6452 and the
estimated rate ratio comparing level 3 to level 1 is 0.2886.

The regression equation can be represented by:

\begin{align*}
E(\text{chd}) &= \frac{y}{1000}\exp\left(\beta_0 + \beta_2 X_2 + \beta_3 X_3 \right) \\
&= \exp\left(\beta_0 + \beta_2 X_2 + \beta_3 X_3 + \log(y/1000) \right)
\end{align*}
where $\beta_2$ and $\beta_3$ are the log rate ratios for $X_2=\text{X2}$ and $X_3=\text{X3}$, respectively.

## (i) ##


```{r 6i,  message=FALSE}
```

Now use level 2 as the reference (by omitting X2 but including
        X1 and X3). The estimated rate ratio comparing level 1 to level
        2 is 1.5498 and the estimated rate ratio comparing level 3 to
        level 2 is 0.4473.

## (j) ##

```{r 6j,  message=FALSE}
```

The estimates are identical (as we would hope) when we have
        R create indicator variables for us.

## (k) ##

Somehow (there are many different alternatives) you’ll need to
        calculate the total number of events and the total person-time
        at risk and then calculate the incidence rate
        as events/person-time. As examples,

```{r 6k}
```

The estimated incidence rate is 0.00999 events per person-year.

---
title: "Biostatistics III in R"
author:
- Code by Annika Tillander, Andreas Karlsson, Benedicte Delcoigne, Johan Zetterqvist and Mark Clements
output:
  prettydoc::html_pretty:
    theme: cayman
    highlight: github
---


# Exercise 8. Diet data: Using Poisson regression to study the effect of energy intake adjusting for confounders on two different timescales #

Use Poisson regression to study the association between energy intake (hieng) and CHD adjusted for potential confounders (job, BMI). We know that people who expend a lot of energy (i.e., are physically active) require a higher energy intake. We do not have data on physical activity but we are hoping that occupation (job) will serve as a surrogate measure of work-time physical activity (conductors on London double-decker busses expend energy walking up and down the stairs all day).

Fit models both without adjusting for ‘time’ and by adjusting for attained age (you will need to split the data) and time-since-entry and compare the results.

-----------

Load the diet data using time-on-study as the timescale.

```{r setup, cache=FALSE, message=FALSE, echo=FALSE}
library('knitr')
read_chunk('../q8.R')
opts_chunk$set(cache=FALSE)
```

You may have to install the required packages the first time you use them. You can install a package by `install.packages("package_of_interest")` for each package you require.

```{r loadDependencies, message=FALSE}
```
Load diet data and explore it.

```{r loadPreprocess, results='hide'}
```

The rates plotted on timescale attained age show a clear
        increasing trend as age increases, which is to be expected
        (older persons are more likely to suffer from CHD). The rates
        plotted on timescale time-since-entry are almost constant (if
        you have some imagination you can see that the rates are flat).
		

## (a) ##

```{r 8a1_Haz_att_age,  message=FALSE, warning = FALSE}
```

```{r 8a2_Haz_time_entry,  message=FALSE, warning = FALSE}
```

## (b) ##  

Patients with high energy intake have 48% less CHD rate. The
        underlying shape of the rates is assumed to be constant (i.e.
        the baseline is flat) over time.
		
```{r 8b_ir,  message=FALSE}
```

## (c) ##  

The effect of high energy intake is slightly confounded by bmi
        and job, since the point estimate changes a little.


```{r 8c_ir,  message=FALSE}
```

## (d) ##  

The y variable is not correct since it is kept for all splitted
        records, and contains the complete follow-up rather than the
        risktime in that specific timeband. The risktime variable
        contains the correct amount of risktime for each timeband. The
        event variable chd is not correct since it is kept constant
        for all splitted records, while it should only be 1 for the
        last record (if the person has the event). For all other
        records (timebands) for that person it should be 0.
		

```{r 8d_agebands,  message=FALSE}
```

The effect of high energy intake is somewhat confounded by age,
        but also confounded by job and bmi.

```{r 8d_model1,  message=FALSE}
```

Fitting the model for CHD, with adjustment for job and bmi.

```{r 8d_model2,  message=FALSE}
```


## (e) ##
		
```{r 8.e.i,  message=FALSE}
```

There seems to be no confounding by time-since-entry, but there
        is confounding by bmi and job.

---
title: "Biostatistics III in R"
author:
- Andreas Karlsson and Mark Clements
output:
  html_document:
    theme: null
  html_vignette: default
  prettydoc::html_pretty: default
---

Installation for Biostatistics III in R
======================================================

R will be used throughout the course. This section describes how to
download and install the files required for the computing exercises
(e.g., data files) as well as how to install packages for
extending R. If you are working in a computer lab during a course
it’s possible these files may have already been installed for you.

Download and installation of R packages is generally done within R. The packages can be installed from CRAN by

    install.packages("biostat3")
    install.packages(c("bshazard","rstpm2","Epi","dplyr"))

You can use the `library` function to check if an R package is installed (and load it).

    library(biostat3)  # main package
	## some additional packages
    library(rstpm2)    # stpm2(), pstpm2()
    library(bshazard)  # bshazard()
    library(Epi)       # ccwc()
    library(dplyr)     # mutate(), filter(), group_by(), summarise(), %>%
	
You can also read the data files directly from the web from within
R. For example,

    library(foreign)
	colon <- read.dta("http://www.biostat3.net/download/colon.dta")

---
title: "Biostatistics III in R"
author:
- Code by Xing-Rong Liu and Mark Clements
output:
  prettydoc::html_pretty:
    mathjax: https://biostat3.net/js/mathjax/tex-chtml.js
    theme: cayman
    highlight: github
---

## Exercise 28. Flexible parametric survival models in R ##



```{r setup, cache=FALSE, message=FALSE, echo=FALSE}
library('knitr')
read_chunk('../q28.R')
opts_chunk$set(cache=FALSE, fig.width=10, fig.height=6)
```


```{r loadDependencies, message=FALSE}
```


```{r loadPreprocess}
```

## (a) ## 

The `stpm2` output can be seen below.

```{r a_flex}
```

The hazard ratio, 95% confidence interval and statistical
        significance are very similar to the Cox model.
		
```{r a_cox}
```

## (b) ## 

The predicted survival and hazard functions are shown below.

```{r b_surv}
```

```{r b_haz}
```

## (c) ## 

There is a constant difference as the predictions are from a
        proportional hazards model and a multiplicative effect becomes
        additive on the log scale.
		
```{r c_haz_log}
```

## (d) ## 

The log hazard ratios (and hence the hazard ratios) from 2 df
and up are similar and for 3 df they are very similar. The main
difference is for 1 df, which is equivalent to a Weibull model.
The Weibull model enforces a monotonic hazard function and as
the hazard function in the melanoma data has a turning point it
is clearly inappropriate.\
The lowest AIC is for the model with 5 df and for the BIC it is
the model with 2 df. The penalty term in the AIC is twice the
number of parameters ($2 \times k$) whereas in the BIC it is
$\log(D) \times k$ where $D$ is the number of events. Since
$\log(D) > k$ the BIC penalizes extra parameters much more
strongly than AIC. Since we have a large data set and there are
no disadvantages to including extra parameters we would use 5 df
for the baseline hazard.
		
```{r d_AIC_BIC}
```

## (e) ## 

```{r e_base_surv}
```

The code for hazards is very similar:

```{r e_base_haz}
```

With the exception of 1 df (the Weibull model), the survival and
hazard functions show similar shapes, so as long we have enough
knots our conclusions would be very similar.


## (f) ## 

```{r f_sex_age}
```

After modelling for sex, calendar period age group and time with five degrees of freedom, the adjusted hazard ratios for: females compared with males was 0.59 (95% CI: 0.54, 0.64); diagnoses during the period 1985--1994 compared with those diagnosed 1974--1984 was 0.72 (95% CI: 0.66, 0.79); and age groups 45--59, 60--74 and 75+ compared with ages 0--44 years were 1.33 (95% CI: 1.17, 1.49), 1.86 (95% CI: 1.66. 2.07) and 3.40 (95% CI: 2.93, 3.92), respectively.

Undertaking a likelihood ratio test, there was strong evidence (p<1e-16) that age group contributed significantly to the model fit.

## (g) ## 

```{r g_sex_age}
```

The estimates are so similar because very similar models are
being fitted with exactly the same covariates. The two models
differ only in the manner in which they account for the
baseline hazard. In the Cox model it is assumed arbitrary and
not directly estimated. In the flexible parametric model the
baseline hazard is modelled using splines. The 5 df spline
allows sufficient flexibility to make the model estimates
virtually identical.

## (h) ## 

```{r h_time_varying}
```

There is strong evidence of a non-proportional effect of age.

We could also investigate the non-proportional effect of age with penalized models, where sp is the optimal smoothing parameters estimated from models without sp argument:

```{r h_time_varying_penalised}
```


## (i) ## 

The baseline hazard is shown below. This baseline
        is for the youngest age group who are male and diagnosed in
        1975–1984, i.e, when all the covariates are equal to zero.
		
```{r i_plot_base_haz}
```

## (j) ## 

```{r j_age_HR}
```

```{r j_oldest}
```

        The hazard ratios decrease as a function of follow-up time. The
        hazard ratio is so high during the early years of follow-up
        because the hazard in the reference group is close to
        zero. The hazard ratio for the oldest age
        group with 95% confidence intervals is also shown.
## (k) ## 


```{r k_haz_diff}
```

The hazard difference is small early on, despite the hazard
        ratio being large, because the underlying hazard is so low.
		
## (l) ## 


```{r l_surv_diff}
```

## (m) ## 


```{r m_time_dep_eff}
```

---
title: "Biostatistics III in R"
author:
- Code by Andreas Karlsson and Mark Clements
output:
  prettydoc::html_pretty:
    theme: cayman
    highlight: github
---

# Exercise 22. Estimating the effect of a time-varying exposure – the bereavement data #


These data were used to study a possible effect of marital bereavement (loss of husband or wife) on all–cause mortality in the elderly. The dataset was extracted from a larger follow-up study of an elderly population and concerns subjects whose husbands or wives were alive at entry to the study. Thus all subjects enter as not bereaved but may become bereaved at some point during follow–up. The variable dosp records the date of death of each subject’s spouse and takes the value 1/1/2000 where this has not yet happened.


-----------


```{r setup, cache=FALSE, message=FALSE, echo=FALSE}
library('knitr')
read_chunk('../q22.R')
opts_chunk$set(cache=FALSE)
```

You may have to install the required packages the first time you use them. You can install a package by `install.packages("package_of_interest")` for each package you require.

```{r loadDependencies, message=FALSE}
```

## (a) ## 

Load the bereavement data and explore it.

```{r loadPreprocess, results='hide'}
```

```{r 22.a, warning=FALSE, message=FALSE, results='hide'}
```

## (b) ## 
Calculate the mortality rate per 1000 years for men and for women, and find the rate ratio comparing women (coded 2) with men (coded 1).

  i. What dimension of time did we use as the timescale? Do you think this is a sensible choice?
  ii. Which gender has the highest mortality? Is this expected?
  iii. Could age be a potential confounder? Does age at entry differ between males and females? Later we will estimate the rate ratio while controlling for age.

```{r 22.b, warning=FALSE, message=FALSE, results='hide'}
```

## (c) Breaking records into pre and post bereavement. ## 
In these data a subject changes exposure status from not bereaved to bereaved when his or her spouse dies. The first stage of the analysis therefore is to partition each follow–up into a record describing the period of follow-up pre–bereavement and (for subjects who were bereaved during the study) the period post–bereavement.

```{r 22.c, warning=FALSE, message=FALSE, results='hide'}
```

## (d) ## 
Now find the (crude) effect of bereavement.


```{r 22.d, warning=FALSE, message=FALSE, results='hide'}
```

## (e) ## 
Since there is a strong possibility that the effect of bereavement is not the same for men as for women, use streg to estimate the effect of bereavement separately for men and women. Do this both by fitting separate models for males and females as well as by using a single model with an interaction term (you may need to create dummy variables). Confirm that the estimates are identical for these two approaches.

```{r 22.e, warning=FALSE, message=FALSE, results='hide'}
```

## (f) Controlling for age.## 
There is strong confounding by age. Expand the data by 5 year age–bands, and check that the rate is increasing with age. Find the effect of bereavement controlled for age. If you wish to study the distribution of age then it is useful to know that age at entry and exit. Translate your time scale to age.

```{r 22.f, warning=FALSE, message=FALSE, results='hide'}
```

## (g) ## 
Now estimate the effect of bereavement (controlled for age) separately for each sex.

```{r 22.g, warning=FALSE, message=FALSE, results='hide'}
```

## (h) ## 
We have assumed that any effect of bereavement is both immediate and permanent. This is not realistic and we might wish to improve the analysis by further subdividing the post–bereavement follow–up. How might you do this? (you are not expected to actually do it)

## (i) Analysis using Cox regression.## 
We can also model these data using Cox regression. Provided we use the attained age as the time scale and split the data to obtain separate observations for the bereaved and non-bereaved person-time the following command will estimate the effect of bereavement adjusted for attained age.

```{r 22.i, warning=FALSE, message=FALSE, results='hide'}
```

That is, we do not have to split the data by attained age (although we can fit the model to data split by attained age and the results will be the same).

## (j) ## 
Use the Cox model to estimate the effect of bereavement separately for males and females and compare the estimates to those obtained using Poisson regression.

```{r 22.j, warning=FALSE, message=FALSE, results='hide'}
```

---
title: "Biostatistics III in R"
author:
- Code by Johan Zetterqvist and Mark Clements
output:
  prettydoc::html_pretty:
    theme: cayman
    highlight: github
---


# Exercise 13. Modelling the diet data using Cox regression #

-----------

Now fit a model to the localised melanoma data where the outcome is observed survival (i.e. all deaths are considered to be events).

```{r setup, cache=FALSE, message=FALSE, echo=FALSE}
library('knitr')
read_chunk('../q13.R')
opts_chunk$set(cache=FALSE)
```

You may have to install the required packages the first time you use them. You can install a package by `install.packages("package_of_interest")` for each package you require.

```{r loadDependencies, message=FALSE}
```
Load the melanoma data and explore it.

```{r loadPreprocess, results='hide'}
```

## (a) ## 

```{r 13.a, warning=FALSE, message=FALSE}
```

These two models are conceptually different since the Cox model
adjusts for ‘time’ even though this is not explicit in the
`coxph` function. In this example, ‘time’ refers to ‘time on
study’ (time since entry) which we do not expect to be a
strong confounder. That is, we would expect the estimates of the
effect of high energy to be similar for the two models, which
they are.

## (b) ## 

If we use a different timescale then this amounts to adjusting
for a different factor. As such, we would not expect the
estimates to be identical. Attained age, unlike time since
entry, is expected to be a confounder but we see that it is not
a strong confounder.
		
```{r 13.b, warning=FALSE, message=FALSE}
```

---
title: "Biostatistics III in R"
author:
- Code by Johan Zetterqvist and Mark Clements
output:
  prettydoc::html_pretty:
    theme: cayman
    highlight: github
---


# Exercise 7. Model cause-specific mortality with Poisson regression #

In this exercise we model, using Poisson regression, cause-specific mortality of patients diagnosed with localised (stage==1) melanoma.

In exercise 9 we model cause-specific mortality using Cox regression and in exercise 28 we use flexible parametric models. The aim is to illustrate that these three methods are very similar.

The aim of these exercises is to explore the similarities and differences to these three approaches to modelling. We will be comparing the results (and their interpretation) as we proceed through the exercises.

-----------

Load the diet data using time-on-study as the timescale.

```{r setup, cache=FALSE, message=FALSE, echo=FALSE}
library('knitr')
read_chunk('../q7.R')
opts_chunk$set(cache=FALSE)
```

You may have to install the required packages the first time you use them. You can install a package by `install.packages("package_of_interest")` for each package you require.

```{r loadDependencies, message=FALSE}
```

Load the melanoma data and explore it.

```{r loadPreprocess, results='hide'}
```

Rates can be modelled on different timescales, e.g., attained age, time-since-entry, calendar time. Plot the CHD incidence rates both by attained age and by time-since-entry. Is there a difference? Do the same for CHD hazard by different energy intakes (hieng).

## (a) ## 
### i. ###  

```{r 7.a.i,  message=FALSE}
```

Survival is better during the latter period.

### ii. ###  

```{r 7.a.ii,  message=FALSE}
```

Mortality is lower during the latter period.

### iii. ###

```{r 7.a.iii,  message=FALSE}
```

The two graphs both show that prognosis is better during the
            latter period. Patients diagnosed during the latter period
            have lower mortality and higher survival.
			
## (b) ##

```{r 7.b,  message=FALSE}
```

The estimated mortality rate is lower for patients diagnosed during
the early period. This is not consistent with what we saw in previous
analyses. The inconsistency is due to the fact that we have not
controlled for time since diagnosis. look at the graph of the
estimated hazards (on the previous page) and try and estimate the
overall average value for each group. We see that the average hazard
for patients diagnosed in the early period is drawn down by the low
mortality experienced by patients 10 years subsequent to diagnosis.

## (c) ##

### i. ###  

```{r 7.c.i,  message=FALSE}
```

Now that we have restricted follow-up to a maximum of 10 years we see
that the average mortality rate for patients diagnosed in the early
period is higher than for the latter period. This is consistent with
the graphs we examined in part (a).

### ii. ###  

```{r 7.c.ii,  message=FALSE}
```

### iii. ###  

```{r 7.c.iii,  message=FALSE}
```

We see that Poisson regression is estimating the mortality rate ratio
which, in this simple example, is the ratio of the two mortality
rates.

The regression equation is:

\begin{align*}
E(\text{death_cancer}) &= \frac{\text{surv_mm}}{12 \times 1000}\exp\left(\beta_0 + \beta_1 I(\text{year8594}="\text{Diagnosed 85-94}")\right) \\
&= \exp\left(\beta_0 + \beta_1 I(\text{year8594}="\text{Diagnosed 85-94}") + \log(\text{surv_mm}/1000/12) \right)
\end{align*}

where \(E(\text{death_cancer})\) is the expected number of cancer deaths, $\beta_0$ is the intercept term for the log rate, $\beta_1$ is the log rate ratio for the later calendar period, and $\text{surv_mm}/1000/12$ is the period-time.


## (d) ##
In order to adjust for time since diagnosis (i.e., adjust for the fact
that we expect mortality to depend on time since diagnosis) we need to
split the data by this timescale. We will restrict our analysis to
mortality up to 10 years following diagnosis.

```{r 7.d,  message=FALSE}
```

## (e) ##  

```{r 7.e,  message=FALSE}
```

It seems reasonable (at least to me) that melanoma-specific
        mortality is lower during the first year. These patients were
        classified as having localised skin melanoma at the time
        of diagnosis. That is, there was no evidence of metastases at
        the time of diagnosis although many of the patients who died
        would have had undetectable metastases or micrometastases at the
        time of diagnosis. It appears that it takes at least one year
        for these initially undetectable metastases to progress and
        cause the death of the patient.

## (f) ##  

```{r 7.f,  message=FALSE, warning=FALSE}
```

The pattern is similar. The plot of the mortality
rates could be considered an
approximation to the ‘true’ functional form depicted
in the hazard plot. By estimating the rates for each year
of follow-up we are essentially approximating the hazard using a step function. It would probably
be more informative to use narrower intervals (e.g.,
6-month intervals) for the first 6 months of follow-up.
		
## (g) ##  

```{r 7.g,  message=FALSE}
```

The pattern of the estimated mortality rate ratios mirrors the
pattern we saw in the plot of the rates. Note that the first
year of follow-up is the reference so the estimated rate ratio
labelled `1` for `fu` is the rate ratio for the second year
compared to the first year.

The regression equation is:

\begin{align*}
E(\text{death_cancer}) &= \text{pt}\exp\left(\beta_0 + \beta_1 I(\text{fu}=1) + \beta_2 I(\text{fu}=2) + \beta_3 I(\text{fu}=3) + \beta_4 I(\text{fu}=4) + \beta_5 I(\text{fu}=5) + \beta_6 I(\text{fu}=6) + \beta_7 I(\text{fu}=7) + \beta_8 I(\text{fu}=8) + \beta_9 I(\text{fu}=9)\right) \\
&= \exp\left(\beta_0 + \beta_1 I(\text{fu}=1) + \beta_2 I(\text{fu}=2) + \beta_3 I(\text{fu}=3) + \beta_4 I(\text{fu}=4) + \beta_5 I(\text{fu}=5) + \beta_6 I(\text{fu}=6) + \beta_7 I(\text{fu}=7) + \beta_8 I(\text{fu}=8) + \beta_9 I(\text{fu}=9) + \log(\text{pt})\right)
\end{align*}



## (h) ##

```{r 7.h, message=FALSE} 
``` 

The estimated mortality rate ratio is
$0.7791$ compared to $0.8832$ (part c) and a value greater than 1 in
part (b). The estimate we obtained in part (b) was subject to
confounding by time-since-diagnosis. In part (c) we restricted to the
first 10 years of follow-up subsequent to diagnosis. This did not,
however, completely remove the confounding effect of time since
diagnosis. There was still some confounding within the first 10 years
of follow-up (if this is not clear to you then look in the data to see
if there are associations between the confounder and the exposure and
the confounder and the outcome) so the estimate was subject to
residual confounding. Now, when we adjust for time since diagnosis we
see that the estimate changes further.


## (i) ##  
Now control for age, sex, and calendar period. Write out the regression equation.

The regression equation is:
\begin{align*}
E(\text{death_cancer}) &= \text{pt}\exp\left(\beta_0 + \beta_1 I(\text{fu}=1) + \beta_2 I(\text{fu}=2) + \beta_3 I(\text{fu}=3) + \beta_4 I(\text{fu}=4) + \beta_5 I(\text{fu}=5) + \beta_6 I(\text{fu}=6) + \beta_7 I(\text{fu}=7) + \beta_8 I(\text{fu}=8) + \beta_9 I(\text{fu}=9) + \right. \\
                                             &\qquad \left.\beta_{10} x + \beta_{11} I(\text{fu}=1) x + \beta_{12} I(\text{fu}=2) x + \beta_{13} I(\text{fu}=3) x + \beta_{14} I(\text{fu}=4) x + \beta_{15} I(\text{fu}=5) x + \beta_{16} I(\text{fu}=6) x + \beta_{17} I(\text{fu}=7) x + \beta_{18} I(\text{fu}=8) x + \beta_{19} I(\text{fu}=9) x \right)
\end{align*}
where $x$ is the indicator variable when year8594="Diagnosed 85-94". 


### i. ###

For patients of the same sex diagnosed in the same calendar
period, those aged 60–74 at diagnosis have an estimated 86% higher
risk of death due to skin melanoma than those aged 0–44 at
diagnosis. The difference is statistically significant.

### ii. ### 

The parameter estimate for period changes from 0.78 to
0.72 when age and sex are added to the model. Whether this is ‘strong
confounding’, or even ‘confounding’ is a matter of judgement. I would
consider this confounding but not strong confounding but there is no
correct answer.

### iii. ###

```{r 7.i,  message=FALSE, warning=FALSE}
```

Age (modelled as a categorical variable with 4 levels) is highly
significant in the model.

## (j) ##

```{r 7.j,  message=FALSE}
```

The interaction term is not statistically significant indicating that
there is no evidence that the effect of sex is modified by period.

## (k) ##
Based on the interaction model you fitted in exercise 7j, estimate the hazard ratio for the effect of sex (with 95% confidence interval) for each calendar period.

ADVANCED: Do this with each of the following methods and confirm that the results are the same:

### i. ###

```{r 7.k.i,  message=FALSE}
```
The effect of sex for patients diagnosed 1975–84 is
$0.6031338$ and the effect of sex for patients diagnosed
1985–94 is $0.6031338 \times 0.9437245=0.56919214$.

### ii. ###  
We can use `lincom` to get the estimated effect for patients diagnosed
1985–94.


```{r 7.k.ii,  message=FALSE}
```

The advantage of `lincom` is that we also get a confidence
interval (not easy to calculate by hand since the SE is a
function of variances and covariances).
			
### iii. ###

```{r 7.k.iii,  message=FALSE}
```


### iv. ### 

```{r 7.k.iv,  message=FALSE}
```

## (l) ##
If we fit stratified models we get slightly different estimates
        ($0.6165815$ and $0.5549737$) since the models stratified by
        calendar period imply that all estimates are modified by
        calendar period. That is, we are actually estimating the
        following model:

```{r 7.l,  message=FALSE}
```

---
title: "Biostatistics III in R"
author:
- Code by Johan Zetterqvist and Mark Clements
output:
  prettydoc::html_pretty:
    theme: cayman
    highlight: github
---


# Exercise 7. Model cause-specific mortality with Poisson regression #

In this exercise we model, using Poisson regression, cause-specific mortality of patients diagnosed with localised (stage==1) melanoma.

In exercise 9 we model cause-specific mortality using Cox regression and in exercise 28 we use flexible parametric models. The aim is to illustrate that these three methods are very similar.

The aim of these exercises is to explore the similarities and differences to these three approaches to modelling. We will be comparing the results (and their interpretation) as we proceed through the exercises.

-----------

```{r setup, cache=FALSE, message=FALSE, echo=FALSE}
library('knitr')
read_chunk('../q7.R')
opts_chunk$set(cache=FALSE)
```

You may have to install the required packages the first time you use them. You can install a package by `install.packages("package_of_interest")` for each package you require.

```{r loadDependencies, message=FALSE, results='hide', fig.show='hide', eval=FALSE}
```

Load the melanoma data and explore it.

```{r loadPreprocess, results='hide', eval=FALSE}
```

Rates can be modelled on different timescales, e.g., attained age, time-since-entry, calendar time. Plot the CHD incidence rates both by attained age and by time-since-entry. Is there a difference? Do the same for CHD hazard by different energy intakes (hieng).

## (a) ## 
### i. ###  
Plot Kaplan-Meier estimates of cause-specific survival as a function of calendar period of diagnosis.

```{r 7.a.i,  message=FALSE, results='hide', fig.show='hide', eval=FALSE}
```

### ii. ###  
Now plot the estimated hazard function (cause-specific mortality rate) as a function of calendar period of diagnosis.

```{r 7.a.ii,  message=FALSE, results='hide', fig.show='hide', eval=FALSE}
```
During which calendar period (the early or the latter) is mortality the lowest?

### iii. ###
Is the interpretation (with respect to how prognosis depends on period) based on the hazard consistent with the interpretation of the survival plot?

```{r 7.a.iii,  message=FALSE, results='hide', fig.show='hide', eval=FALSE}
```

## (b) ##  
Estimate the cause-specific mortality rate for each calendar period.

```{r 7.b,  message=FALSE, results='hide', fig.show='hide', eval=FALSE}
```

During which calendar period (the early or the latter) is mortality the lowest? Is this consistent with what you found earlier? If not, why the inconsistency?

## (c) ##
The reason for the inconsistency between parts 7a and 7b was confounding by time since diagnosis. The comparison in part 7a was adjusted for time since diagnosis (since we compare the differences between the curves at each point in time) whereas the comparison in part 7b was not. Understanding this concept is central to the remainder of the exercise so please ask for help if you don’t follow.

Two approaches for controlling for confounding are ‘restriction’ and ‘statistical adjustment’. We will first use restriction to control for confounding. We will restrict the potential follow-up time to a maximum of 120 months. Individuals who survive more than 120 months are censored at 120 months.

### i. ###  
Estimate the cause-specific mortality rate for each calendar period.

```{r 7.c.i,  message=FALSE, results='hide', fig.show='hide', eval=FALSE}
```

During which calendar period (the early of the latter) is mortality the lowest? Is this consistent with what you found in part 7b?

### ii. ###  
Calculate by hand the ratio (85–94/75–84) of the two mortality rates (i.e., a mortality rate ratio) and interpret the estimate (i.e., during which period is mortality higher/lower and by how much).

```{r 7.c.ii,  message=FALSE, results='hide', fig.show='hide', eval=FALSE}
```

### iii. ###  
Now use Poisson regression to estimate the same mortality rate ratio. Write the linear predictor using pen and paper and draw a graph of the fitted hazard rates.

```{r 7.c.iii,  message=FALSE, results='hide', fig.show='hide', eval=FALSE}
```

## (7d) ##  
In order to adjust for time since diagnosis (i.e., adjust for the fact that we expect mortality to depend on time since diagnosis) we need to split the data by this timescale. We will restrict our analysis to mortality up to 10 years following diagnosis.

```{r 7.d,  message=FALSE, results='hide', fig.show='hide', eval=FALSE}
```

## (e) ##  
Now tabulate (and produce a graph of) the rates by follow-up time.

```{r 7.e,  message=FALSE, results='hide', fig.show='hide', eval=FALSE}
```

Mortality appears to be quite low during the first year of follow-up. Does this seem reasonable considering the disease with which these patients have been diagnosed?

## (f) ##  
Compare the plot of the estimated rates to a plot of the hazard rate as a function of continuous time.

```{r 7.f,  message=FALSE, warning=FALSE, results='hide', fig.show='hide', eval=FALSE}
```

Is the interpretation similar? Do you think it is sufficient to classify follow-up time into annual intervals or might it be preferable to use, for example, narrower intervals?

## (g) ##  
Use Poisson regression to estimate incidence rate ratios as a function of follow-up time. Write the linear predictor using pen and paper.


```{r 7.g,  message=FALSE, results='hide', fig.show='hide', eval=FALSE}
```
Does the pattern of estimated incident rate ratios mirror the pattern you observed in
the plots? Draw a graph of the fitted hazard rate using pen and paper.

Write out the regression equation.

## (h) ##  
Now estimate the effect of calendar period of diagnosis while adjusting for time since diagnosis. Before fitting this model, predict what you expect the estimated effect to be (i.e., will it be higher, lower, or similar to the value we obtained in part c). Write the linear predictor using pen and paper and draw a graph of the fitted hazard rates.


```{r 7.h,  message=FALSE, results='hide', fig.show='hide', eval=FALSE}
```
Is the estimated effect of calendar period of diagnosis consistent with what you expected? Add an interaction between follow-up and calendar period of diagnosis and interpret the results.

## (i) ##  
Now control for age, sex, and calendar period. Write the linear predictor using pen and paper.

### i. ###  
Interpret the estimated hazard ratio for the parameter labelled agegrp 2, including a comment on statistical significance.
### ii. ###  
Is the effect of calendar period strongly confounded by age and sex? That is, does the inclusion of sex and age in the model change the estimate for the effect of calendar period?
### iii. ###  
Perform a Wald test of the overall effect of age and interpret the results.

```{r 7.i,  message=FALSE, warning=FALSE, results='hide', fig.show='hide', eval=FALSE}
```

## (j) ##  
Is the effect of sex modified by calendar period (whilst adjusting for age and follow-up)? Fit an appropriate interaction term to test this hypothesis. Write the linear predictor using pen and paper.

```{r 7.j,  message=FALSE, results='hide', fig.show='hide', eval=FALSE}
```


## (k) ##  
Based on the interaction model you fitted in exercise 7j, estimate the hazard ratio for the effect of sex (with 95% confidence interval) for each calendar period.

ADVANCED: Do this with each of the following methods and confirm that the results are the same:

### i. ###  
Using hand-calculation on the estimates from exercise 7j.

```{r 7.k.i,  message=FALSE, results='hide', fig.show='hide', eval=FALSE}
```
### ii. ###  
Using the estimates from exercise 7j.


```{r 7.k.ii,  message=FALSE, results='hide', fig.show='hide', eval=FALSE}
```

### iii. ###  
Creating appropriate dummy variables that represent the effects of sex for each calendar period.


```{r 7.k.iii,  message=FALSE, results='hide', fig.show='hide', eval=FALSE}
```

Write the linear predictor using pen and paper.


### iv. ### 
Using the formula to specify the interactions to repeat the previous model.

```{r 7.k.iv,  message=FALSE, results='hide', fig.show='hide', eval=FALSE}
```
Using the formula to specify the interactions, repeat the previous model.

## (l) ##
Now fit a separate model for each calendar period in order to estimate the hazard ratio for the effect of sex (with 95% confidence interval) for each calendar period.

Why do the estimates differ from those you obtained in the previous part?

```{r 7.l,  message=FALSE, results='hide', fig.show='hide', eval=FALSE}
```
Can you fit a single model that reproduces the estimates you obtained from the stratified models?

## (m) ##  
Split by month and fit a model to smooth for time using natural splines, adjusting for age group and calendar period. Plot the baseline hazard. 

```{r 7.m,  message=FALSE, results='hide', fig.show='hide', eval=FALSE}
```


## (n) ##  
Split by month and fit a model to smooth for time using natural splines, adjusting for age group and calendar period, with a time-varying hazard ratio for calendar period. Plot the time-varying hazard ratio. 

```{r 7.n,  message=FALSE, results='hide', fig.show='hide', eval=FALSE}
```

---
title: "Biostatistics III in R"
author:
- Code by Annika Tillander, Andreas Karlsson and Mark Clements
output:
  prettydoc::html_pretty:
    theme: cayman
    highlight: github
---

## Exercise 4. Localised melanoma: Comparing actuarial and Kaplan-Meier approaches with discrete time data ##


```{r setup, cache=FALSE, message=FALSE, echo=FALSE}
library('knitr')
read_chunk('../q4.R')
opts_chunk$set(cache=FALSE)
```

We load the dependencies:

```{r loadDependencies, message=FALSE}
```

Then load the data and define an indicator:
```{r loadPreprocess}
```

Then we show the results using the actuarial estimator with years:
```{r actuarialYears}
```

Similarly, we use the actuarial estimator using months:
```{r actuarialMonths}
```

Then the code using the Kaplan-Meier estimator with years:
```{r kmYears}
```

And the Kaplan-Meier estimator with data in months:
```{r kmMonths}
```

## (a) ##
The actuarial method is most appropriate because it deals with
        ties (events and censorings at the same time) in a more
        appropriate manner. The fact that there are a reasonably large
        number of ties in these data means that there is a difference
        between the estimates.

## (b) ##
The K-M estimate changes more. Because the actuarial method
        deals with ties in an appropriate manner it is not biased when
        data are heavily tied so is not heavily affected when we reduce
        the number of ties.


## (c) ##

The plot clearly shows that the Kaplan-Meier estimator with the
aggregated data is upwardly biased compared with the other curves.

```{r comparisonPlot}
```

---
title: "Biostatistics III in R"
author:
- Code by Annika Tillander, Andreas Karlsson and Mark Clements
output:
  prettydoc::html_pretty:
    theme: cayman
    highlight: github
---

# Exercise 2. Comparing survival proportions and mortality rates by stage for cause-specific and all-cause survival #

```{r setup, cache=FALSE, message=FALSE, echo=FALSE}
library('knitr')
read_chunk('../q2.R')
opts_chunk$set(cache=FALSE)
```

Load dependencies

```{r loadDependencies, message=FALSE}
```

We start by listing the first few observations to get an idea about the data. We then define two 1/0 variables for the events that we are interested in. 

```{r loadPreprocess}
```

We convert the logical variables to 0/1 because some of the `R` functions use logical variables (with values `TRUE` and `FALSE`) as factors. A short-hand approach for converting `TRUE` to 1 and `FALSE` to 0 is to add 0:

```{r}
c(TRUE,FALSE)+0
```

## (a) Plot estimates of the survivor function and hazard function by stage ##
We now tabulate the distribution of the melanoma patients by cancer stage at diagnosis.

```{r a_tabulate}
```

We then plot the survival and survival by stage. 

```{r a_plotSurv}
```

Survival depends heavily on stage. It is interesting to note
that patients with stage 0 (unknown) appear to have a similar
survival to patients with stage 1 (localized).

As an extension, we can use the`bshazard` to calculate the hazards with confidence intervals (see below). Note, however, that the bshazard function will _adjust_ for covariates rather than stratify by covariates. This means that we need to divide the dataset into strata and calculate the smoothed hazards separately. I have shown one approach using `dplyr` for dividing the data, with he plots use `ggplot`, which allows for over-lapping confidence intervals (using the `alpha` transparency argument).

```{r a_plotHaz}
```


## (b) Estimate the mortality rates for each stage using, for example, the  `survRate` command ##

```{r b_crudeRates}
```

The time unit is months (since we specified `surv_mm` as the analysis
time). Therefore, the units of the rates shown above are
events/person-month. 


## (c) ##
Here we tabulate crude rates per person-year and per 1000 person-years. We could divide the times by 12 to obtain estimates with units of the number of events per person-year. For example,

```{r b2_crudeRates}
```
To obtain mortality rates per 1000 person-years:

```{r c_crudeRates1000}
```

## (d) ##
Below we see that the crude mortality rate is higher for males than for females.

```{r d_crudeRates1000_sex}
```

We see that the crude mortality rate is higher for males than
females, a difference which is also reflected in the survival
and hazard curves:

```{r d_plotSurv_sex}
```

## (e) ##

The majority of patients are alive at end of study. 1,913 died
from cancer while 1,134 died from another cause. The cause of
death is highly depending of age, as young people die less from
other causes. To observe this we tabulate the events by age group.

```{r e_tabByAge}
```


## (f) ##

The survival is worse for all-cause survival than for cause-specific, since you now can die from other causes, and these deaths are incorporated in the Kaplan-Meier estimates. The ”other cause” mortality is particularly present in patients with localised and unknown stage.

```{r f_survStage}
```

## (g) ##

By comparing Kaplan-Meier estimates for cancer deaths with all-cause mortality conditioned on age over 75 years, we see that the “other” cause mortality is particularly influential in patients with localised and unknown stage. Patients with localised disease, have a better prognosis (i.e. the cancer does not kill them), and are thus more likely to experience death from another cause. For regional and distant stage, the cancer is more aggressive and is the cause of death for most of these patients (i.e. it is the cancer that kills these patients before they have “the chance” to die from something else).

```{r g_allCa75p}
```


## (h) Compare Kaplan-Meier estimates for cancer deaths with all-cause mortality by age group. ##

```{r h_allCaAgeGrp}
```

---
title: "Biostatistics III in R"
author:
- Code by Annika Tillander, Andreas Karlsson and Mark Clements
output:
  prettydoc::html_pretty:
    mathjax: https://biostat3.net/js/mathjax/tex-chtml.js
    theme: cayman
    highlight: github
---


# Exercise 10. Examining the proportional hazards hypothesis (localised melanoma) #

-----------

Load the diet data using time-on-study as the timescale with a maximum of 10 years follow-up.

```{r setup, cache=FALSE, message=FALSE, echo=FALSE}
library('knitr')
read_chunk('../q10.R')
opts_chunk$set(cache=FALSE)
```

You may have to install the required packages the first time you use them. You can install a package by `install.packages("package_of_interest")` for each package you require.

```{r loadDependencies, message=FALSE}
```
Load melanoma data and explore it.

```{r loadPreprocess, results='hide'}
```

## (a) ## 

If we look at the hazard curves, at their peak the ratio is
approximately $0.04/0.065\approx0.62$. The ratio seems to vary with respect to time.

```{r 10.a, message=FALSE}
```

## (b) ## 
There is some evidence against the assumption of
proportional hazards since we see non-parallel curves
when plotting the instantaneous cause-specific hazard on the
log scale.

```{r 10.b, message=FALSE}
```

## (c) ## 

If the proportional hazards assumption is appropriate then we
should see parallel lines. This looks
okay; we shouldn’t put too much weight on the fact that the
curves cross early in the follow-up since there are so few
deaths there. The difference between the two log-cumulative
hazard curves is similar during the part of the follow-up where
we have the most information (most deaths). Note that these
curves are not based on the estimated Cox model (i.e., they
are unadjusted).
		

```{r 10.c, message=FALSE}
```

## (d) ## 
The estimated hazard ratio from the Cox model is $0.78$ which is
similar (as it should be) to the estimate made by looking at the
hazard function plot.

```{r 10.d}
```

## (e) ## 
The plot of the scaled Schoenfeld residuals for the effect of
period. Under proportional hazards, the smoother will be a horizontal
line.  The line does vary (with possibly an increasing log hazard
ratio at around 4 years), but not in a linear pattern, which is
consistent with the p-value of 0.10 for linear trend.

```{r 10.e}
```


## (f) ## 

Based on the tests for linear trends, we expect a trend for the log hazard ratio comparing ages less than 45 years with those aged 75 years and over. All three log hazard ratios tend to decrease by time of diagnosis, while the trend is more marked for the oldest age group (75+). There is evidence for non-proportionality, particularly for those patients aged 75 years and over.

```{r 10.f}
```


## (g) ## 
It seems that there is evidence of non-proportional hazards by
age (particularly for the comparison of the oldest to youngest)
but not for calendar period. The plot of Schoenfeld residuals
suggested non-proportionality for period but this was not
statistically significant.

```{r 10.g}
```

## (h) ## 

The hazard ratios for age in the top panel are for the first two
years subsequent to diagnosis. To obtain the hazard ratios for
the period two years or more following diagnosis we multiply the
hazard ratios in the top and bottom panel. That is, during the
first two years following diagnosis patients aged 75 years or
more at diagnosis have 5.4 times higher cancer-specific
mortality than patients aged 0–44 at diagnosis. During the
period two years or more following diagnosis the corresponding
hazard ratio is $5.4 \times 0.49=2.66$.\
Using `survSplit` to split on time will give you the same results
as above. We see that the age:follow up interaction is
statistically significant.


```{r 10.h}
```


The regression equation for the cox2p8Split1 model is 
\begin{align*}
h(t|\text{year8594},\text{sex},\text{agegrp},\text{fu}) &= h_0(t) \exp(\beta_1 I(\text{sex}=\text{"Female"})+\beta_2 I(\text{year8594}=\text{"Diagnosed 85-94"})+\\
&\qquad\beta_3 I(\text{agegrp}=\text{"45-59"})+\beta_4 I(\text{agegrp}=\text{"60-74"})+\beta_5 I(\text{agegrp}=\text{"75+"}) + \\
&\qquad \beta_6 I(\text{agegrp}=\text{"45-59"} \&\ \text{fu}=2)+\beta_7 I(\text{agegrp}=\text{"60-74"}  \&\ \text{fu}=2)+\beta_8 I(\text{agegrp}=\text{"75+"} \&\ \text{fu}=2))
\end{align*}
where $h(t|\text{year8594},\text{sex},\text{agegrp},\text{fu})$ is the hazard at time $t$ given covariates $\text{year8594}$, $\text{sex}$, $\text{agegrp}$ and $\text{fu}$, with baseline hazard $h_0(t)$ and regression coefficients representing log hazard ratios for $\beta_1$ for females, $\beta_2$ for the calendar period 1985--1994, $\beta_3$ for those aged 45--59 years at diagnosis, $\beta_4$ for those aged 60--74 years and $\beta_5$ for those aged 75 years and over, with interaction terms for the change in log hazard ratio for the second follow-up period being $\beta_6$ for those aged 45--59 years at diagnosis, $\beta_7$ for those aged 60--74 years and $\beta_8$ for those aged 75 years and over.


## (i) ## 

              0–2 years   2+ years
------------- ----------- ----------
  Agegrp0-44     1.00        1.00
  Agegrp45-59    1.70        1.23
  Agegrp60-74    2.46        1.70 
  Agegrp75+      5.42        2.67


```{r 10.i}
```

The regression equation for the `cox2p8Split2` model is 
\begin{align*}
h(t|\text{year8594},\text{sex},\text{agegrp},\text{fu}) &= h_0(t) \exp(\beta_1 I(\text{sex}=\text{"Female"})+\beta_2 I(\text{year8594}=\text{"Diagnosed 85-94"})+\\
&\qquad\beta_3 I(\text{agegrp}=\text{"45-59"} \&\ \text{fu}=1)+\beta_4 I(\text{agegrp}=\text{"45-59"} \&\ \text{fu}=2)+\beta_5 I(\text{agegrp}=\text{"60-74"} \&\ \text{fu}=1) + \\
&\qquad \beta_6 I(\text{agegrp}=\text{"60-74"} \&\ \text{fu}=2)+\beta_7 I(\text{agegrp}=\text{"75+"}  \&\ \text{fu}=1)+\beta_8 I(\text{agegrp}=\text{"75+"} \&\ \text{fu}=2))
\end{align*}
where $h(t|\text{year8594},\text{sex},\text{agegrp},\text{agegrp},\text{fu})$ is the hazard at time $t$ given covariates $\text{year8594}$, $\text{sex}$ and $\text{agegrp}$, $\text{agegrp}$ and $\text{fu}$, with baseline hazard $h_0(t)$ and regression coefficients representing log hazard ratios for $\beta_1$ for the calendar period 1985--1994, $\beta_2$ for females, with log hazard ratios for the first and second follow-up period being $\beta_3$ and $\beta_4$ for those aged 45--59 years at diagnosis, $\beta_5$ and $\beta_6$ for those aged 60--74 years and $\beta_7$ and $\beta_8$ for those aged 75 years and over.

We can also use the `tt` argument in `coxph` for modelling for time-varying effects:

```{r 10.ib}
```

The regression equation for the `cox2p8tvct` model is 
\begin{align*}
h(t|\text{year8594},\text{sex},\text{agegrp}) &= h_0(t) \exp(\beta_1 I(\text{sex}=\text{"Female"})+\beta_2 I(\text{year8594}=\text{"Diagnosed 85-94"})+\\
&\qquad\beta_3 I(\text{agegrp}=\text{"45-59"})+\beta_4 I(\text{agegrp}=\text{"60-64"}) + \beta_5 I(\text{agegrp}=\text{"75+"}) + \\
&\qquad \beta_6 I(\text{agegrp}=\text{"45-59"}) t +\beta_7 I(\text{agegrp}=\text{"60-74"})t + \beta_8 I(\text{agegrp}=\text{"75+"}) t)
\end{align*}
where $h(t|\text{year8594},\text{sex},\text{agegrp},\text{agegrp})$ is the hazard at time $t$ given covariates $\text{year8594}$, $\text{sex}$ and $\text{agegrp}$ and $\text{agegrp}$, with baseline hazard $h_0(t)$ and regression coefficients representing log hazard ratios for $\beta_1$ for the calendar period 1985--1994, $\beta_2$ for females, with log hazard ratios at time 0 for those aged 45--59 years, 60--74 years and 75 years and over are $\beta_3$, $\beta_4$ and $\beta_5$, respectively, while the change in log hazard ratios per year for those aged those aged 45--59 years, 60--74 years and 75 years and over are $\beta_3$, $\beta_4$ and $\beta_5$, respectively.

The hazard ratio for model `cox2p8tvct` for the those aged 75 years and over compared with those aged less than 45 years is 
\begin{align*}
\frac{h(t|\text{year8594},\text{sex},\text{agegrp}=\text{"75+"})}{h(t|\text{year8594},\text{sex},\text{agegrp}=\text{"0-44"})} &= 
\frac{h_0(t) \exp(\beta_1 I(\text{sex}=\text{"Female"})+\beta_2 I(\text{year8594}=\text{"Diagnosed 85-94"})+ \beta_5 + \beta_8 t)}{h_0(t)\exp(\beta_1 I(\text{sex}=\text{"Female"})+\beta_2 I(\text{year8594}=\text{"Diagnosed 85-94"}))} \\
&= \exp(\beta_5 + \beta_8 t)
\end{align*}

We have shown several ways to use the `tt` functionality for a factor variable, including using different tt arguments for each factor level (as per model `cox2p8tvc2`) and using a `tt` term that returns a set of columns (as per model `cox2p8tvct`). We have used the `lincom` function to estimate the hazard ratio for `agegrp75+`. We will later describe a more flexible approach to modelling time-dependent effects using `stpm2`.

## (j) ## 

```{r 10.j}
```

We use the `predictnl` function from `rstpm2` to calculate the hazard
ratios and confidence intervals based on the delta method. We see
clear evidence for a rate ratio for those aged 75 years and over
compared with those aged less than 45 years declining by time since
diagnosis. Fitting for an interaction between age 75+ and time from
diagnosis, we get a rate ratio for those aged 75 years at 0.5 years
from diagnosis of 5.19 (95% confidence interval (CI): 3.56, 7.29),
while at 2 years the rate ratio is 3.82 (95% CI: 3.00, 4.86).

Downloading user-written Stata commands and data files
======================================================

\[gettingstarted\] Stata will be used throughout the course. This
section describes how to download and install the files required for the
computing exercises (e.g., data files) as well as how to install
user-written commands for extending Stata. If you are working in a
computer lab during a course it’s possible these files may have already
been installed for you.

Downloading the course files
----------------------------

It is suggested that you create a new directory, change the Stata
working directory to the new directory (e.g., `cd c:\survival\`), and
then download the files. You can create a new directory in Windows
Explorer or you can do it from within Stata as follows.

    mkdir c:\survival
    cd c:\survival

Use the `pwd` command to confirm you are in the working directory you
wish to use for the course. The course files are available on the web as
a ZIP archive:\
<http://biostat3.net/download/biostat3.zip>\
Save and extract this folder in your created working directory. You can
also read the data files directly from the web from within Stata. For
example,

    . use http://www.biostat3.net/download/colon, clear
    (Colon carcinoma, all stages, 1975-94, follow-up to 1995)

Installing Stata user-written commands {#installing_commands}
--------------------------------------

Download and installation of user-written commands is done within Stata.
It is recommended that you change the Stata working directory to the
course directory (e.g., `cd c:\survival\`) before issuing these
commands.

### How can I check if these commands are already installed?

You can use the `which` command to check if (and where) a Stata command
is installed.

    . which stpm2
    c:\ado\plus\s\stpm2.ado
    *! version 1.5.0 29Jul2014

Use the `adoupdate` command to update previously installed user-written
commands (note that this is distinct from the `update` command that
updates official Stata commands). Simply type `adoupdate, update` to
update all user-written commands.

### stpm2 - flexible parametric models

The `stpm2` command, written by Paul Lambert and Patrick Royston, fits
flexible parametric survival models (so called Royston-Parmar models).
It is installed from within Stata using the following commands:

    ssc install stpm2
    ssc install rcsgen

`rcsgen` is a command for generating basis vectors for restricted cubic
splines and is required by `stpm2`.

### Estimating probability of death in a competing risks framework

The `stcompet` command estimates the cumulative incidence function (CIF)
non-parametrically. The `stcompadj` command estimates the CIF using a
competing risks analogue of the Cox model. The `stpm2cm` command
estimates the crude probabilities of death (i.e. CIF) after fitting a
relative survival model using `stpm2`. The `stpm2cif` command estimates
the CIF through postestimation after fitting a cause-specific competing
risks model using `stpm2`.

    ssc install stcompet
    ssc install stcompadj
    ssc install stpm2cm
    ssc install stpm2cif

Exercises
=========

1.  <span>**Hand calculation: Life table and Kaplan-Meier estimates of
    survival**</span>\

    Using hand calculation (i.e., using a spreadsheet program or pen,
    paper, and a calculator) estimate the cause-specific survivor
    function for the sample of 35 patients diagnosed with colon
    carcinoma (see the table below) using both the Kaplan-Meier method
    (up to at least 30 months) and the actuarial method (at least the
    first 5 annual intervals). \[byhand\]

    In the lectures we estimated the observed survivor function
    (i.e. all deaths were considered to be events) using the
    Kaplan-Meier and actuarial methods; your task is to estimate the
    cause-specific survivor function (only deaths due to colon carcinoma
    are considered events) using the same data. The next page includes
    some hints to help you get started.

      ---- -------- ------- ----------- --------- ----- ---- ---------------
                      Age   Clinical      dx date            
      ID   Sex       at dx  stage            mmyy    mm   yy Status
      1    male       72    Localised        2.89     2    0 Dead - other
      2    female     82    Distant         12.91     2    0 Dead - cancer
      3    male       73    Distant         11.93     3    0 Dead - cancer
      4    male       63    Distant          6.88     5    0 Dead - cancer
      5    male       67    Localised        5.89     7    0 Dead - cancer
      6    male       74    Regional         7.92     8    0 Dead - cancer
      7    female     56    Distant          1.86     9    0 Dead - cancer
      8    female     52    Distant          5.86    11    0 Dead - cancer
      9    male       64    Localised       11.94    13    1 Alive
      10   female     70    Localised       10.94    14    1 Alive
      11   female     83    Localised        7.90    19    1 Dead - other
      12   male       64    Distant          8.89    22    1 Dead - cancer
      13   female     79    Localised       11.93    25    2 Alive
      14   female     70    Distant          6.88    27    2 Dead - cancer
      15   male       70    Regional         9.93    27    2 Alive
      16   female     68    Distant          9.91    28    2 Dead - cancer
      17   male       58    Localised       11.90    32    2 Dead - cancer
      18   male       54    Distant          4.90    32    2 Dead - cancer
      19   female     86    Localised        4.93    32    2 Alive
      20   male       31    Localised        1.90    33    2 Dead - cancer
      21   female     75    Localised        1.93    35    2 Alive
      22   female     85    Localised       11.92    37    3 Alive
      23   female     68    Distant          7.86    43    3 Dead - cancer
      24   male       54    Regional         6.85    46    3 Dead - cancer
      25   male       80    Localised        6.91    54    4 Alive
      26   female     52    Localised        7.89    77    6 Alive
      27   male       52    Localised        6.89    78    6 Alive
      28   male       65    Localised        1.89    83    6 Alive
      29   male       60    Localised       11.88    85    7 Alive
      30   female     71    Localised       11.87    97    8 Alive
      31   male       58    Localised        8.87   100    8 Alive
      32   female     80    Localised        5.87   102    8 Dead - cancer
      33   male       66    Localised        1.86   103    8 Dead - other
      34   male       67    Localised        3.87   105    8 Alive
      35   female     56    Distant         12.86   108    9 Alive
      ---- -------- ------- ----------- --------- ----- ---- ---------------

    We suggest you start with the actuarial approach. Your task is to
    construct a life table with the following structure.

    <span>@lrccrcccc</span> time&$l$&$d$&$w$&$l'$&$p$& $S(t)$\
    \
    <span>\[</span>0-1) & 35 & & & & &\
    \
    \
    <span>\[</span>1-2) & & & & & &\
    \
    \
    <span>\[</span>2-3) & & & & & &\
    \
    \
    <span>\[</span>3-4) & & & & & &\
    \
    \
    <span>\[</span>4-5) & & & & & &\
    \
    \
    <span>\[</span>5-6) & & & & & &\
    \

    We have already entered $l_1$ (number of people alive at the start
    of interval 1). The next step is to add the number who experienced
    the event ($d$) and the number censored ($w$) during the first year.
    From $l$, $d$, and $w$ you will then be able to calculate $l'$
    (effective number at risk), followed by $p$ (conditional probability
    of surviving the interval) and finally $S(t)$, the cumulative
    probability of surviving from time zero until the end of
    the interval.

     \
    <span>**KAPLAN-MEIER APPROACH**</span>

    To estimate survival using the Kaplan-Meier approach you will find
    it easiest to add a line to the table at each and every time there
    is an event or censoring. We should use time in months. The first
    time at which there is an event or censoring is time equal to
    2 months. The trick is what to do when there are both events and
    censorings at the same time.

    <span>@ccccrccc</span> time&\# at risk&$d$&$w$&$p$& $S(t)$\
    \
    2 & 35 & & & & &\
    \
    \
    & & & & & &\
    \
    \
    & & & & & &\
    \
    \
    & & & & & &\
    \

2.  <span>**Using Stata to validate the hand calculations done in part
    1 (a)**</span> We will now use Stata to reproduce the same analyses
    done by hand calculation in part 1 (a) although you can do this part
    without having done the hand calculations, since this question also
    serves as an introduction to survival analysis using Stata. Our aim
    is to estimate the cause-specific survivor function for the sample
    of 35 patients diagnosed with colon carcinoma using both the
    Kaplan-Meier method and the actuarial method. In the lectures we
    estimated the all-cause survivor function (i.e. all deaths were
    considered to be events) using the Kaplan-Meier and actuarial
    methods whereas we will now estimate the cause-specific survivor
    function (only deaths due to colon carcinoma are considered events).

    After starting Stata, you will first have to specify the data set
    you wish to analyse, that is

    `. use colon_sample, clear`

    Stata will search for this file in the current working directory.
    The `pwd` command will return the name of the current
    working directory. If you need to change to another directory you
    can use, for example, `cd c:\survival\`. The `describe` command will
    return a summary of the data set structure (e.g., variable names)
    whereas the `list` command will display the values of variables.

    In order to use the Stata `ltable` command (life table estimates of
    the survivor function) we must construct a new variable indicating
    whether the observation period ended with an event (the new variable
    is assigned code 1) or censoring (the new variable is assigned
    code 0). We will call this new variable `csr_fail`
    (cause-specific failure). The `ltable` command is not a standard
    Stata survival analysis (`st`) command and does not require that the
    data be `stset`.

    `. recode status (1=1) (nonmissing=0), gen(csr_fail)`

    There are many ways to create the new variable, the above approach
    is preferred because missing values of status will remain missing.
    Even though we don’t have any missing values, it is good programming
    practice to always write code that will handle missing
    values appropriately.

    The following command will give the actuarial estimates

    `. ltable surv_yy csr_fail`

    Alternatively, we could use

    `. ltable surv_mm csr_fail, interval(12)`

    Before most Stata survival analysis commands can be used (`ltable`
    is an exception) we must first `stset` the data using the `stset`
    command (see Section \[Statasurvival\]).

    `. stset surv_mm, failure(status==1)`

    A listing of the Kaplan-Meier estimates is then obtained as follows

    `. sts list`

    To graph the Kaplan-Meier estimates

    `. sts graph`

    Note that we only have to `stset` the data once. You can also tell
    Stata to show the number at risk either on the curve or in a table.

    `. sts graph, atrisk`\
    `. sts graph, risktable`

    Titles and axis labels can also be specified.

    `. sts graph, risktable ///`\
    `       title(Kaplan-Meier estimates of cause-specific survival) ///`\
    `       xtitle(Time since diagnosis in months)`

3.  <span>**Melanoma: Comparing survival proportions and mortality rates
    by stage for cause-specific and all-cause survival**</span>\

    The purpose of this exercise is to study survival of the patients
    using two alternative measures - survival proportions and
    mortality rates. A second purpose is to study the difference between
    cause-specific and all-cause survival.

    `. use melanoma, clear`\
    `. stset surv_mm, failure(status==1)`

    1.  Plot estimates of the survivor function and hazard function
        by stage.

        `. sts graph, by(stage)`\
        `. sts graph, hazard by(stage)`

        By default, the `sts graph` command plots Kaplan-Meier estimates
        of survival. If we add the `hazard` option it shows estimates of
        the hazard function. Does it appear that stage is associated
        with patient survival?

        Stata tip: You may have found that each time you produce a graph
        Stata overwrites the previous graph in the graph window. You can
        instruct Stata to open each graph in a separate window by naming
        the graphs. This will give you the possibility to compare graphs
        side by side.

        `. sts graph, by(stage) name(survival)`\
        `. sts graph, by(stage) name(hazard) hazard`

        You can use `set autotabgraphs` to control whether multiple
        graphs are created as tabs within one window or as
        separate windows. Issue the following command to make Stata
        present graphs as tabs within a single window (and store the
        setting permanently).

        `set autotabgraphs on, permanently`

    2.  Estimate the mortality rates for each stage using, for example,
        the `strate` command.

        `. strate stage`

        What are the units of the estimated rates?

        \[The `strate` command, as the name suggests, is used to
        estimates rates. Look at the help pages if you are not familiar
        with the command.\]

    3.  If you haven’t already done so, estimate the mortality rates for
        each stage per 1000 person-years of follow-up.

        \[HINT: consider the `scale()` option to `stset` and the `per()`
        option to `strate`.\]

    4.  Study whether survival is different for males and females (both
        by plotting the survivor function and by tabulating
        mortality rates).

        `. sts graph, by(sex)`\
        `. sts graph, hazard by(sex)`

        Is there a difference in survival between males and females? If
        yes, is the difference present throughout the follow up?

    5.  The plots you made above were based on cause-specific survival
        (i.e., only deaths due to cancer are counted as events, deaths
        due to other causes are censored). In the next part of this
        question we will estimate all-cause survival (i.e., any death is
        counted as an event). First, however, study the coding of vital
        status and tabulate vital status by age group.

        How many patients die of each cause? Does the distribution of
        cause of death depend on age?

        `. codebook status`\
        `. tab status agegrp`

    6.  To get all-cause survival, specify all deaths (both cancer
        and other) as events in the stset command.

        `. stset surv_mm, failure(status==1,2)`

        Now plot the survivor proportion for all-cause survival
        by stage. We name the graph to be able to separate them in the
        graph window. Is the survivor proportion different compared to
        the cause-specific survival you estimated above? Why?

        `. sts graph, by(stage) name(anydeath, replace)`

    7.  It is more common to die from a cause other than cancer in
        older ages. How does this impact the survivor proportion for
        different stages? Compare cause-specific and all-cause survival
        by plotting the survivor proportion by stage for the oldest age
        group (75+ years) for both cause-specific and
        all-cause survival. We suggest you copy the code from the PDF
        file into the Stata do editor and run the code from there.

        `. stset surv_mm, failure(status==1)`\
        `. sts graph if agegrp==3, by(stage) ///`\
        `       name(cancerdeath_75, replace) subtitle(`“`Cancer`”`)`\
        `. stset surv_mm, failure(status==1,2)`\
        `. sts graph if agegrp==3, by(stage) ///`\
        `       name(anydeath_75, replace) subtitle(`“`All cause`”`)`\
        `. graph combine cancerdeath_75 anydeath_75`

    8.  Now estimate both cancer-specific and all-cause survival for
        each age group.

        `. use melanoma, clear`\
        `. stset surv_mm, failure(status==1,2)`\
        `. sts graph, by(agegrp) name(anydeathbyage, replace) subtitle(`“`All cause`”`)`\
        \
        `. stset surv_mm, failure(status==1)`\
        `. sts graph, by(agegrp) name(cancerdeathbyage, replace) subtitle(`“`Cancer`”`)`\
        \
        `. graph combine anydeathbyage cancerdeathbyage`

        Are there bigger differences between the age groups for
        cause-specific or for all-cause survival?

4.  <span>**Localised melanoma: Comparing estimates of cause-specific
    survival between periods; first graphically and then using the log
    rank test**</span>\

    \[melanomakm\] We will now analyse the full data set of patients
    diagnosed with localised skin melanoma.

    Use Stata to estimate the cause-specific survivor function, using
    the Kaplan-Meier method with survival time in months, separately for
    each of the two calendar periods 1975–1984 and 1985–1994. The
    following commands can be used

    `. use melanoma if stage == 1, clear`\
    `. stset surv_mm, failure(status==1)`\
    `. sts graph, by(year8594)`

    The variable `year8594` takes the value 1 for patients diagnosed
    1985–1994 and 0 for those diagnosed 1975–1984.

    1.  Without making reference to any formal statistical tests, does
        it appear that patient survival is superior during the most
        recent period?

    2.  The following commands can be used to plot the hazard function
        (instantaneous mortality rate):

            . sts graph, hazard by(year8594)

        1.  At what point in the follow-up is mortality highest?

        2.  Does this pattern seem reasonable from a
            clinicial/biological perspective? \[HINT: Consider the
            disease with which these patients were classified as being
            diagnosed along with the expected fatality of the disease as
            a function of time since diagnosis.\]

    3.  \[logrank\] Use the log rank test to determine whether there is
        a statistically significant difference in patient survival
        between the two periods. The following command can be used:

        `. sts test year8594`

        What do you conclude?

        An alternative test is the generalised Wilcoxon, which can be
        obtained as follows

        `. sts test year8594, wilcoxon`

        <span>*Haven’t heard of the log rank (or Wilcoxon) test?*</span>
        It’s possible you may reach this exercise before we cover the
        details of these tests during lectures. You should nevertheless
        do the exercise and try and interpret the results. Both of these
        tests (the log rank and the generalised Wilcoxon) are used to
        test for differences between the survivor functions. The null
        hypothesis is that the survivor functions are equivalent for the
        two calendar periods (i.e., patient survival does not depend on
        calendar period of diagnosis).

    4.  Estimate cause-specific mortality rates for each age group, and
        graph Kaplan-Meier estimates of the cause-specific survivor
        function for each age group. Are there differences between the
        age groups? Is the interpretation consistent between the
        mortality rates and the survival proportions?

        `. strate agegrp, per(1000)`\
        `. sts graph, by(agegrp)`

        What are the units of the estimated hazard rates? HINT: look at
        how you defined time when you `stset` the data.

    5.  Repeat some of the previous analyses after using the `scale()`
        option to stset to rescale time from months to years. This is
        equivalent to dividing the time variable by 12 so all analyses
        will be the same except the units of time will be different
        (e.g., the graphs will have different labels).

        `. stset surv_mm, failure(status==1) scale(12)`\
        `. sts graph, by(agegrp)`\
        `. strate agegrp, per(1000)`

    6.  Study whether there is evidence of a difference in patient
        survival between males and females. Estimate both the hazard and
        survival function and use the log rank test to test for
        a difference.

5.  <span>**Localised melanoma: Comparing actuarial and Kaplan-Meier
    approaches with discrete time data**</span>\

    The aim of this exercise is to examine the effect of heavily grouped
    data (i.e., data with lots of ties) on estimates of survival made
    using the Kaplan-Meier method and the actuarial method.

    For the patients diagnosed with localised skin melanoma, use Stata
    to estimate the 10-year cause-specific survival proportion. Use both
    the Kaplan-Meier method and the actuarial method. Do this both with
    survival time recorded in completed years and survival time recorded
    in completed months. That is, you should obtain 4 separate estimates
    of the 10-year cause-specific survival proportion to complete the
    cells of the following table. The purpose of this exercise is to
    illustrate small differences between the two methods when there are
    large numbers of ties.

    In order to reproduce the results in the printed solutions you’ll
    need to restrict to localised stage (`stage==1`) and estimate
    cause-specific survival (`status==1` indicates an event). Look at
    the Stata code in the previous questions if you are unsure.

                Actuarial   Kaplan-Meier
      -------- ----------- --------------
                           
         Years             
                           
        Months             

    1.  Of the two estimates (Kaplan-Meier and actuarial) made using
        time recorded in years, which do you think is the most
        appropriate and why?

        \[HINT: Consider how each of the methods handle ties.\]

    2.  Which of the two estimates (Kaplan-Meier or actuarial) changes
        most when using survival time in months rather than years? Why?

6.  <span>**Diet data: tabulating incidence rates and modelling with
    Poisson regression**</span> \[diet:poisson\]\

    Load the <span>diet</span> data and `stset` the data using
    time-on-study as the timescale.

        . use diet, clear
        . stset dox, id(id) fail(chd) origin(doe) scale(365.24)

    1.  Use the <span>strate</span> command to tabulate CHD incidence
        rates per 1000 person-years for each category of `hieng`.
        Calculate (by hand) the ratio of the two incidence rates.

    2.  Use the command <span>poisson</span> to find the incidence rate
        ratio for the high energy group compared to the low energy group
        and compare the estimate to the one you obtained in the previous
        question:

            . poisson chd hieng, e(y) irr

        NOTE: Rates are calculated as events/person-time so when
        modelling rates we need to let Stata know both of
        these quantities. `chd` is the event indicator and `y` is the
        person time at risk for each individual. The `irr` option
        results in the estimates being presented as estimated incidence
        rate ratios rather than parameter estimates (log incidence
        rate ratios).

    3.  Grouping the values of total energy into just two groups does
        not tell us much about how the CHD rate changes with
        total energy. It is a useful exploratory device, but to look
        more closely we need to group the total energy into perhaps 3 or
        4 groups. In this example we shall use the cut points
        $1500, 2500, 3000, 4500$. To check if these cutpoints seem
        reasonable, type:

            . histogram energy, normal
            . sum energy, detail

    4.  Use the commands

            . egen eng3=cut(energy), at(1500, 2500, 3000, 4500)
            . tabulate eng3

        to create a new variable <span>eng3</span> coded 1500 for values
        of <span>energy</span> in the range 1500–2499, 2500 for values
        in the range 2500–2999, and 3000 for values in the
        range 3000–4500.

    5.  \[e\] To estimate and plot the rates for different levels of
        <span>eng3</span> try

            . strate eng3, per(1000) graph

        Calculate (by hand) the ratio of rates in the second and third
        levels to the first level.

    6.  Create your own indicator variables for the three levels of
        <span>eng3</span> with

            . tabulate eng3, gen(X)

    7.  Check the indicator variables with

            . list energy eng3 X1 X2 X3 if eng3==1500
            . list energy eng3 X1 X2 X3 if eng3==2500
            . list energy eng3 X1 X2 X3 if eng3==3000

    8.  Use <span>poisson</span> to compare the second and third levels
        with the first, as follows:

            . poisson chd X2 X3, e(y) irr

        Compare your estimates with those you obtained in part \[e\].

    9.  Use <span>poisson</span> to compare the first and third levels
        with the second.

    10. Repeat the analysis comparing the second and third levels with
        the first but this time have Stata create the indicators
        automatically via the `i.` syntax. That is

            . poisson chd i.eng3, e(y) irr

    11. Without using `st` commands, calculate the total number of
        events during follow-up, person-time at risk, and the crude
        incidence rate (per 1000 person-years), for example with Stata
        commands for descriptive statistics (e.g., summarize). Confirm
        your answer using `strate` or `stptime`. \[HINT: Remember that
        the total number of person-years is the number of persons at
        risk multiplied with the mean follow up time among those
        persons.\]

7.  <span>**Localised melanoma: model cause-specific mortality with
    Poisson regression**</span> \[locmel:csr:poisson\]\

    In this exercise we model, using Poisson regression, cause-specific
    mortality of patients diagnosed with localised
    (`stage==1`) melanoma.

    In exercise \[locmel:csr:cox\] we model cause-specific mortality
    using Cox regression and in exercise \[locmel:csr:fpm\] we use
    flexible parametric models. The aim is to illustrate that these
    three methods are very similar.

    The aim of these exercises is to explore the similarities and
    differences to these three approaches to modelling. We will be
    comparing the results (and their interpretation) as we proceed
    through the exercises so you may wish to save your commands in a do
    file to facilitate comparison.

    The following commands can be used to load and `stset` the data.

    `. use melanoma if stage==1, clear`\
    `. stset surv_mm, failure(status==1) scale(12) id(id)`

    1.  Plot Kaplan-Meier estimates of cause-specific survival as a
        function of calendar period of diagnosis.

        `. sts graph, by(year8594)`

        \[localmel:rate:adjusted\]

        1.  During which calendar period (the early or the latter) is
            survival best?

        2.  Now plot the estimated hazard function (cause-specific
            mortality rate) as a function of calendar period
            of diagnosis.

            `. sts graph, by(year8594) hazard`

            During which calendar period (the early or the latter) is
            mortality the lowest?

        3.  Is the interpretation (with respect to how prognosis depends
            on period) based on the hazard consistent with the
            interpretation of the survival plot?

    2.  Use the `strate` command to estimate the cause-specific
        mortality rate for each calendar period.

        `. strate year8594, per(1000)`

        \[localmel:rate:unadjusted\] During which calendar period (the
        early or the latter) is mortality the lowest? Is this consistent
        with what you found earlier? If not, why the inconsistency?

    3.  The reason for the inconsistency between
        parts \[localmel:rate:adjusted\] and
        \[localmel:rate:unadjusted\] was confounding by time
        since diagnosis. The comparison in
        part \[localmel:rate:adjusted\] was adjusted for time since
        diagnosis (since we compare the differences between the curves
        at each point in time) whereas the comparison in
        part \[localmel:rate:unadjusted\] was not. Understanding this
        concept is central to the remainder of the exercise so please
        ask for help if you don’t follow.

        Two approaches for controlling for confounding are ‘restriction’
        and ‘statistical adjustment’. We will first use restriction to
        control for confounding. That is we will `stset` the data again
        but use the `exit(time 120)` option to restrict the potential
        follow-up time to a maximum of 120 months. Individuals who
        survive more than 120 months are censored at 120 months

        `. use melanoma if stage==1, clear`\
        `. stset surv_mm, failure(status==1) scale(12) id(id) exit(time 120)`

        1.  Use the `strate` command to estimate the cause-specific
            mortality rate for each calendar period.

            `. strate year8594, per(1000)`

            During which calendar period (the early of the latter) is
            mortality the lowest? Is this consistent with what you found
            in part \[localmel:rate:unadjusted\]?

        2.  Calculate by hand the ratio (85–94/75–84) of the two
            mortality rates (i.e., a mortality rate ratio) and interpret
            the estimate (i.e., during which period is mortality
            higher/lower and by how much).

        3.  Now use Poisson regression to estimate the same mortality
            rate ratio.

            `. streg year8594, dist(exp)`

        NOTE: `streg` is one of several Stata commands for performing
        Poisson regression. The model could also be fitted using the
        `poisson` or `glm` commands.

        `. gen risktime=_t-_t0`\
        `. poisson _d year8594 if _st==1, exp(risktime) irr`\
        `. glm _d year8594  if _st==1, family(poisson) eform lnoffset(risktime)`

        However, if you have stset/stsplit the data it is recommended
        that you use `streg` since `streg` understands and respects the
        internal `st` variables (`_st`, `_t`, `_t0`, and `_d`). In
        particular, ‘trimmed’ person-time will be ignored by `streg` but
        not by the `poisson` command.

        Strictly speaking, `streg` fits parametric survival models. A
        parametric survival model assuming survival times are
        exponentially distributed (`dist(exp)`) implies a constant
        hazard and a Poisson process for the number of events (i.e.,
        Poisson regression).

    4.  In order to adjust for time since diagnosis (i.e., adjust for
        the fact that we expect mortality to depend on time
        since diagnosis) we need to split the data by this timescale. We
        will restrict our analysis to mortality up to 10 years
        following diagnosis.

        `. stsplit fu, at(0(1)10) trim`

        NOTE: The `trim` option instructs Stata to ignore time-at-risk
        outside the interval \[0,10\] (i.e., after 10 years subsequent
        to diagnosis). Since we have already made this restriction using
        `stset` there should not be any time ‘trimmed’.

    5.  Now tabulate (and produce a graph of) the rates by
        follow-up time.

        `. strate fu, per(1000) graph`

        Mortality appears to be quite low during the first year
        of follow-up. Does this seem reasonable considering the disease
        with which these patients have been diagnosed?

    6.  Compare the plot of the estimated rates to a plot of the hazard
        rate as a function of continuous time.

        `. sts graph, hazard`

        Is the interpretation similar? Do you think it is sufficient to
        classify follow-up time into annual intervals or might it be
        preferable to use, for example, narrower intervals?

    7.  Use Poisson regression to estimate incidence rate ratios as a
        function of follow-up time.

        `. streg i.fu, dist(exp)`

        Does the pattern of estimated incident rate ratios mirror the
        pattern you observed in the plots?

    8.  Now estimate the effect of calendar period of diagnosis while
        adjusting for time since diagnosis. Before fitting this model,
        predict what you expect the estimated effect to be (i.e., will
        it be higher, lower, or similar to the value of $0.8831852$ we
        obtained in part c).

        `. streg i.fu year8594, dist(exp)`

        Is the estimated effect of calendar period of diagnosis
        consistent with what you expected? Add an interaction between
        follow-up and calendar period of diagnosis and interpret
        the results.

    9.  \[localmel:poisson\] Now control for age, sex, and
        calendar period.

        `. streg i.fu i.agegrp year8594 sex, dist(exp)`

        1.  Interpret the estimated hazard ratio for the parameter
            labelled `agegrp 2`, including a comment on
            statistical significance.

        2.  Is the effect of calendar period strongly confounded by age
            and sex? That is, does the inclusion of sex and age in the
            model change the estimate for the effect of calendar period?

        3.  Perform a Wald test of the overall effect of age and
            interpret the results.

            `. test 1.agegrp 2.agegrp 3.agegrp`

    10. \[localmel:agesexinteraction\] Is the effect of sex modified by
        calendar period (whilst adjusting for age and follow-up)? Fit an
        appropriate interaction term to test this hypothesis.

    11. Based on the interaction model you fitted in
        exercise \[localmel:agesexinteraction\], estimate the hazard
        ratio for the effect of sex (with 95% confidence interval) for
        each calendar period.

        ADVANCED: Do this with each of the following methods and confirm
        that the results are the same:

        1.  Using hand-calculation on the estimates
            from exercise \[localmel:agesexinteraction\].

        2.  Using the estimates from
            exercise \[localmel:agesexinteraction\] and the
            `lincom` command.

            ` . lincom 2.sex + 1.year8594#2.sex, eform`

        3.  Creating appropriate dummy variables that represent the
            effects of sex for each calendar period.

            `. gen sex_early=(sex==2)*(year8594==0)`\
            `. gen sex_latter=(sex==2)*(year8594==1)`\
            `. streg i.fu i.agegrp year8594 sex_early sex_latter, dist(exp)`

        4.  Using Stata 11 syntax to repeat the previous model.

            `. streg i.fu i.agegrp i.year8594 year8594#sex, dist(exp)`

    12. Now fit a separate model for each calendar period in order to
        estimate the hazard ratio for the effect of sex (with 95%
        confidence interval) for each calendar period. Why do the
        estimates differ from those you obtained in the previous part?

        `. streg i.fu i.agegrp sex if year8594==0, dist(exp)`\
        `. streg i.fu i.agegrp sex if year8594==1, dist(exp)`

        Can you fit a single model that reproduces the estimates you
        obtained from the stratified models? Try:

        `. streg i.fu##year8594 i.agegrp##year8594 year8594##sex, dist(exp)`

8.  <span>**Diet data: Using Poisson regression to study the effect of
    energy intake adjusting for confounders on two different
    timescales**</span>\

    Use Poisson regression to study the association between energy
    intake (`hieng`) and CHD adjusted for potential confounders
    (job, BMI). We know that people who expend a lot of energy (i.e.,
    are physically active) require a higher energy intake. We do not
    have data on physical activity but we are hoping that
    occupation (job) will serve as a surrogate measure of work-time
    physical activity (conductors on London double-decker busses expend
    energy walking up and down the stairs all day).

    Fit models both without adjusting for ‘time’ and by adjusting for
    attained age (you will need to split the data) and time-since-entry
    and compare the results.

    1.  Rates can be modelled on different timescales, e.g., attained
        age, time-since-entry, calendar time. Plot the CHD incidence
        rates both by attained age and by time-since-entry. Is there a
        difference? Do the same for CHD hazard by different energy
        intakes (hieng).

        `. use diet, clear`\
        \
        `.* Timescale: Attained age`\
        `. stset dox, id(id) fail(chd) origin(dob) enter(doe) scale(365.24)`\
        `. sts graph, hazard`\
        `. sts graph, by(hieng) hazard`\
        \
        `.* Timescale: Time-since-entry`\
        `. stset dox, id(id) fail(chd) origin(doe) enter(doe) scale(365.24)`\
        `. sts graph, hazard`\
        `. sts graph, by(hieng) hazard`

    2.  Model the rate using Poisson regression, without adjusting for
        any timescale. What is the effect of hieng on CHD? What
        assumption does this model make on the shape of the underlying
        incidence rate over time?

        `. poisson chd hieng, e(y) irr`

    3.  Adjust for BMI and job. Is there evidence that the effect of
        energy intake on CHD is confounded by BMI and job?

        `. gen bmi=weight/(height/100*height/100)`\
        `. poisson chd hieng job bmi, e(y) irr`

    4.  Firstly, let’s adjust for the timescale attained age. To do this
        in Poisson regression you must split the data on timescale age.
        First use `stset` (with origin date of birth) and then use
        `stsplit` to generate agebands.

        `. stset dox, id(id) fail(chd) origin(dob) enter(doe) scale(365.24)`\
        `. stsplit ageband, at(30,50,60,72) trim`\
        `. list id _t0 _t ageband y in 1/10`

        As the poisson command is not an `st` command, you must keep
        track of the risktime yourself. Why is the y variable not
        correct anymore? Generate a new variable, `risktime`, which
        contains the risktime for each split record.

        `. gen risktime=_t-_t0`\
        `. list id _t0 _t ageband y risktime in 1/10`

        You must also keep track of the event variable, as `chd` will
        not be valid after the split.

        `. tab ageband chd, missing`\
        `. tab ageband _d, missing`

        Now fit the model for CHD, both without and with the adjustment
        for `job` and `bmi`. Is the effect of hieng on CHD confounded by
        age, BMI or job?

        `. poisson _d hieng i.ageband, e(risktime) irr`\
        `. poisson _d hieng i.job bmi i.ageband, e(risktime) irr`

        What assumption is being made about the shape of the baseline
        hazard (HINT: the baseline hazard takes the shape of the
        timescale)?

    5.  Secondly, do the same analysis, but now adjust for the
        timescale time-since-entry. (You must read the data in again, as
        you now want to split on another timescale. This is strictly not
        necessary, but to avoid mistakes it is generally a good idea to
        start over again.)

        `. use diet, clear`\
        `. gen bmi=weight/(height/100*height/100)`

        Specify time-since-entry as the timescale by specifying date of
        entry as the time origin.

        `. stset dox, id(id) fail(chd) origin(doe) enter(doe) scale(365.24)`\
        \
        `. stsplit fuband, at(0,5,10,15,22) trim`\
        `. list id _t0 _t fuband y in 1/10`\
        \
        `. gen risktime=_t-_t0`\
        `. list id _t0 _t fuband y risktime in 1/10`\
        \
        `. tab fuband chd, missing`\
        `. tab fuband _d, missing`\
        \
        `. poisson _d hieng i.fuband, e(risktime) irr`\
        `. poisson _d hieng i.job bmi i.fuband, e(risktime) irr`

        Compare the results with the analysis adjusted for attained age.
        Are there any differences? Why (or why not)? Go back to the
        graphs at the beginning of the exercise and look
        for explanations.

    6.  Repeat the exercise using `streg`. What is the
        advantage/disadvantage of using streg?

9.  <span>**Localised melanoma: modelling cause-specific mortality using
    Cox regression**</span> \[locmel:csr:cox\]\

    In exercise \[locmel:csr:poisson\] we modelled the cause-specific
    mortality of patients diagnosed with localised melanoma using
    Poisson regression. We will now model cause-specific mortality using
    Cox regression and compare the results to those we obtained using
    the Poisson regression model.

    To fit a Cox proportional hazards model (for
    cause-specific survival) with calendar period as the only
    explanatory variable, the following commands can be used. Note that
    we are censoring all survival times at 120 months (10 years) in
    order to facilitate comparisons with the Poisson regression model
    in exercise \[locmel:csr:poisson\].

    `. use melanoma`\
    `. keep if stage == 1`\
    `. stset surv_mm, failure(status==1) exit(time 120)`\
    `. stcox year8594`

    1.  Interpret the estimated hazard ratio, including a comment on
        statistical significance.

    2.  (This part is more theoretical and is not required in order to
        understand the remaining parts.)

        Stata reports a Wald test of the null hypothesis that survival
        is independent of calendar period. The test statistic (and
        associated P-value) is reported in the table of parameter
        estimates (labelled `z`). Under the null hypothesis, the test
        statistic has a standard normal (Z) distribution, so the square
        of the test statistic will have a chi square distribution with
        one degree of freedom.

        Stata also reports a likelihood ratio test statistic of the null
        hypothesis that none of the parameters in the model are
        associated with survival (labelled `LR chi2(1)`). In general,
        this test statistic will have a chi-square distribution with
        degrees of freedom equal to the number of parameters in
        the model. For the current model, with only one parameter, the
        test statistic has a chi square distribution with one degree
        of freedom.

        Compare these two test statistics with each other and with the
        log rank test statistic (which also has a
        $\chi^2_1$ distribution) calculated in question \[logrank\] (you
        should, however, recalculate the log rank test since we have
        restricted follow-up to the first 10 years in this exercise).
        Would you expect these test statistics to be similar? Consider
        the null and alternative hypotheses of each test and the
        assumptions involved with each test.

    3.  \[localmel:cox\] Now include sex and age (in categories) in
        the model.

        `. stcox sex year8594 i.agegrp`

        1.  Interpret the estimated hazard ratio for the parameter
            labelled `agegrp 2`, including a comment on
            statistical significance.

        2.  Is the effect of calendar period strongly confounded by age
            and sex? That is, does the inclusion of sex and age in the
            model change the estimate for the effect of calendar period?

        3.  Perform a Wald test of the overall effect of age and
            interpret the results.

            `. test 1.agegrp 2.agegrp 3.agegrp`

    4.  Perform a likelihood ratio test of the overall effect of age and
        interpret the results. The following commands can be used

        `. stcox sex year8594 i.agegrp`\
        `. est store A`\
        `. stcox sex year8594`\
        `. lrtest A`

        Compare your findings to those obtained using the Wald test. Are
        the findings similar? Would you expect them to be similar?

    5.  The model estimated in question \[localmel:cox\] is similar to
        the model estimated in question \[localmel:poisson\].

        1.  Both models adjust for `sex, year8594,` and `i.agegrp ` but
            the Poisson regression model in
            question \[localmel:poisson\] appears to adjust for an
            additional variable (`i.fu`). Is the Poisson regression
            model adjusting for an additional factor? Explain.

        2.  Would you expect the parameter estimate for sex, period, and
            age to be similar for the two models? Are they similar?

        3.  Do both models assume proportional hazards? Explain.

        Following is some code for estimating and comparing the Cox and
        Poisson regression models (you might wish to copy this code from
        the PDF version of this document and paste it into the Stata do
        file editor or use `compare_cox_poisson.do`.

            use melanoma if stage==1, clear
            stset surv_mm, failure(status==1) id(id) exit(time 120)
            stcox year8594 sex i.agegrp
            est store Cox

            /* split on time since diagnosis */
            stsplit fu, at(0(12)120) trim

            streg i.fu year8594 sex i.agegrp, dist(exp)
            est store Poisson
            est table Cox Poisson, eform equations(1)

    6.  ADVANCED: By splitting at each failure time we can estimate a
        Poisson regression model that is identical to the Cox model.
        Code is available in the file `compare_cox_poisson.do` on the
        course website. This model takes several minutes to estimate and
        you may need to reset the values of `memory` and `matsize`.

    7.  ADVANCED: Split the data finely (e.g., 3-month intervals) and
        model the effect of time using a restricted cubic spline.

            use melanoma if stage==1, clear
            stset surv_mm, failure(status==1) id(id) exit(time 120)
            /* split on time since diagnosis (1-month intervals) */
            stsplit fu, at(0(1)120) trim
            /* Create basis for restricted cubic spline */
            mkspline fu_rcs=fu, cubic
            streg fu_rcs* year8594 sex i.agegrp, dist(exp)
            predict xb, xb
            twoway line xb fu if year8594==0 & sex==1 & agegrp==1, sort

10. <span>**Examining the proportional hazards hypothesis
    (localised melanoma)**</span>\

    1.  For the localised melanoma data with 10 years follow-up, plot
        the instantaneous cause-specific hazard for each
        calendar period. The following commands can be used

        `. use melanoma if stage == 1, clear`\
        `. stset surv_mm, failure(status==1) id(id) exit(time 120) scale(12)`\
        `. sts graph, hazard by(year8594)`

        Make a rough estimate of the hazard ratio for patients diagnosed
        1985–94 to those diagnosed 1975–84. In part (d) you will fit a
        Cox model and check your estimate.

    2.  Now plot the instantaneous cause-specific hazard for each
        calendar period using a log scale for the y axis (use the option
        `yscale(log)`). What would you expect to see if a proportional
        hazards assumption were appropriate? Do you see it?

    3.  Another graphical way of checking the proportional hazards
        assumption is to plot the log cumulative cause specific hazard
        function for each calendar period. These plots were not given
        extensive coverage in the lectures, so attempt this if you like
        or continue to part (d). The command for plotting this function
        is

        `. stphplot, by(year8594)`

        What would you expect to see if a proportional hazards
        assumption were appropriate? Do you see it?

    4.  Compare your estimated hazard ratio from part (a) with the one
        from a fitted Cox model with calendar period as the only
        explanatory variable. Are they similar?

    5.  Now fit a more complex model and use graphical methods to
        explore the assumption of proportional hazards by
        calendar period. For example,

        `. stcox sex i.year8594 i.agegrp`\
        `. estat phtest, plot(1.year8594)`

        What do you conclude?

    6.  Do part (a)–(e) but now for the variable `agegrp`. What are your
        conclusions regarding the assumption of proportional hazards?

    7.  Now formally test the assumption of proportional hazards using

        `. stcox sex i.year8594 i.agegrp`\
        `. estat phtest, detail`

        Are your conclusions from the test coherent with your
        conclusions from the graphical assessments?

    8.  Estimate separate age effects for the first two years of
        follow-up (and separate estimates for the remainder of
        the follow-up) while controlling for sex and period. Do the
        estimates for the effect of age differ between the two periods
        of follow-up?

        There are two ways to fit time-varying effects: 1) the tvc
        option in stcox or 2) by splitting on time using stsplit.

        Using tvc:

        `. tab(agegrp), gen(agegrp)`\
        `. stcox sex year8594 agegrp2 agegrp3 agegrp4, ///`\
        `            tvc(agegrp2 agegrp3 agegrp4) texp(_t>=2)`

        Using stsplit:

        `. stsplit fuband, at(0,2)`\
        `. list id _t0 _t fu in 1/10`\
        \
        `. stcox sex year8594 i.agegrp##i.fuband`

        These are simply two alternative syntaxes for fitting the same
        model with the same parameterizations. They give the so-called
        default parameterizations for interaction effects. We see
        effects of age (i.e., the hazard ratios) for the period 0–2
        years subsequent to diagnosis along with the
        interaction effects. An advantage of the default
        parameterisation is that one can easily test the statistical
        significance of the interaction effects. Before going further,
        test whether the age\*follow-up interaction is statistically
        significant (using a Wald and/or LR test).

    9.  Often we wish to see the effects of exposure (age) for each
        level of the modifier (time since diagnosis). That is, we would
        like to complete the table below with relevant hazard ratios. To
        get the effects of age for the period 2+ years after diagnosis,
        using the default parametrization, we must multiply the hazard
        ratios for 0–2 years by the appropriate interaction effect. Now
        let’s reparameterise the model to directly estimate the effects
        of age for each level of time since diagnosis. This is easily
        done in Stata (version 11 or later) using single \#’s

        `. stcox sex year8594 i.fuband i.fuband#i.agegrp`

                     0–2 years   2+ years
          --------- ----------- ----------
            Agegrp1    1.00        1.00
            Agegrp2             
            Agegrp3             
            Agegrp4             

        Fill in the table above. Does the effect of age appear different
        before and after 2 years?

    10. ADVANCED: Fit an analogous Poisson regression model. Are the
        parameter estimates similar? HINT: You will need to split the
        data by time since diagnosis.

11. <span>**Cox regression with observed (all-cause) mortality as the
    outcome**</span>\

    Now fit a model to the localised melanoma data where the outcome is
    observed survival (i.e. all deaths are considered to be events).

    `. stset surv_mm, failure(status==1,2) exit(time 120)`\
    `. keep if stage==1`\
    `. stcox sex year8594 i.agegrp`

    1.  Interpret the estimated hazard ratio for the parameter labelled
        `2.agegrp`, including a comment on statistical significance.

    2.  On comparing the estimates between the observed and
        cause-specific survival models it appears that only the
        parameters for age have changed substantially. Can you explain
        why the estimates for the effect of age would be expected to
        change more than the estimates of the effect of sex and period?

12. <span>**Cox model for cause-specific mortality for melanoma
    (all stages)**</span>\

    Use Cox regression to model the cause-specific survival of patients
    with skin melanoma (including all stages).

    1.  First fit the model with sex as the only explanatory variable.
        Does there appear to be a difference in survival between males
        and females?

    2.  Is the effect of sex confounded by other factors (e.g. age,
        stage, subsite, period)? After controlling for potential
        confounders, does there still appear to a difference in survival
        between males and females?

    3.  Consider the hypothesis that there exists a class of melanomas
        where female sex hormones play a large role in the etiology.
        These hormone related cancers are diagnosed primarily in women
        and are, on average, less aggressive (i.e., prognosis is good).
        If such a hypothesis were true we might expect the effect of sex
        to be modified by age at diagnosis (e.g., pre versus
        post menopausal). Test whether this is the case.

    4.  Decide on a ‘most appropriate’ model for these data. Be sure to
        evaluate the proportional hazards assumption.

13. <span>**Modelling the diet data using Cox regression**</span>

    1.  Fit the following Poisson regression model to the diet data (we
        fitted this same model in question \[diet:poisson\]).

            . use diet, clear
            . poisson chd hieng, e(y) irr

        Now fit the following Cox model.

            . stset dox, id(id) fail(chd) entry(doe) origin(doe) scale(365.24)
            . stcox hieng

        1.  On what scale are we measuring ‘time’? That is, what is the
            timescale?

        2.  Is it correct to say that both of these models estimate the
            effect of high energy on CHD <span>*without controlling for
            any potential confounders*</span>? If not, how are these
            models conceptually different?

        3.  Would you expect the parameter estimates for these two
            models to be very different? Is there a large difference?

    2.  `stset` the data with attained age as the timescale and refit
        the Cox model. Is the estimate of the effect of high energy
        different? Would we expect it to be different?

14. <span>**Estimating the effect of a time-varying exposure – the
    bereavement data**</span>\

    These data were used to study a possible effect of <span>*marital
    bereavement*</span> (loss of husband or wife) on all–cause mortality
    in the elderly. The dataset was extracted from a larger follow-up
    study of an elderly population and concerns subjects whose husbands
    or wives were alive at entry to the study. Thus all subjects enter
    as not bereaved but may become bereaved at some point
    during follow–up. The variable <span>dosp</span> records the date of
    death of each subject’s spouse and takes the value 1/1/2000 where
    this has not yet happened.

    1.  Load the data with

            . use brv, clear
            . desc

        To see how the coding works for couples try

            . list id sex doe dosp dox fail if couple==3

        for a couple, both of whom die during follow–up. Draw a picture
        showing the follow–up for both subjects, and mark the dates of
        entry exit and death of spouse on it. Try

            . list id sex doe dosp dox fail if couple==4

        for a couple, one of whom dies during follow–up,

            . list id sex doe dosp dox fail if couple==19

        for a couple, neither of whom die during follow–up, and

            . list id sex doe dosp dox fail if couple==7

        for a couple where only data on one individual is available.

    2.  Set the <span>st</span> variables, calculate the mortality rate
        per 1000 years for men and for women, and find the rate ratio
        comparing women (coded 2) with men (coded 1), using

            . stset dox, fail(fail) origin(dob) entry(doe) scale(365.24) id(id)
            . strate sex, per(1000)
            . streg sex, dist(exp)

        1.  What dimension of time did we use as the timescale when we
            `stset` the data? Do you think this is a sensible choice?

        2.  Which gender has the highest mortality? Is this expected?

        3.  Could age be a potential confounder? Does age at entry
            differ between males and females? Later we will estimate the
            rate ratio while controlling for age.

    3.  <span>**Breaking records into pre and post bereavement**</span>\
        In these data a subject changes exposure status from not
        bereaved to bereaved when his or her spouse dies. The first
        stage of the analysis therefore is to partition each follow–up
        into a record describing the period of follow-up pre–bereavement
        and (for subjects who were bereaved during the study) the
        period post–bereavement.

        This can be done using <span>stsplit</span>:

            . stsplit brv, after(time=dosp) at(0)
            . recode brv -1=0 0=1

        This syntax of <span>stsplit</span> splits the records at the
        death of spouse (or 1/1/2000 if the spouse is still alive). The
        variable <span>brv</span> takes the values $-1$ for the pre
        bereavement part and 0 for the post bereavment part and the
        <span>recode</span> command changes these to 0 and
        1 respectively.

        To see the effect on couple 3

            . list id sex doe dosp dox brv _t0 _t _d fail if couple==3

        We see that, of this couple, only the woman was bereaved during
        follow-up (it is impossible for both of a couple to contribute
        person-time to the bereaved category). This woman was classified
        as ‘not bereaved’ during age 83.87 and 84.41 and ‘bereaved’
        during ages 84.41 and 84.82. Study the data for the other
        couples mentioned above.

    4.  Now find the (crude) effect of bereavement

            . streg brv, dist(exp)

    5.  Since there is a strong possibility that the effect of
        bereavement is not the same for men as for women, use
        <span>streg</span> to estimate the effect of bereavement
        separately for men and women. Do this both by fitting separate
        models for males and females (e.g. `streg brv if sex==1`) as
        well as by using a single model with an interaction term (you
        may need to create dummy variables). Confirm that the estimates
        are identical for these two approaches.

    6.  <span>**Controlling for age**</span> There is strong confounding
        by age. Use <span>stsplit</span> to expand the data by 5 year
        age–bands, and check that the rate is increasing with age. Use
        <span>streg</span> to find the effect of bereavement controlled
        for age. If you wish to study the distribution of age then it is
        useful to know that age at entry and exit are stored in the
        variables `_t0` and `_t` respectively.

    7.  Now estimate the effect of bereavement (controlled for age)
        separately for each sex.

    8.  We have assumed that any effect of bereavement is both
        <span>*immediate*</span> and <span>*permanent*</span>. This is
        not realistic and we might wish to improve the analysis by
        further subdividing the post–bereavement follow–up. How might
        you do this? (you are not expected to actually do it)

    9.  <span>**Analysis using Cox regression**</span>\
        We can also model these data using Cox regression. Provided we
        have stset the data with attained age as the time scale and
        split the data (using `stsplit`) to obtain separate observations
        for the bereaved and non-bereaved person-time the following
        command will estimate the effect of bereavement adjusted for
        attained age.

            . stcox brv

        That is, we do not have to split the data by attained age
        (although we can fit the model to data split by attained age and
        the results will be the same).

    10. Use the Cox model to estimate the effect of bereavement
        separately for males and females and compare the estimates to
        those obtained using Poisson regression.

15. \[smr\] <span>**Calculating SMRs/SIRs**</span>\

    The standardized mortality ratio (SMR) is the ratio of the observed
    number of deaths in the study population to the number that would be
    expected if the study population experienced the same mortality as
    the standard population. It is an indirectly standardized rate. When
    studying disease incidence the corresponding quantity is called a
    standardized incidence ratio (SIR). These measures are typically
    used when the entire study population is considered ‘exposed’.
    Rather than following-up both the exposed study population and an
    unexposed control population and comparing the two estimated rates
    we instead only estimate the rate (or number of events) in the study
    population and compare this to the expected rate (expected number
    of events) for the standard population. For example, we might study
    disease incidence or mortality among individuals with a certain
    occupation (farmers, painters, airline cabin crew) or cancer
    incidence in a cohort exposed to ionising radiation.

    In the analysis of cancer patient survival we typically estimate
    <span>*excess mortality*</span> (observed - expected deaths). The
    SMR (observed/expected deaths) is a measure of <span>*relative
    mortality*</span>. The estimation of observed and expected numbers
    of deaths are performed in an identical manner for each measure but
    with the SMR we assume that the effect of exposure is multiplicative
    to the baseline rate whereas with excess mortality we assume it
    is additive. Which measure, relative mortality or excess mortality,
    do you think is more homogeneous across age?

    The following example illustrates the approach to estimating
    SMRs/SIRs using Stata. Specifically, we will estimate SMRs for the
    melanoma data using the general population mortality rates
    stratified by age and calendar period (derived from
    <span>popmort.dta</span>) to estimate the expected number of deaths.
    The expected mortality rates depend on current age and current year
    so the approach is as follows

    -   Split follow-up into 1-year age bands

    -   Split the resulting data into 1-year calendar period bands

    -   For each age-period band, merge with <span>popmort.dta</span> to
        obtain the expected mortality rates

    -   Sum the observed and expected numbers of deaths and calculate
        the SMR (observed/expected) and a 95% CI

    1.  Start by stsetting the data with age as the timescale and
        splitting the follow-up into 1 year age bands

            use melanoma, clear
            stset exit, fail(status == 1 2) origin(bdate) entry(dx) scale(365.24) id(id)
            stsplit _age, at(0(1)110) trim

    2.  Now split these new records into 1 year calendar period bands
        using

            stsplit _year, after(time=d(1/1/1900)) at(70(1)100) trim
            replace _year=1900+_year
            list id _age _year in 1/15

        Note that we have used the second syntax for
        <span>stsplit</span> and set the origin for calendar period as
        1/1/1900 for convenience in setting the breaks.

    3.  Each subject’s follow–up is now divided into small pieces
        corresponding to the agebands and calendar periods the subject
        passes through. We can make tables of deaths and person-years by
        age and calendar period with

            gen _y = _t - _t0 if _st==1
            table _age _year, c(sum _d)
            table _age _year, c(sum _y) format(%5.3f)

        As the data have been split in 1-year intervals on both time
        scales the table created above is not so informative. Grouped
        variables will provide a better overview.

            egen ageband_10=cut(_age), at (0(10)110)
            egen period_5=cut(_year), at(1970(5)2000)

            table ageband_10 period_5, c(sum _d)
            table ageband_10 period_5, c(sum _y) format(%4.1f)

    4.  To make a table of rates by age and calendar period, try

            gen obsrate=_d/_y
            table ageband_10 period_5 [iw=_y] , c(mean obsrate) format(%5.3f)

    5.  To calculate the expected cases for a cohort, using reference
        mortality rates classified by age and calendar period, it is
        first necessary to break the follow–up into parts which
        correspond to these age bands and calendar periods, as above.

        Before calculating the expected number of cases it is necessary
        to add the reference rates to the expanded data with

            sort _year sex _age
            merge _year sex _age using popmort

        This is a matched merge on age band and calendar period and will
        add the appropriate survival probability to each record. The
        system variable <span>\_merge</span> takes the following values:

          ---- ----------------------------------------------------------------
          1–   record in the master file but no match in <span>popmort</span>
          2–   record in <span>popmort</span> but no match in the master file
          3–   record in the master file with a match in <span>popmort</span>
          ---- ----------------------------------------------------------------

            tab _merge

        should show mostly 3’s with some 2’s but no 1’s. You can now
        drop the records with no match in the master file and the system
        variable

            drop if _merge==2
            drop _merge

    6.  The mortality rates for the standard population are derived by
        transforming the survival probabilities

            gen mortrate=(-ln(prob))

        and to calculate the expected number of cases, multiply the
        follow-up time for each record by the reference rate for that
        record

            gen e=_y*mortrate
            list id e _d in 1/15

    7.  The SMR is the ratio of the total observed cases to the total
        number expected. The total numbers are obtained through

            egen obs=total(_d)
            egen exp=total(e)

        from which the manually calculated SMR with corresponding 95%
        confidence interval are obtained (<span>preserve</span> and
        <span>restore</span> are used to speed up the processing)

            preserve
            keep in 1
            gen SMR = obs/exp
            gen LL = ( 0.5*invchi2(2*obs, 0.025)) / exp
            gen UL = ( 0.5*invchi2(2*(obs+1), 0.975)) / exp

            display "SMR(95%CI)=" round(SMR,.001) " ///
                    (" round(LL,.001) ":" round(UL,.001) ")"
            restore

        An easier approach is to let the `strate` command perform these
        calculations for us (after first splitting and merging in the
        standard rates).

            strate, smr(mortrate)

    8.  To calculate the SMR for the different stages, try

            strate stage, smr(mortrate)

    <span>**Summary**</span>\
    The following commands can be used to calculate an SMR for the
    melanoma patients:

        use melanoma, clear
        stset exit, fail(status == 1 2) origin(bdate) entry(dx) scale(365.25) id(id)
        stsplit _age, at(0(1)110) trim
        stsplit _year, after(time=d(1/1/1900)) at(70(1)100) trim
        replace _year=1900+_year
        sort _year sex _age
        merge _year sex _age using popmort
        drop if _merge==2
        gen mortrate=-ln(prob)
        strate, smr(mortrate)

16. <span>**Localised melanoma: Generating and analysing a nested
    case-control study**</span>\

    The data on patients diagnosd with localised melanoma were obtained
    from the Finnish cancer registry. We might be interested in studying
    additional prognostic factors not available in the cancer
    registry data. For example, we might wish to extract additional
    information from the medical records (e.g., treatment) or genotype
    archived tumour samples. A nested case control design will restrict
    the number of individuals for whom we need to collect
    additional information. We will first fit a model to the full cohort
    and then generate a nested case-control study and fit the
    same model.

    We will first analyse the full cohort using a Cox model. We will
    only study the first 10 years subsequent to diagnosis.

        use melanoma, clear
        keep if stage == 1
        stset surv_mm, failure(status==1) id(id) exit(time 120)

        /* Cox model to full cohort */
        stcox sex year8594 i.agegrp

    1.  How many individuals are in our study? That is, if we were
        collecting additional information, on how many individuals would
        we need to collect it?

    2.  How many experience the event (i.e., death due to cancer).

    3.  Now generate a nested case-control study with 1 control per case
        and fit a model with the same explanatory variables.

            sttocc, n(1)
            clogit _case sex year8594 i.agegrp, group(_set) or

    4.  How many unique individuals are in our study? That is, if we
        were collecting additional information, on how many individuals
        would we need to collect it?

    5.  Compare the estimated parameters and standard errors between the
        full cohort analysis and the nested case-control study. What is
        the relative efficiency (ratio of variances) of the nested
        case-control compared to the full cohort design?

    6.  If you are interested in exploring this further you can repeat
        the exercise. That is, generate another nested case-control
        study and analyse it. If you did this a large number of times,
        and plotted a histogram of the parameter estimates, you will
        find that the parameter estimates from the nested case-control
        study have a symmetric distribution with mean equal to the the
        full-cohort estimate. In the solutions you can find Stata code
        for looping.

17. <span>**Modelling cause-specific mortality using flexible parametric
    models**</span> \[locmel:csr:fpm\]\

    We will now fit some models with the linear predictor on the log
    cumulative hazard scale using flexible parametric survival models
    (Royston-Parmar models).

    Load the Melanoma data and refit the Cox model to use as
    a comparison.

        . use melanoma, clear
        . keep if stage == 1
        . stset surv_mm, failure(status==1) exit(time 120) scale(12)
        . stcox year8594,

    1.  Fit a flexible parametric survival model on the log cumulative
        hazard scale with 4 degrees of freedom for the baseline.

            . stpm2 year8594, scale(hazard) df(4) eform

        Compare the estimated hazard ratio, 95% confidence interval and
        statistical significance to the Cox model.

    2.  Obtain predicted values of the survival and hazard functions and
        plot these functions by calendar period.

            . predict s1, survival
            . predict h1, hazard per(1000)

            . twoway  (line s1 _t if year8594 == 0, sort) ///
                      (line s1 _t if year8594 == 1, sort) ///
                      , legend(order(1 "1975-1984" 2 "1985-1994") ring(0) pos(1) col(1)) ///
                      xtitle("Time since diagnosis (years)")

            . twoway  (line h1 _t if year8594 == 0, sort) ///
                      (line h1 _t if year8594 == 1, sort) ///
                      , legend(order(1 "1975-1984" 2 "1985-1994") ring(0) pos(1) col(1)) ///
                      xtitle("Time since diagnosis (years)")

    3.  Add the option `yscale(log)` to the hazard plot to display the
        hazard function on the log scale. Why is the difference between
        the two lines constant over the time scale?

    4.  Note that there are 4 `_rcs` terms because of the
        `df(4)` option. We can investigate more or less degrees of
        freedom for the baseline. It is easiest to do this in a loop.

            forvalues i = 1/6 {
              stpm2 year8594, scale(hazard) df(`i') eform
              estimates store df`i'
              predict h`i', hazard per(1000)
              predict s`i', survival
            }

        Compare the hazard ratios, AIC and BIC from the
        different models. On the following page you can find a brief
        description of the AIC and BIC.

            . estimates table df*, eq(1) keep(year8594) se stats(AIC BIC)

        According to the AIC and BIC how many degrees of freedom should
        be used for the baseline? Does it matter for the interpretation
        of the the estimated hazard ratio?

        **About AIC and BIC**

        AIC (Akaike information criterion) and BIC (Bayesian
        information criterion) are two popular measures for comparing
        the relative goodness-of-fit of statistical models. The AIC and
        BIC are defined as:\
        $AIC = -2 \ln(\mbox{likelihood}) + 2 k$\
        $BIC = -2 \ln(\mbox{likelihood}) + \ln(N) k$\
        where $k$ = number of parameters estimated and $N$ = number
        of observations.

        Given a set of candidate models for the data, the preferred
        model is the one with the minimum AIC/BIC value. Hence, the
        measures not only reward goodness of fit, but also include a
        penalty that is an increasing function of the number of
        estimated parameters. AIC uses a fixed constant, 2, in the
        penalty term whereas the penalty in BIC is a function of the
        number of observations. It is not always obvious how ‘number of
        observations’ should be defined for time-to-event data,
        particularly for grouped or split data. Volinsky and
        Raftery (2000) suggest using the number of events for $N$ in the
        BIC penalty term for survival models. The `estimates stats`
        command contains an option `n(#)` for specifying $N$. **Which
        measure – AIC or BIC – is best?**

        In many circumstances both the AIC and BIC will suggest the
        same model. For population-based survival data, the number of
        observations is large so BIC will penalize models with
        additional parameters more strongly than AIC. We suggest using
        the AIC rather than BIC.

    5.  Compare the estimated baseline survival and hazard functions for
        the models with varying degrees of freedom.

    6.  Now include sex and age (in categories) in the model.

            . stpm2 i.sex year8594 i.agegrp, df(4) scale(hazard) eform
            . estimates store ph

        Compare the estimates to those obtained in question 9(c).
        Perform a Wald test (use the `test` command) for the overall
        effect of age and compare it to that obtained for the Cox model.

    7.  Explain why the estimates from the Cox model and the flexible
        parametric model are so similar.

    8.  We will now extend the model to allow the effect of age group to
        be time-dependent using 2 degrees of freedom for each
        age category. Note that you can’t use Stata’s factor variables
        in the `tvc()` option, so create your own dummy variables.

            . tab agegrp, gen(agegrp)
            . stpm2 i.sex year8594 agegrp2-agegrp4, df(4) scale(hazard) ///
                    tvc(agegrp2 agegrp3 agegrp4) dftvc(2)
            . estimates store nonph

        Perform a likelihood ratio test comparing the proportional
        hazards model with the non-proportional hazards (for age) model.
        Is there evidence of a non-proportional effect?

            . lrtest ph nonph

    9.  Predict and plot the baseline hazard function for this model.
        For which group of patients (i.e., which covariate values) does
        the baseline hazard apply?

            . predict h0, hazard zeros ci
            . line h0 _t, sort

    10. Obtain a prediction of the hazard ratio as a function of time
        for each age group.

            . predict hr2, hrnumerator(agegrp2 1) ci
            . predict hr3, hrnumerator(agegrp3 1) ci
            . predict hr4, hrnumerator(agegrp4 1) ci

        Plot these hazard ratios versus follow-up time on the
        same graph. What happens to the hazard ratios as follow-up time
        increases? Also plot the hazard ratio for the oldest group with
        a 95% confidence interval. Explain why the hazard ratio for the
        largest age group is so high early on in the time-scale (hint:
        look at the baseline hazard)

    11. Obtain and plot with 95% confidence intervals the difference in
        the hazard rates between the oldest and youngest agegroups for
        males in 1975-1984.

            . predict hdiff4, hdiff1(agegrp4 1) ci per(1000)
            . twoway (rarea hdiff4_lci hdiff4_uci _t, sort) ///
                (line hdiff4 _t, sort) ///
                ,legend(off)  ///
                xtitle("Time since diagnosis (years)") ///
                ytitle("Difference in hazard rate")

        Explain why the hazard difference is small early on in the
        time-scale, when the hazard ratio is at is greatest.

    12. Obtain and plot with 95% confidence intervals the difference in
        the survival functions between the oldest and youngest agegroups
        for females diagnosed in 1985-1994.

            . predict sdiff4, sdiff1(agegrp4 1 sex 2 year8594 1) ///
                            sdiff2(agegrp4 0 sex 2 year8594 1) ci
            . twoway (rarea sdiff4_lci sdiff4_uci _t, sort) ///
                (line sdiff4 _t, sort) ///
                ,legend(off)  ///
                xtitle("Time since diagnosis (years)") ///
                ytitle("Difference in survival functions")

    13. Fit models with 1, 2 and 3 df for the time-dependent effect
        of age. Use the AIC and BIC to compare models. Compare the
        estimated time-dependent hazard ratio for the oldest age group
        compared to the youngest (also compare the 95%
        confidence intervals). You may want to exclude the first month
        from you plot.

18. <span>**Probability of death in a competing risks framework
    (cause-specific survival)**</span> \[locmel:rsr:fpm\]\

    This question gives an introduction to some of the methods available
    for competing risks analyses. We will be estimating similar
    quantities to q34 and q38 but we are now working in a cause-specific
    survival framework. To carry out the exercises you will need to
    install some user-written commands from within Stata. The `stcompet`
    command estimates the cumulative incidence function (CIF)
    non-parametrically. The `stcompadj` command estimates the CIF using
    a competing risks analogue of the Cox model. Finally, the `stpm2cif`
    command estimates the CIF through postestimation after fitting a
    flexible parametric model.

    1.  Load the melanoma data. If you summarize status you will notice
        that there are deaths from both cancer and other causes. Plot
        the complement of the Kaplan-Meier estimate (i.e. 1 minus
        Kaplan-Meier survival estimate) for both cancer and
        other causes. Describe what you see.

        A common confusion when competing risks are present is to think
        that the probability of death from cancer can be obtained by
        taking the complement of the Kaplan-Meier estimate (1-KM). By
        doing this we treat deaths from other causes as censored. This
        then assumes that the patients dying from other causes would
        have been at no systematically higher or lower risk of dying
        from cancer (independent censoring). Patients that die due to
        competing causes can no longer die from cancer which essentially
        violates this independence assumption. Therefore, the resulting
        estimates would not be interpretable as the probability of death
        from cancer.

        The appropriate estimate for the “real world” probability of
        death from cancer when competing risks are present is the
        cumulative incidence function. That is the proportion of
        patients that have died from cancer at a certain time in the
        follow-up period taking into account competing causes of death.

    2.  Use the `stcompet` command to estimate the cumulative incidence
        function for both cancer and other causes. Plot the cumulative
        incidence functions along with the complements of the
        Kaplan-Meier estimates from part (a). What do you notice?

            . stset surv_mm, failure(status==1) scale(12)
            . stcompet CIF=ci, compet1(2)
            . gen CIFcancer=CIF if status==1
            . gen CIFother=CIF if status==2

    3.  We now want to consider a competing risks analysis that will
        take into account covariate effects. Use the `stcompadj` command
        to estimate the cumulative incidence function for cancer and
        other causes taking into account the effect of sex. First we
        need to generate a binary variable for females. We shall assume
        that the effect of females is the same for both cancer and
        other causes. You will need to run the command twice in order to
        evaluate the cumulative incidence functions for each sex. Plot
        the cumulative incidence functions for cancer and other causes
        for both males and females. Are there any differences between
        males and females?

            . gen female=sex==2
            . stset surv_mm, failure(status==1) scale(12)
            . stcompadj female=0, compet(2) gen(CIFcancermale CIFothermale)
            . stcompadj female=1, compet(2) gen(CIFcancerfemale CIFotherfemale)

    4.  We will now consider the same model but using the flexible
        parametric approach. In order to do this we will first need to
        expand the data set so that each patient has two rows of data -
        one for each cause of death.

        1.  Expand the data and have a look at the new data set.

                . expand 2
                . bysort id: gen cause=_n
                . gen cancer=(cause==1)
                . gen other=(cause==2)

        2.  Fit a flexible parametric model for cancer and other
            causes simultaneously. Include sex as a covariate assuming
            that the effect of sex is the same for both cancer and
            other causes. Interpret the effect of sex.

                . stset surv_mm, failure(event) scale(12)
                . stpm2 cancer other female, scale(hazard) ///
                  rcsbaseoff dftvc(3) nocons tvc(cancer other) eform nolog

            By including the two cause indicators (`cancer` and `other`)
            as both main effects and time-dependent effects (using
            `tvc` option) we have fitted a stratified model with two
            separate baselines, one for each cause. For this reason we
            have used the `rcsbaseoff` option together with the `nocons`
            option which excludes the baseline hazard from the model.

        3.  Use the `stpm2cif` postestimation command to obtain the
            cumulative incidence functions for cancer and other causes
            for each sex. You will need to run this command twice - once
            for each sex. Notice that a new time variable is generated
            called `_newt`. You will need to use this instead of `_t` in
            your plots. Do the results look the same as the ones from
            the Cox model approach?

                . stpm2cif cancermale othermale, cause1(cancer 1) ///
                  cause2(other 1)
                . stpm2cif cancerfemale otherfemale, cause1(cancer 1 female 1) ///
                  cause2(other 1 female 1)

        4.  Think about an alternative way to present the results. Try
            stacking the cumulative incidence functions for cancer and
            other causes.

    5.  So far the model only included one covariate (male/female). We
        now want to adjust the model for age. However, we don’t believe
        that the effect of age is the same for both cancer and other
        causes of death.

        1.  To allow the effect of age to vary for the two causes create
            interaction terms between age group and the causes of death.

                . gen age0ca=(agegrp==0 & cancer==1)
                . gen age1ca=(agegrp==1 & cancer==1)
                . gen age2ca=(agegrp==2 & cancer==1)
                . gen age3ca=(agegrp==3 & cancer==1)
                . gen age0oth=(agegrp==0 & other==1)
                . gen age1oth=(agegrp==1 & other==1)
                . gen age2oth=(agegrp==2 & other==1)
                . gen age3oth=(agegrp==3 & other==1)

        2.  Fit a flexible parametric model including sex and the
            interaction terms between age group and cause.

                . stpm2 cancer other female age1ca age2ca age3ca ///
                        age1oth age2oth age3oth , scale(hazard) ///
                        rcsbaseoff dftvc(3) nocons tvc(cancer other) eform nolog

        3.  Now incorporate sex as a time-dependent effect in the model.

                . stpm2 cancer other female age1ca age2ca age3ca ///
                        age1oth age2oth age3oth , scale(hazard) ///
                        rcsbaseoff dftvc(3) nocons tvc(cancer other female) eform nolog

        4.  Estimate the cumulative incidence functions for each sex and
            for the age groups 0-44 and 75+. Plot the cumulative
            incidence functions against time.

                . stpm2cif cancermaleage0 othermaleage0, ///
                  cause1(cancer 1) cause2(other 1)

                . stpm2cif cancermaleage3 othersex1age3, ///
                  cause1(cancer 1 age3ca 1) cause2(other 1 age3oth 1)

                . stpm2cif cancerfemaleage0 othefemaleage0, ///
                  cause1(cancer 1 female 1) cause2(other 1 female 1)

                . stpm2cif cancerfemaleage3 otherfemaleage3, ///
                  cause1(cancer 1 age3ca 1 female 1) cause2(other 1 age3oth 1 female 1)

---
title: "Biostatistics III in R"
author:
- Code by Annika Tillander, Andreas Karlsson and Mark Clements
output:
  prettydoc::html_pretty:
    mathjax: https://biostat3.net/js/mathjax/tex-chtml.js
    theme: cayman
    highlight: github
---

# Exercise 3. Localised melanoma: Comparing estimates of cause-specific survival between periods; first graphically and then using the log rank test #


```{r setup, cache=FALSE, message=FALSE, echo=FALSE}
library('knitr')
read_chunk('../q3.R')
opts_chunk$set(cache=FALSE, fig.width=10, fig.height=6)
```

You may have to install the required packages the first time you use them. You can install a package by `install.packages("package_of_interest")` for each package you require.

```{r loadDependencies, message=FALSE}
```

We will now analyse the full data set of patients diagnosed with localised skin melanoma. We start by reading the data selecting those with a localised stage and then define a 1/0 varible for the events that we are interested in.

```{r loadPreprocess}
```

## (a) ##

```{r a_survDiaDate}
```

There seems to be a clear difference in survival between the
        two periods. Patients diagnosed during 1985–94 have superior
        survival to those diagnosed 1975–84.

## (b) ##

The plot shows the instantaneous cancer-specific mortality rate
        (the hazard) as a function of time. It appears that mortality is
        highest approximately 3.5 years following diagnosis. Remember
        that all patients were classified as having localised cancer at
        the time of diagnosis so we would not expect mortality to be
        high directly following diagnosis.

The plot of the hazard clearly illustrates the pattern of
        cancer-specific mortality as a function of time whereas this
        pattern is not obvious in the plot of the survivor function.

```{r b_hazDiaDate}
```


## (c) ##

There is strong evidence that survival differs between the
        two periods. The log-rank and the Wilcoxon tests give very
        similar results. The Wilcoxon test gives more weight to
        differences in survival in the early period of follow-up (where
        there are more individuals at risk) whereas the log rank test
        gives equal weight to all points in the follow-up. Both tests
        assume that, if there is a difference, a proportional hazards
        assumption is appropriate.

```{r c_testDiaDate}
```


## (d) ##
We see that mortality increases with age at diagnosis (and
        survival decreases).
		
```{r d_crudeRates1000_agegrp}
```

The rates are (cause-specific) deaths per 1000 person-years.
        When we use `Surv` we defined time as time in months divided by 12 and then asked
        for rates per 1000 units of time.

```{r d_plotSurv_sex}
```

What are the units of the estimated hazard rates? HINT: look at how you defined time.

## (e) ##

```{r e_crudeRates1000_agegrp}
```

## (f) ##

```{r f_sexDiff}
```

---
title: "Biostatistics III in R"
author:
- Code by Annika Tillander, Andreas Karlsson, Benedicte Delcoigne, Johan Zetterqvist and Mark Clements
format:
  html:
    minimal: true
filters:
  - webr
execute:
  echo: true
  message: false
  cache: false
  fig-width: 7
  fig-height: 6
---


# Exercise 8. Diet data: Using Poisson regression to study the effect of energy intake adjusting for confounders on two different timescales #

Use Poisson regression to study the association between energy intake (`hieng`) and CHD adjusted for potential confounders (`job`, `BMI`). We know that people who expend a lot of energy (i.e., are physically active) require a higher energy intake. We do not have data on physical activity but we are hoping that occupation (`job`) will serve as a surrogate measure of work-time physical activity (conductors on London double-decker busses expend energy walking up and down the stairs all day).

Fit models both without adjusting for ‘time’ and by adjusting for attained age (you will need to split the data) and time-since-entry and compare the results.

-----------


You may have to install the required packages the first time you use them. You can install a package by `install.packages("package_of_interest")` for each package you require.

```{webr-r}
#| autorun: true
library(biostat3)  # diet, eform
library(bshazard)  # bshazard
library(knitr)     # kable
library(broom)     # tidy
diet <- transform(biostat3::diet, bmi = weight/((height/100)^2))
```

Load diet data and explore it.

```{webr-r}
#| results: "asis"
head(diet) |> kable("html")
```

```{webr-r}
summary(diet)
```

Rates can be modelled on different timescales, e.g., attained age, time-since-entry, calendar time. Plot the CHD incidence rates both by attained age and by time-since-entry. Is there a difference? Do the same for CHD hazard by different energy intakes (`hieng`).

## (a1) ##  
Plot the CHD incidence rates by attained age. Do the same for CHD hazard by different energy intakes (`hieng`). 


```{webr-r}
scale <- 365.24
plot(bshazard(Surv((doe - dob)/scale, (dox - dob)/scale, chd) ~ 1,
              data=subset(diet,hieng=="low")),
     ylim=c(0,0.03), conf.int=FALSE, xlab="Attained age (years)")
lines(bshazard(Surv((doe - dob)/scale, (dox - dob)/scale, chd) ~ 1,
               data=subset(diet,hieng=="high")),
      col="red", conf.int=FALSE)
legend("topleft", legend=c('hieng=="low"','hieng=="high"'), col=1:2, lty=1, bty="n")

par(mfrow=1:2)
for (level in levels(diet$hieng))
    plot(bshazard(Surv((doe - dob)/scale, (dox - dob)/scale, chd) ~ 1,
                  data=subset(diet,hieng==level)),
         ylim=c(0,0.03), xlab="Attained age (years)",
         main=sprintf('hieng == "%s"', level))
```

## (a2) ##  
Plot the CHD incidence rates by time-since-entry. Do the same for CHD hazard by different energy intakes (`hieng`).

```{webr-r}
if (requireNamespace("muhaz")) {
    scale <- 365.24
    plot(muhaz2(Surv((dox - doe)/scale, chd) ~ hieng, data=diet), lty=2,
         xlab="Time since study entry (years)", ylim=c(0,0.025),
         legend=FALSE)
    lines(bshazard(Surv((dox - doe)/scale, chd) ~ 1, data=subset(diet,hieng=="low")),
          conf.int=FALSE)
    lines(bshazard(Surv((dox - doe)/scale, chd) ~ 1, data=subset(diet,hieng=="high")),
          col="red", conf.int=FALSE)
    legend("topleft", legend=c('hieng=="low" (bshazard)','hieng=="high" (bshazard)',
                               'hieng=="low" (muhaz)','hieng=="high" (muhaz)'),
           col=1:2, lty=c(1,1,2,2), bty="n")
}

scale <- 365.24
par(mfrow=1:2)
for (level in levels(diet$hieng))
    plot(bshazard(Surv((dox - doe)/scale, chd) ~ 1,
                  data=subset(diet,hieng==level)),
         ylim=c(0,0.03), xlab="Time since study entry (years)",
         main=sprintf('hieng == "%s"', level))

```

## (b) ##  
Fit a poisson model to find the incidence rate ratio for the high energy group compared to the low energy group without adjusting for any time scale.

```{webr-r}
poisson8b <- glm( chd ~ hieng + offset( log( y/1000 ) ), family=poisson, data=diet)
summary(poisson8b)
tidy(poisson8b, conf.int=TRUE, exponentiate=TRUE) # tidyverse
eform(poisson8b) # Wald-based CIs
```

## (c) ##  
Adjust for BMI and job. Is the effect of energy intake on CHD confounded by BMI and job?

```{webr-r}
levels(diet$job)
poisson8c <- glm( chd ~ hieng + job + bmi + offset( log( y/1000 ) ),
                 family=poisson, data=diet)
summary(poisson8c)
eform(poisson8c)
```

## (d) ##  
Now fit the model for CHD, both without and with the adjustment for job and bmi. Is the effect of hieng on CHD confounded by age, BMI or job? Write the linear predictors using pen and paper.

Firstly, let’s adjust for the timescale attained age. To do this in Poisson regression you must split the data on timescale age. The risktime variable contains the correct amount of risktime for each timeband.


```{webr-r}
#| autorun: true
scale <- 365.24
age.cuts <- c(30,50,60,72)
diet.spl.dob <- survSplit(Surv((doe - dob)/scale, (dox - dob)/scale, chd) ~ .,
                          data=diet, cut=age.cuts,start="tstart",end="tstop")

## Tabulate ageband
diet.spl.dob |> subset(id<3, c(id, tstart, tstop, y))

## Create an agespan variable
diet.spl.dob <- transform(diet.spl.dob,
                          agespan = cut(tstop, age.cuts))

## Make the numeric variables factors since we want to model them with dummie variables and calculate time at risk
diet.spl.dob <- transform(diet.spl.dob,
                          risk_time = (tstop-tstart))

## Tabulate ageband including risk_time
diet.spl.dob |> subset(id<3, c(id, tstart, tstop, y, risk_time))

## Tabulate number of events per agespan
xtabs(~agespan+chd,diet.spl.dob)
```

Fitting the model for CHD, without adjustment for job and bmi.


```{webr-r}
poisson8d <- glm( chd ~ hieng + agespan + offset( log( risk_time) ),
                 family=poisson,
                 data=diet.spl.dob)

summary(poisson8d)
eform(poisson8d)
```

Fitting the model for CHD, with adjustment for job and bmi.

```{webr-r}
poisson8d <- glm( chd ~ hieng + agespan + job + bmi + offset( log( risk_time) ),
                 family=poisson,
                 data=diet.spl.dob)

summary(poisson8d)
eform(poisson8d)
```

The effect of high energy intake is somewhat confounded by age, but also confounded by job and bmi. What assumption is being made about the shape of the baseline hazard (HINT: the baseline hazard takes the shape of the timescale)?


## (e) ##
Secondly, do the same analysis, but now adjust for the timescale time-since-entry.

```{webr-r}
time.cuts <- c(0, 5, 10, 15, 22)
diet.spl.t_entry <- survSplit(Surv((dox-doe)/365.24, chd) ~ .,
                              data=diet, cut=time.cuts, end="tstop", start="tstart",
                              event="chd")

##Tabulate ageband
diet.spl.t_entry |> subset(id<=3, c(id, tstart, tstop, y))

diet.spl.t_entry <- transform(diet.spl.t_entry,
                              fu = cut(tstop, time.cuts),
                              risk_time = (tstop-tstart))

##Tabulate ageband including risk_time
diet.spl.t_entry |> subset(id<=3, c(id, fu, tstart, y, risk_time))

poisson8e1 <- glm( chd ~ fu + hieng + offset( log( risk_time) ),
                 family=poisson,
                 data=diet.spl.t_entry )

summary(poisson8e1)
eform(poisson8e1)

```
Compare the results with the analysis adjusted for attained age. Are there any differences? Why (or why not)? Go back to the graphs at the beginning of the exercise and look for explanations.

---
title: "Biostatistics III in R"
author:
- Code by Annika Tillander, Johan Zetterqvist and Mark Clements
output:
  prettydoc::html_pretty:
    mathjax: https://biostat3.net/js/mathjax/tex-chtml.js
    theme: cayman
    highlight: github
---

# Exercise 9. Localised melanoma: modelling cause-specific mortality using Cox regression #

In exercise 7 we modelled the cause-specific mortality of patients diagnosed with localised melanoma using Poisson regression. We will now model cause-specific mortality using Cox regression and compare the results to those we obtained using the Poisson regression model.

To fit a Cox proportional hazards model (for cause-specific survival) with calendar period as the only explanatory variable, the following commands can be used. Note that we are censoring all survival times at 120 months (10 years) in order to facilitate comparisons with the Poisson regression model in exercise 7.

-----------


```{r setup, cache=FALSE, message=FALSE, echo=FALSE}
library('knitr')
read_chunk('../q9.R')
opts_chunk$set(cache=FALSE)
```

You may have to install the required packages the first time you use them. You can install a package by `install.packages("package_of_interest")` for each package you require.

```{r loadDependencies, message=FALSE}
```

```{r loadPreprocess, results='hide'}
```

## (a) ##

```{r 9.a}
```

Patients diagnosed during 1985–94 experience only 77.7% of the
cancer mortality experienced by those diagnosed 1975–84. That
is, mortality due to skin melanoma has decreased by 22.3% in the
latter period compared to the earlier period. This estimate is
not adjusted for potential confounders. There is strong evidence
of a statistically significant difference in survival between
the two periods (based on the test statistic or the fact that
the CI for the hazard ratio does not contain 1).

The regression equation is 

\begin{align*}
h(t|\text{year8594}) &= h_0(t) \exp(\beta_1 I(\text{year8594}="\text{Diagnosed 85-94}"))
\end{align*}
where $h(t|\text{year8594})$ is the hazard at time $t$ given covariate $\text{year8594}$, with baseline hazard $h_0(t)$ and regression coefficient $\beta_1$ for the log hazard ratio for the calendar period 1985--1994 compared with the reference calendar period 1974--1984.


## (b) ##

```{r 9.b}
```

The three test statistics are

        log-rank

        :   14.85 

        Wald

        :   $-3.84^2=14.75$ (from the $z$ test above)

        Likelihood ratio

        :   14.78 (from the output above)

The three test statistics are very similar. We would expect each of
these test statistics to be similar since they each test the same null
hypothesis that survival is independent of calendar period. The null
hypothesis in each case is that survival is not associated with
calendar period.


## (c) ##

```{r  9.c}
```

The regression equation is 

\begin{align*}
h(t|\text{year8594},\text{sex},\text{agegrp}) &= h_0(t) \exp(\beta_1 I(\text{year8594}="\text{Diagnosed 85-94}")+\beta_2 I(\text{sex}="\text{Female}")+\beta_3 I(\text{agegrp}="\text{45-59}")+\beta_4 I(\text{agegrp}="\text{60-74}")+\beta_5 I(\text{agegrp}="\text{75+}"))
\end{align*}
where $h(t|\text{year8594},\text{sex},\text{agegrp})$ is the hazard at time $t$ given covariates $\text{year8594}$, $\text{sex}$ and $\text{agegrp}$, with baseline hazard $h_0(t)$ and regression coefficients representing log hazard ratios for $\beta_1$ for the calendar period 1985--1994, $\beta_2$ for females, $\beta_3$ for those aged 45--59 years at diagnosis, $\beta_4$ for those aged 60--74 years and $\beta_5$ for those aged 75 years and over.


  i. For patients of the same sex diagnosed in the same calendar
            period, those aged 60–74 at diagnosis have an estimated 86%
            higher risk of death due to skin melanoma than those aged
            0–44 at diagnosis. The difference is
            statistically significant.
			
	 If this were an exam question the previous paragraph would
            be awarded full marks. It is worth noting, however, that the
            analysis is adjusted for the fact that mortality may depend
            on time since diagnosis (since this is the underlying
            time scale) and the mortality ratio between the two age
            groups is assumed to be the same at each point during the
            follow-up (i.e., proportional hazard).

  ii. The parameter estimate for period changes from 0.78 to 0.72 when
            age and sex are added to the model. Whether this is
            ‘strong confounding’, or even ‘confounding’, is a matter
            of judgement. I would consider this confounding but not
            strong confounding but there is no correct answer to this
            question.
 
  iii. Age (modelled as a categorical variable with 4 levels) is
            highly significant in the model.


## (d) ##

```{r 9.d, warning=FALSE}
```

Age (modelled as a categorical variable with 4 levels) is highly
significant in the model. The Wald test is an approximation to
the LR test and we would expect the two to be similar (which
they are).

## (e) ##

```{r 9.e}
```

  i. Both models adjust for the same factors. When fitting the
            Poisson regression model we split time since diagnosis into
            annual intervals and explicitly estimated the effect of this
            factor in the model. The Cox model does not estimate the
            effect of ‘time’ but the other estimates are adjusted for
            ‘time’.
			
  ii. Since the two models are conceptually similar we would
            expect the parameter estimates to be similar, which
            they are.
			
  iii. Yes, both models assume ‘proportional hazards’. The
            proportional hazards assumption implies that the rate
            ratios for sex, period, and age are constant across all
            levels of follow-up time. In other words, the assumption
            is that there is no effect modification by follow-up
            time. This assumption is implicit in Poisson regression
            (as it is in logistic regression) where it is assumed that
            estimated rate ratios are constant across all combination
            of the other covariates. We can, of course, relax this
            assumption by fitting interaction terms.

## (f) ##

```{r 9.f}
```

## (g) ##

This R code demonstates how to predict rates and survival for those diagnosed 1985--94 who are male aged 45--59 years:

```{r 9.g}
```

---
title: "Biostatistics III in R"
author:
- Code by Andreas Karlsson and Mark Clements
format:
  html:
    minimal: true
filters:
  - webr
execute:
  echo: true
  message: false
  cache: false
  fig-width: 7
  fig-height: 6
---


# Cox model for cause-specific mortality for melanoma (all stages) #


Use Cox regression to model the cause-specific survival of patients with skin melanoma (including all stages).

-----------


You may have to install the required packages the first time you use them. You can install a package by `install.packages("package_of_interest")` for each package you require.

Load the melanoma data and explore it.

```{webr-r}
#| autorun: true
library(biostat3)
melanoma.l <- transform(biostat3::melanoma,
                        death_cancer = ifelse( status == "Dead: cancer", 1, 0))
```

## (a) ## 
First fit the model with sex as the only explanatory variable. Does there appear to be a difference in survival between males and females?


```{webr-r}
coxph(Surv(surv_mm, death_cancer) ~ sex, data=melanoma.l) |> summary()
```

## (b) ## 
Is the effect of sex confounded by other factors (e.g. age, stage, subsite, period)? After controlling for potential confounders, does there still appear to a difference in survival between males and females?

```{webr-r}
coxph(Surv(surv_mm, death_cancer) ~ sex + agegrp + stage + subsite + year8594,
      data=melanoma.l) |> summary()
```

## (c) ## 
Consider the hypothesis that there exists a class of melanomas where female sex hormones play a large role in the etiology. These hormone related cancers are diagnosed primarily in women and are, on average, less aggressive (i.e., prognosis is good). If such a hypothesis were true we might expect the effect of sex to be modified by age at diagnosis (e.g., pre versus post menopausal). Test whether this is the case.

```{webr-r}
coxph(Surv(surv_mm, death_cancer) ~ agegrp + agegrp * sex, data=melanoma.l) |>
    summary()
```

## (d) ## 
Decide on a ‘most appropriate’ model for these data. Be sure to evaluate the proportional hazards assumption.


```{webr-r}
cox4 <- coxph(Surv(surv_mm, death_cancer) ~ sex + year8594 + agegrp + subsite + stage,
              data=melanoma.l)
summary(cox4)

## Test proportional hazards assumption
cox.zph(cox4, transform="log") 
cox.zph(cox4, transform="identity") # Stata default
```

```{webr-r}
cox5 <- coxph(Surv(surv_mm, death_cancer) ~ sex + year8594 + agegrp + subsite +
                  strata(stage), data=melanoma.l)
summary(cox5)

## Test proportional hazards assumption
cox.zph(cox5, transform="log") 
cox.zph(cox5, transform="identity") 
```

```{webr-r}
cox6 <- coxph(Surv(surv_mm, death_cancer) ~ sex * agegrp + year8594 + agegrp + subsite +
                  strata(stage), data=melanoma.l)
summary(cox6)
anova(cox6)
```

---
title: "Biostatistics III in R"
author:
- Code by Andreas Karlsson and Mark Clements
output:
  prettydoc::html_pretty:
    mathjax: https://biostat3.net/js/mathjax/tex-chtml.js
    theme: cayman
    highlight: github
---

# Cox model for cause-specific mortality for melanoma (all stages) #


Use Cox regression to model the cause-specific survival of patients with skin melanoma (including all stages).

-----------


```{r setup, cache=FALSE, message=FALSE, echo=FALSE}
library('knitr')
read_chunk('../q12.R')
opts_chunk$set(cache=FALSE)
```

You may have to install the required packages the first time you use them. You can install a package by `install.packages("package_of_interest")` for each package you require.

```{r loadDependencies, message=FALSE}
```
Load the melanoma data and explore it.

```{r loadPreprocess, results='hide'}
```

## (a) ## 
Without adjusting for potential confounders, we see that
        females have a 37% lower mortality rate than males.

```{r 12.a, warning=FALSE, message=FALSE}
```

## (b) ## 
After adjusting for a range of potential confounders, we see that
        the estimated difference in cancer-specific mortality between
        males and females has decreased slightly but there is still
        quite a large difference.
		
```{r 12.b, warning=FALSE, message=FALSE}
```

## (c) ##

Let’s first estimate the effect of gender for each age group
        without adjusting for confounders.
		
```{r 12.c, warning=FALSE, message=FALSE}
```

We see that there is some evidence that the survival advantage
        experienced by females depends on age. The hazard ratio for
        males/females in the youngest age group is 0.46, while in the
        highest age group the hazard ratio is 0.68. There is evidence
        that the hazard ratios for gender differ across the age
        groups (p=0.0035). However, after adjusting for stage, subsite,
        and period there is no longer evidence of an interaction.
		
There is not strong evidence in support of the
        hypothesis (although some may consider that there is
        weak evidence).
		
## (d) ##
		
After having fitted a main effects model we can check the
        proportional hazards assumption by fitting a regression line
        through the model-based Schoenfeld residulas and check if the
        slope is statistically different from zero.

There is strong evidence that the proportional hazard assumption
		is not satisfied for the effect of stage. Unless our primary
        interest is in the stage effect we can fit a stratified Cox
        model where we stratify on stage (i.e. estimate a separate
        baseline hazard function for each stage group).		

```{r 12.d.i, warning=FALSE, message=FALSE}
```

If we re-do a test for non-proportional hazards we find that
        there is no longer evidence that any of the remaining covariates
        effects seem to depend on time since diagnosis.

Having accounted for the time-dependent effect of stage, there
        is still no evidence that the effect of sex is modified by age
        at diagnosis.

```{r 12.d.ii, warning=FALSE, message=FALSE}
```

If you have time make sure you check for additional interaction
        terms between the remaining covariates, i.e. between age at
        diagnosis and stage.

```{r 12.d.iii, warning=FALSE, message=FALSE}
```

---
title: "WebR-enabled code cell"
format: html
engine: knitr
#webr:
#  show-startup-message: false    # Disable display of webR initialization state
#  show-header-message: true      # Display whether COOP&COEP headers are set for speed.
#  packages: ['ggplot2', 'dplyr'] # Pre-install dependencies
#  autoload-packages: false       # Disable automatic library calls on R packages specified in packages.
#  repos:                         # Specify repositories to check for custom packages
#    - https://github-username.github.io/reponame
#    - https://username.r-universe.dev
#  channel-type: 'post-message'   # Specify a specific communication channel type.
#  home-dir: "/home/rstudio"      # Customize where the working directory is
#  base-url: ''                   # Base URL used for downloading R WebAssembly binaries
#  service-worker-url: ''         # URL from where to load JavaScript worker scripts when loading webR with the ServiceWorker communication channel.
filters:
- webr
---

## Demo

This is a webr-enabled code cell in a Quarto HTML document.

```{webr-r}
1 + 1 
```

```{webr-r}
fit = lm(mpg ~ am, data = mtcars)
summary(fit)
```

```{webr-r}
plot(pressure)
```

---
title: "Biostatistics III in R"
author:
- Code by Johan Zetterqvist and Mark Clements
output:
  prettydoc::html_pretty:
    mathjax: https://biostat3.net/js/mathjax/tex-chtml.js
    theme: cayman
    highlight: github
---

# Exercise 11. Cox regression with all-cause mortality as the outcome #


Now fit a model to the localised melanoma data where the outcome is observed survival (i.e. all deaths are considered to be events).

```{r setup, cache=FALSE, message=FALSE, echo=FALSE}
library('knitr')
read_chunk('../q11.R')
opts_chunk$set(cache=FALSE)
```

You may have to install the required packages the first time you use them. You can install a package by `install.packages("package_of_interest")` for each package you require.

```{r loadDependencies, message=FALSE}
```
Load the melanoma data and explore it.

```{r loadPreprocess, results='hide'}
```

## (a) ## 

For patients of the same sex diagnosed in the same period, those
aged 60–74 at diagnosis have a 2.94 times higher risk of death
*due to any causes* than those aged 0-–44
at diagnosis. The 95% confidence interval is (2.52, 3.44). This difference is statistically significant.

The regression equation is 
\begin{align*}
h(t|\text{year8594},\text{sex},\text{agegrp}) &= h_0(t) \exp(\beta_1 I(\text{sex}=\text{"Female"})+\beta_2 I(\text{year8594}=\text{"Diagnosed 85-94"})+\\
&\qquad\beta_3 I(\text{agegrp}=\text{"45-59"})+\beta_4 I(\text{agegrp}=\text{"60-64"}) + \beta_5 I(\text{agegrp}=\text{"75+"}) 
\end{align*}
where $h(t|\text{year8594},\text{sex},\text{agegrp},\text{agegrp})$ is the hazard at time $t$ given covariates $\text{year8594}$, $\text{sex}$ and $\text{agegrp}$ and $\text{agegrp}$, with baseline hazard $h_0(t)$ and regression coefficients representing log hazard ratios for $\beta_1$ for the calendar period 1985--1994, $\beta_2$ for females, with log hazard ratios at time 0 for those aged 45--59 years, 60--74 years and 75 years and over are $\beta_3$, $\beta_4$ and $\beta_5$, respectively.

From the regression equation, a formula for the hazard ratio comparing a male aged 60--74 years with a female aged 75 years and over is
\begin{align*}
\frac{h(t|\text{year8594},\text{sex}=\text{"Male"},\text{agegrp}=\text{"60-74"})}{h(t|\text{year8594},\text{sex}=\text{"Female"},\text{agegrp}=\text{"75+"})} &= 
\frac{h_0(t) \exp(\beta_2 I(\text{year8594}=\text{"Diagnosed 85-94"})+ \beta_4)}{h_0(t)\exp(\beta_1}+\beta_2 I(\text{year8594}=\text{"Diagnosed 85-94"}+\beta_5))} \\
&= \exp(\beta_4 - \beta_1 - \beta_5)
\end{align*}

```{r 11.a, warning=FALSE}
```

## (b) ## 

Note that the previous model estimated cause-specific hazard
ratios whereas the current model estimates all-cause
hazard ratios. The estimated hazard ratios for sex and period
are similar, whereas the estimated hazard ratios for age are
markedly different. This is because non-cancer mortality is
heavily dependent on age, but only lightly dependent on sex and
calendar period.
		
```{r 11.b, warning=FALSE}
```

---
title: "Biostatistics III in R"
author:
- Code by Mark Clements
output:
  prettydoc::html_pretty:
    theme: cayman
    highlight: github
---


# Exercise 14. Non-collapsibility of proportional hazards models #

-----------

We simulate for time-to-event data assuming _constant hazards_ and then investigate whether we can estimate the underlying parameters. Note that the binary variable $X$ is essentially a coin toss and we have used a large variance for the normally distributed $U$. 

```{r setup, cache=FALSE, message=FALSE, echo=FALSE}
library('knitr')
read_chunk('../q14.R')
opts_chunk$set(cache=FALSE)
```

You may have to install the required packages the first time you use them. You can install a package by `install.packages("package_of_interest")` for each package you require.

```{r loadDependencies, message=FALSE}
```

<!-- We can use `dagitty` to graph the causal diagram:  -->
<!-- ```{r 14.dag} -->
<!-- ``` -->

The assumed causal diagram is reproduced below: 

```{r,engine='tikz',fig.ext='svg',fig.width=3,echo=FALSE}
    \usetikzlibrary{arrows,decorations.pathmorphing,backgrounds,positioning,fit,petri,matrix}
    \begin{tikzpicture}[->,bend angle=20,semithick,>=stealth']
      \matrix [matrix of nodes,row sep=10mm, column sep=15mm]
      {
        |(X)| $X$ & |(C)| $C$ \\
        & |(T)| $T$ & |(Y)| $(Y,\Delta)$ \\
        |(U)| $U$ \\
      };
      \begin{scope}[every node/.style={auto}]
        \draw (X) to node[anchor=south] {1} (T);
        \draw (U) to node[anchor=south] {1} (T);
        \draw (T) to node[anchor=north] {} (Y);
        \draw (C) to node[anchor=north] {} (Y);
      \end{scope}
    \end{tikzpicture}
```


```{r 14.simulate, results='hide'}
```

## (a) Fitting models with both $X$ and $U$ ## 

For constant hazards, we can fit (i) Poisson regression, (ii) Cox regression and (iii) flexible parametric survival models. 

```{r 14.a, results='hide'}
```

It may be useful to investigate whether the hazard ratio for $X$ is time-varying hazard ratio and the form for survival.

```{r 14.tvc.xu, results='hide'}
```

## (b) Fitting models with only $X$ ## 

We now model by excluding the variable $U$. This variable could be excluded when it is not measured or perhaps when the variable is not considered to be a confounding variable -- from the causal diagram, the two variables $X$ and $U$ are not correlated and are only connected through the time variable $T$.

```{r 14.b, results='hide'}
```

```{r 14.b.2, results='hide'}
```

Again, we suggest investigating whether the hazard ratio for $X$ is time-varying.

```{r 14.tvc.x}
```

What do you see from the time-varing hazard ratio? Is $U$ a potential confounder for $X$?



## (c) Rarer outcomes ## 

We now simulate for rarer outcomes by changing the censoring distribution:

```{r 14.simulate.2}
```

```{r 14.b, results='hide'}
```

```{r 14.b.2}
```

What do you observe?


## (d) Less heterogeneity ## 

We now simulate for less heterogeneity by changing the reducing the standard deviation for the random effect $U$ from 3 to 1. 

```{r 14.simulate.3}
```

```{r 14.b, results='hide'}
```

```{r 14.b.2}
```

What do you observe?


## (e) Accelerated failure time models ##

As an alternative model class, we can fit _accelerated failure time models_ with a smooth baseline survival function. We can use the *rstpm2::aft* function, which uses splines to model baseline survival. Using the baseline simulation, fit and interpret smooth accelerated failure time models:

```{r 14.aft}
```

---
title: "Biostatistics III in R"
author:
- Code by Mark Clements
output:
  prettydoc::html_pretty:
    theme: cayman
    highlight: github
---

# Exercise 23. Calculating SMRs/SIRs #

-----------

```{r setup, cache=FALSE, message=FALSE, echo=FALSE}
library('knitr')
read_chunk('../q23.R')
opts_chunk$set(cache=FALSE)
```

You may have to install the required packages the first time you use them. You can install a package by `install.packages("package_of_interest")` for each package you require.

```{r loadDependencies, message=FALSE}
```
Load the melanoma data. Restrict the data to the localised status of the melanoma and to the 10 firts years of follow-up. Use the time-on-study as the timescale. define the event as death from cancer.

```{r loadPreprocess, results='hide'}
```

The _standardized mortality ratio_ (SMR) is the ratio of the observed
number of deaths in the study population to the number that would be
expected if the study population experienced the same mortality as
the standard population. It is an indirectly standardized rate. When
studying disease incidence the corresponding quantity is called a
_standardized incidence ratio_ (SIR). These measures are typically
used when the entire study population is considered ‘exposed’.
Rather than following-up both the exposed study population and an
unexposed control population and comparing the two estimated rates
we instead only estimate the rate (or number of events) in the study
population and compare this to the expected rate (expected number
of events) for the standard population. For example, we might study
disease incidence or mortality among individuals with a certain
occupation (farmers, painters, airline cabin crew) or cancer
incidence in a cohort exposed to ionising radiation.

In the analysis of cancer patient survival we typically estimate
_excess mortality_ (observed - expected deaths). The
SMR (observed/expected deaths) is a measure of _relative
mortality_. The estimation of observed and expected numbers
of deaths are performed in an identical manner for each measure but
with the SMR we assume that the effect of exposure is multiplicative
to the baseline rate whereas with excess mortality we assume it
is additive. Which measure, relative mortality or excess mortality,
do you think is more homogeneous across age?

The following example illustrates the approach to estimating
SMRs/SIRs using R. Specifically, we will estimate SMRs for the
melanoma data using the general population mortality rates
stratified by age and calendar period (derived from
`popmort`) to estimate the expected number of deaths.
The expected mortality rates depend on current age and current year
so the approach is as follows:

1. Split follow-up into 1-year age bands
2. Split the resulting data into 1-year calendar period bands
3. For each age-period band, merge with <span>popmort.dta</span> to
        obtain the expected mortality rates
4. Sum the observed and expected numbers of deaths and calculate
        the SMR (observed/expected) and a 95% CI

## (a) ##

Start by splitting the follow-up into 1 year age bands. We do not have
a date of birth available, so we can make a mid-point
approximation for the age at diagnosis.

```{r 23.a1, results='hide'}
```

```{r 23.a2, results='hide'}
```

## (b) ##

Now split these new records into one year calendar period bands. 

```{r 23.b1, results='hide'}
```

```{r 23.b2, results='hide'}
```

## (c) ##

Descriptives: Each subject’s follow–up is now divided into small pieces
corresponding to the agebands and calendar periods the subject passes
through. We can make tables of deaths and person-years by age and
calendar period with

```{r 23.c1, results='hide'}
```

```{r 23.c2, results='hide'}
```

```{r 23.c3, results='hide'}
```

As the data have been split in one-year intervals on both time
scales the table created above is not so informative. Grouped
variables will provide a better overview.


## (d) ##

Descriptives: as the data have been split in 1-year intervals on both time scales in the table created above, this takes up a lot of space. Grouped variables will provide a better overview. To make a table of rates by age and calendar period, we can define group variables and use `survRate` as usually: 

```{r 23.d, results='hide'}
```

## (e) ##

To calculate the expected cases for a cohort, using reference
mortality rates classified by age and calendar period, it is
first necessary to merge the population rates with the
observed person-time.  Then the expected number of cases are
calculated by multiplying the follow-up time for each record
by the reference rate for that record. The SMR is the ratio of
the total observed cases to the total number expected.
		
First, calculate the total person time at risk and the observed number of deaths for each combination: 
```{r 23.e1, results='hide'}
```

This is the data set of reference rates: 
```{r 23.e2, results='hide'}
```

We now merge the observed person time and deaths (in the melanoma cohort) with the corresponding reference rates in the `popmort` data set:
```{r 23.e3, results='hide'}
```

The expected number of events (assuming the reference mortality rates in the general population) are simply: 
```{r 23.e4, results='hide'}
```

## (f) ##

Calculate the crude overall SMR, as well as the SMR by sex. Plot the SMRs by calendar year and age. 

We can calculate the SMR simply from the data, like so: 
```{r 23.f1, results='hide', fig.show='hide'}
```

By sex:
```{r 23.f2, results='hide', fig.show='hide'}
```

We can do the same by e.g. calendar year, but there it is easier to plot than show: 
```{r 23.f3, results='hide', fig.show='hide'}
```

For the ages, we have two many levels and too few events ot produce reliable estimates. We can either use splines or (simpler) define a grouping variable as above.
```{r 23.f4, results='hide', fig.show='hide'}
```

Note that we can use `survRate` to get confidence intervals:
```{r 23.f5, results='hide', fig.show='hide'}
```

## (g) ##

Model the SMR as a function of age, sex and calendar period.

We use the observed (nominator in SMR) as the outcome count and the log-expected count (denominator in SMR) as offset in the Poisson regression.

Let's prettify the data for the fit.
Here, a good choice of reference level for age & year makes a big difference
in how easy we can interpret the model parameters;

```{r 23.g1, results='hide', fig.show='hide'}
```

A simple analysis of deviance, which performs a likelihood ratio test for the hypothesis that removing a variable from the model does not improve model fit shows however that all predictors are statistically significantly associated with the SMR:
```{r 23.g2, results='hide', fig.show='hide'}
```

---
title: "Biostatistics III in R: Survival analysis for epidemiologists"
author:
- Annika Tillander, Johan Zetterqvist, Bénédicte Delcoigne, Xingrong Liu, Mark Clements and Andreas Karlsson.
output:
  prettydoc::html_pretty:
    theme: cayman
    highlight: github
---

# Installation instructions

Instructions are available [on-line](http://biostat3.net/download/R/labs/installation.html) and [off-line](labs/installation.html).


# Computing laboratory exercises (on-line)

 \#  Description                                                               Questions                                            R code                                         Solutions
---  ------------------------------------------------------------------------  ---------------------------------------------------  ---------------------------------------------  -------------------------------------------------------
 1   Life tables and Kaplan-Meier estimates                                    [Q1](http://biostat3.net/download/R/labs/q1.html)    [q1.R](http://biostat3.net/download/R/q1.R)    [S1](http://biostat3.net/download/R/solutions/q1.html)
 2   Comparing survival and rates by stage                                     [Q2](http://biostat3.net/download/R/labs/q2.html)    [q2.R](http://biostat3.net/download/R/q2.R)    [S2](http://biostat3.net/download/R/solutions/q2.html)
 3   Comparing survival graphically and using the log rank test                [Q3](http://biostat3.net/download/R/labs/q3.html)    [q3.R](http://biostat3.net/download/R/q3.R)    [S3](http://biostat3.net/download/R/solutions/q3.html)
 4   Comparing actuarial and Kaplan-Meier estimators                           [Q4](http://biostat3.net/download/R/labs/q4.html)    [q4.R](http://biostat3.net/download/R/q4.R)    [S4](http://biostat3.net/download/R/solutions/q4.html)
 6   Tabulating rates and modelling with Poisson regression                    [Q6](http://biostat3.net/download/R/labs/q6.html)    [q6.R](http://biostat3.net/download/R/q6.R)    [S6](http://biostat3.net/download/R/solutions/q6.html)
 7   Model cause-specific mortality with Poisson regression                    [Q7](http://biostat3.net/download/R/labs/q7.html)    [q7.R](http://biostat3.net/download/R/q7.R)    [S7](http://biostat3.net/download/R/solutions/q7.html)
 8   Poisson regression adjusting for confounders on different timescales      [Q8](http://biostat3.net/download/R/labs/q8.html)    [q8.R](http://biostat3.net/download/R/q8.R)    [S8](http://biostat3.net/download/R/solutions/q8.html)
 9   Modelling cause-specific mortality using Cox regression                   [Q9](http://biostat3.net/download/R/labs/q9.html)    [q9.R](http://biostat3.net/download/R/q9.R)    [S9](http://biostat3.net/download/R/solutions/q9.html)
 10  Examining the proportional hazards hypothesis                             [Q10](http://biostat3.net/download/R/labs/q10.html)  [q10.R](http://biostat3.net/download/R/q10.R)  [S10](http://biostat3.net/download/R/solutions/q10.html)
 11  Cox regression with all-cause mortality as the outcome                    [Q11](http://biostat3.net/download/R/labs/q11.html)  [q11.R](http://biostat3.net/download/R/q11.R)  [S11](http://biostat3.net/download/R/solutions/q11.html)
 12  Cox model for cause-specific mortality for melanoma                       [Q12](http://biostat3.net/download/R/labs/q12.html)  [q12.R](http://biostat3.net/download/R/q12.R)  [S12](http://biostat3.net/download/R/solutions/q12.html)
 13  Modelling the diet data using Cox regression                              [Q13](http://biostat3.net/download/R/labs/q13.html)  [q13.R](http://biostat3.net/download/R/q13.R)  [S13](http://biostat3.net/download/R/solutions/q13.html)
 14  Non-collapsibility of proportional hazards models                         [Q14](http://biostat3.net/download/R/labs/q14.html)  [q14.R](http://biostat3.net/download/R/q14.R)  [S14](http://biostat3.net/download/R/solutions/q14.html)
 22  Time-varying exposures and the bereavement data                           [Q22](http://biostat3.net/download/R/labs/q22.html)  [q22.R](http://biostat3.net/download/R/q22.R)  [S22](http://biostat3.net/download/R/solutions/q22.html)
 23  Calculating SMRs/SIRs                                                     [Q23](http://biostat3.net/download/R/labs/q23.html)  [q23.R](http://biostat3.net/download/R/q23.R)  [S23](http://biostat3.net/download/R/solutions/q23.html)
 25  Generating and analysing a nested case-control (NCC) study                [Q25](http://biostat3.net/download/R/labs/q25.html)  [q25.R](http://biostat3.net/download/R/q25.R)  [S25](http://biostat3.net/download/R/solutions/q25.html)
 28  Flexible parametric survival models in R                                  [Q28](http://biostat3.net/download/R/labs/q28.html)  [q28.R](http://biostat3.net/download/R/q28.R)  [S28](http://biostat3.net/download/R/solutions/q28.html)
------


## Computing laboratory exercises (off-line)

 \#  Description                                                               Questions             R code          Solutions
---  ------------------------------------------------------------------------  --------------------  --------------  -------------------------
 1   Life tables and Kaplan-Meier estimates                                    [Q1](labs/q1.html)    [q1.R](q1.R)    [S1](solutions/q1.html)
 2   Comparing survival and rates by stage                                     [Q2](labs/q2.html)    [q2.R](q2.R)    [S2](solutions/q2.html)
 3   Comparing survival graphically and using the log rank test                [Q3](labs/q3.html)    [q3.R](q3.R)    [S3](solutions/q3.html)
 4   Comparing actuarial and Kaplan-Meier estimators                           [Q4](labs/q4.html)    [q4.R](q4.R)    [S4](solutions/q4.html)
 6   Tabulating rates and modelling with Poisson regression                    [Q6](labs/q6.html)    [q6.R](q6.R)    [S6](solutions/q6.html)
 7   Model cause-specific mortality with Poisson regression                    [Q7](labs/q7.html)    [q7.R](q7.R)    [S7](solutions/q7.html)
 8   Poisson regression adjusting for confounders on different timescales      [Q8](labs/q8.html)    [q8.R](q8.R)    [S8](solutions/q8.html)
 9   Modelling cause-specific mortality using Cox regression                   [Q9](labs/q9.html)    [q9.R](q9.R)    [S9](solutions/q9.html)
 10  Examining the proportional hazards hypothesis                             [Q10](labs/q10.html)  [q10.R](q10.R)  [S10](solutions/q10.html)
 11  Cox regression with all-cause mortality as the outcome                    [Q11](labs/q11.html)  [q11.R](q11.R)  [S11](solutions/q11.html)
 12  Cox model for cause-specific mortality for melanoma                       [Q12](labs/q12.html)  [q12.R](q12.R)  [S12](solutions/q12.html)
 13  Modelling the diet data using Cox regression                              [Q13](labs/q13.html)  [q13.R](q13.R)  [S13](solutions/q13.html)
 14  Non-collapsibility of proportional hazards models                         [Q14](labs/q14.html)  [q14.R](q14.R)  [S14](solutions/q14.html)
 22  Time-varying exposures and the bereavement data                           [Q22](labs/q22.html)  [q22.R](q22.R)  [S22](solutions/q22.html)
 23  Calculating SMRs/SIRs                                                     [Q23](labs/q23.html)  [q23.R](q23.R)  [S23](solutions/q23.html)
 25  Generating and analysing a nested case-control (NCC) study                [Q25](labs/q25.html)  [q25.R](q25.R)  [S25](solutions/q25.html)
 28  Flexible parametric survival models in R                                  [Q28](labs/q28.html)  [q28.R](q28.R)  [S28](solutions/q28.html)
------

---
title: "Biostatistics III in R"
author:
- Code by Andreas Karlsson and Mark Clements
output:
  prettydoc::html_pretty:
    theme: cayman
    highlight: github
---

# Cox model for cause-specific mortality for melanoma (all stages) #


Use Cox regression to model the cause-specific survival of patients with skin melanoma (including all stages).

-----------


```{r setup, cache=FALSE, message=FALSE, echo=FALSE}
library('knitr')
read_chunk('../q12.R')
opts_chunk$set(cache=FALSE)
```

You may have to install the required packages the first time you use them. You can install a package by `install.packages("package_of_interest")` for each package you require.

```{r loadDependencies, message=FALSE}
```
Load the melanoma data and explore it.

```{r loadPreprocess, results='hide'}
```

## (a) ## 
First fit the model with sex as the only explanatory variable. Does there appear to be a difference in survival between males and females?


```{r 12.a, warning=FALSE, message=FALSE, results='hide'}
```

## (b) ## 
Is the effect of sex confounded by other factors (e.g. age, stage, subsite, period)? After controlling for potential confounders, does there still appear to a difference in survival between males and females?

```{r 12.b, warning=FALSE, message=FALSE, results='hide'}
```

## (c) ## 
Consider the hypothesis that there exists a class of melanomas where female sex hormones play a large role in the etiology. These hormone related cancers are diagnosed primarily in women and are, on average, less aggressive (i.e., prognosis is good). If such a hypothesis were true we might expect the effect of sex to be modified by age at diagnosis (e.g., pre versus post menopausal). Test whether this is the case.

```{r 12.c, warning=FALSE, message=FALSE, results='hide'}
```

## (d) ## 
Decide on a ‘most appropriate’ model for these data. Be sure to evaluate the proportional hazards assumption.


```{r 12.d.i, warning=FALSE, message=FALSE, results='hide'}
```

```{r 12.d.ii, warning=FALSE, message=FALSE, results='hide'}
```

```{r 12.d.iii, warning=FALSE, message=FALSE, results='hide'}
```

---
title: "Biostatistics III in R"
author:
- Code by Annika Tillander, Andreas Karlsson and Mark Clements
output:
  prettydoc::html_pretty:
    mathjax: https://biostat3.net/js/mathjax/tex-chtml.js
    theme: cayman
    highlight: github
---

# Exercise 1: Life tables and Kaplan-Meier estimates of survival #

```{r setup, cache=FALSE, message=FALSE, echo=FALSE}
library('knitr')
read_chunk('../q1.R')
opts_chunk$set(cache=FALSE, fig.width=7, fig.height=6)
options(width=90)
```

## (a) Hand calculation: Life table and Kaplan-Meier estimates of survival ##

The results are contained in an [Excel file](exercise1.xls) and are also shown in the R
    output below.

## (b) Using R to validate the hand calculations done in part 1 (a) ##

First, load the `biostat3` library for the dataset , `survminer` for plots and `knitr` for nice html output:

```{r loadDependencies, message=FALSE}
```

Following are the life table estimates. Note that in the lectures,
when we estimated all-cause survival, there were 8 deaths in the
first interval. One of these died of a cause other than cancer so in
the cause-specific survival analysis we see that there are 7
‘deaths’ and 1 censoring (Stata uses the term ‘lost’ for lost
to follow-up) in the first interval.

```{r lifeTable, results='asis'}
```

Following is a table of Kaplan-Meier estimates. Although it’s not
    clear from the table, the person censored (lost) at time 2 was at
    risk when the other person dies at time 2. On the following is
    a graph of the survival function.

```{r KaplanMeier}
```

---
title: "Biostatistics III in R"
author:
- Code by Annika Tillander, Andreas Karlsson and Mark Clements
format:
  html:
    minimal: true
filters:
  - webr
execute:
  echo: true
  message: false
  cache: false
  fig-width: 7
  fig-height: 6
---


# Exercise 2. Comparing survival proportions and mortality rates by stage for cause-specific and all-cause survival #
	
The purpose of this exercise is to study survival of the patients
using two alternative measures --- survival proportions and
mortality rates. A second purpose is to study the difference between
cause-specific and all-cause survival.

You may have to install the required packages the first time you use them. You can install a package by `install.packages("package_of_interest")` for each package you require.

Load dependencies and define two 1/0 variables for the events that we are interested in:

```{webr-r}
#| autorun: true
#| results: "hide"
library(biostat3) # melanoma (depends on survival)
library(bshazard) # bshazard
library(knitr)    # kable
as.data.frame.bshazard <- function(x, ...)
    with(x, data.frame(time,hazard,lower.ci,upper.ci))
melanoma <- 
    transform(biostat3::melanoma,
              death_cancer = ifelse(status == "Dead: cancer", 1, 0),
              death_all = ifelse(status %in% c("Dead: cancer", "Dead: other"), 1, 0))
```

We then list the first few observations to get an idea about the data.

```{webr-r}
#| results: 'asis'
head(biostat3::melanoma) |> knitr::kable("html")
```

## (a) Plot estimates of the survivor function and hazard function by stage ##

We now tabulate the distribution of the melanoma patients by cancer stage at diagnosis.

```{webr-r}
#| results: 'asis'
Freq <- xtabs(~stage, data=melanoma)
cbind(Freq, Prop=proportions(Freq)) |> kable("html")
```

We then plot the survival and hazards by stage. Does it appear that stage is associated with patient survival?

```{webr-r}
library(dplyr)
hazards <- group_by(melanoma, stage) |> 
    do(as.data.frame(bshazard(Surv(surv_mm/12, death_cancer)~1, data=., verbose=FALSE))) |>
    ungroup()
with(hazards, plt(hazard~time|stage, ymin=lower.ci, ymax=upper.ci,
                  type="ribbon",
                  xlab="Time since diagnosis (years)",
                  ylab="Hazard",
                  col=1:4, lty=1, xlim=c(0,20), ylim=0:1))
```


## (b) Estimate the mortality rates for each stage using, for example, the `survRate` command ##

```{webr-r}
#| results: "asis"
survRate(Surv(surv_mm/12, death_cancer) ~ stage, data=melanoma) |> kable("html")
```

What are the units of the estimated rates? The `survRate` function, as the name suggests, is used to estimates rates. Look at the help pages if you are not familiar with the function (e.g. `?survRate` or `help(survRate)`).


We can also do this using more general tools:

```{webr-r}
#| results: "asis"
library(dplyr)
melanoma |>
    group_by(stage) |>
    summarise(D = sum(death_cancer), M = sum(surv_mm/12), Rate = D/M,
              lower.ci = stats::poisson.test(D,M)$conf.int[1],
              upper.ci = stats::poisson.test(D,M)$conf.int[2]) |>
    kable("html")
```

## (c) ##
If you haven’t already done so, estimate the mortality rates for each stage per 1000 person-years of follow-up.

```{webr-r}
#| results: "asis"
survRate(Surv(surv_mm/12/1000, death_cancer) ~ stage, data=melanoma) |> kable("html")
```

## (d) ##

Study whether survival is different for males and females (both by plotting the survivor function and by tabulating mortality rates). Is there a difference in survival between males and females? If yes, is the difference present throughout the follow up?

```{webr-r}
library(dplyr) # slow:(
library(tinyplot) # fast:)
library(ggplot2) # slow:(
hazards <- group_by(melanoma, sex) |>
    do(as.data.frame(bshazard(Surv(surv_mm/12, death_cancer)~1, data=., verbose=FALSE))) |>
    ungroup()
with(hazards,
     plt(hazard~time|sex,ymin=lower.ci, ymax=upper.ci,type="ribbon",
         xlab='Follow-up Time', ylab='Hazard'))
ggplot(hazards,aes(x=time,y=hazard,group=sex)) + geom_line(aes(col=sex)) +
    geom_ribbon(aes(ymin=lower.ci, ymax=upper.ci, fill=sex), alpha=0.3) + ylim(0,0.01) +
    xlab('Follow-up Time') + ylab('Hazard')
```

## (e) ##

The plots you made above were based on cause-specific survival
(i.e., only deaths due to cancer are counted as events, deaths
due to other causes are censored). In the next part of this
question we will estimate all-cause survival (i.e., any death is
counted as an event). First, however, study the coding of vital
status and tabulate vital status by age group.

How many patients die of each cause? Does the distribution of
cause of death depend on age?


```{webr-r}
Freq <- xtabs(~status+agegrp, melanoma)
Freq
# proportions for status by agegrp
round(proportions(Freq,"agegrp")*100,1)
chisq.test(Freq[-4,])
```

## (f) ##

To get all-cause survival, specify all deaths (both cancer
and other) as events.

Now plot the survivor proportion for all-cause survival
by stage. Is the survivor proportion different compared to
the cause-specific survival you estimated above? Why?

```{webr-r}
par(mfrow=c(1, 1))
afit <- survfit(Surv(surv_mm/12, death_all) ~ stage, data = melanoma)
plot(afit, col=1:4,
     xlab = "Time since diagnosis (years)",
     ylab = "Survival",
     main = "Kaplan-Meier survival estimates\nAll-cause")
legend("topright", levels(melanoma$stage), col=1:4, lty = 1)
```

## (g) ##

It is more common to die from a cause other than cancer in
older ages. How does this impact the survivor proportion for
different stages? Compare cause-specific and all-cause survival
by plotting the survivor proportion by stage for the oldest age
group (75+ years) for both cause-specific and
all-cause survival.

```{webr-r}
par(mfrow=c(1, 2))
mfit75 <- survfit(Surv(surv_mm/12, death_cancer) ~ stage, data = subset(melanoma,agegrp=="75+"))
plot(mfit75, col=1:4,
     xlab = "Since since diagnosis (years)",
     ylab = "Survival",
     main = "Kaplan-Meier survival estimates\nCancer | Age 75+")
legend("topright", levels(melanoma$stage), col=1:4, lty = 1)

afit75 <- survfit(Surv(surv_mm/12, death_all) ~ stage, data = subset(melanoma,agegrp=="75+"))
plot(afit75, col=1:4,
     xlab = "Time since diagnosis (years)",
     ylab = "Survival",
     main = "Kaplan-Meier survival estimates\nAll-cause | Age 75+")
legend("topright", levels(melanoma$stage), col=1:4, lty = 1)
```

## (h) ##

Now estimate both cancer-specific and all-cause survival for
        each age group.


```{web-r}
par(mfrow=c(1, 2))
survfit(Surv(surv_mm/12, death_cancer) ~ agegrp, data = melanoma) |>
	plot(col=1:4,
         xlab = "Time since diagnosis (years)",
         ylab = "Survival",
         main = "Kaplan-Meier estimates of\ncancer survival by age group")
legend("topright", levels(melanoma$agegrp), col=1:4, lty = 1)

survfit(Surv(surv_mm/12, death_all) ~ agegrp, data = melanoma) |>
    plot(col=1:4,
         xlab = "Time since diagnosis (years)",
         ylab = "Survival",
         main = "Kaplan-Meier estimates of\nall-cause survival by age group")
legend("topright", levels(melanoma$agegrp), col=1:4, lty = 1)
```
